searchNodes=[{"doc":"The top-level module of RDF.ex. RDF.ex consists of: modules for the nodes of an RDF graph RDF.Term RDF.IRI RDF.BlankNode RDF.Literal the RDF.Literal.Datatype system a facility for the mapping of URIs of a vocabulary to Elixir modules and functions: RDF.Vocabulary.Namespace a facility for the automatic generation of resource identifiers: RDF.Resource.Generator modules for the construction of statements RDF.Triple RDF.Quad RDF.Statement modules for collections of statements RDF.Description RDF.Graph RDF.Dataset RDF.Data RDF.List RDF.Diff functions to construct and execute basic graph pattern queries: RDF.Query functions for working with RDF serializations: RDF.Serialization behaviours for the definition of RDF serialization formats RDF.Serialization.Format RDF.Serialization.Decoder RDF.Serialization.Encoder and the implementation of various RDF serialization formats RDF.NTriples RDF.NQuads RDF.Turtle This top-level module provides shortcut functions for the construction of the basic elements and structures of RDF and some general helper functions. For a general introduction you may refer to the guides on the homepage .","ref":"RDF.html","title":"RDF","type":"module"},{"doc":"See RDF.NS.RDF.nil/0 .","ref":"RDF.html#/0","title":"RDF./0","type":"function"},{"doc":"See RDF.BlankNode.new/0 .","ref":"RDF.html#bnode/0","title":"RDF.bnode/0","type":"function"},{"doc":"See RDF.BlankNode.new/1 .","ref":"RDF.html#bnode/1","title":"RDF.bnode/1","type":"function"},{"doc":"Checks if the given value is a blank node. Examples iex&gt; RDF . bnode? ( RDF . bnode ) true iex&gt; RDF . bnode? ( RDF . iri ( &quot;http://example.com/resource&quot; ) ) false iex&gt; RDF . bnode? ( 42 ) false","ref":"RDF.html#bnode?/1","title":"RDF.bnode?/1","type":"function"},{"doc":"See RDF.Star.Statement.coerce_graph_name/1 .","ref":"RDF.html#coerce_graph_name/1","title":"RDF.coerce_graph_name/1","type":"function"},{"doc":"See RDF.Star.Statement.coerce_object/2 .","ref":"RDF.html#coerce_object/2","title":"RDF.coerce_object/2","type":"function"},{"doc":"See RDF.Star.Statement.coerce_predicate/1 .","ref":"RDF.html#coerce_predicate/1","title":"RDF.coerce_predicate/1","type":"function"},{"doc":"See RDF.Star.Statement.coerce_predicate/2 .","ref":"RDF.html#coerce_predicate/2","title":"RDF.coerce_predicate/2","type":"function"},{"doc":"See RDF.Star.Statement.coerce_subject/2 .","ref":"RDF.html#coerce_subject/2","title":"RDF.coerce_subject/2","type":"function"},{"doc":"See RDF.Dataset.new/0 .","ref":"RDF.html#dataset/0","title":"RDF.dataset/0","type":"function"},{"doc":"See RDF.Dataset.new/1 .","ref":"RDF.html#dataset/1","title":"RDF.dataset/1","type":"function"},{"doc":"See RDF.Dataset.new/2 .","ref":"RDF.html#dataset/2","title":"RDF.dataset/2","type":"function"},{"doc":"See RDF.IRI.default_base/0 .","ref":"RDF.html#default_base_iri/0","title":"RDF.default_base_iri/0","type":"function"},{"doc":"A user-defined RDF.PrefixMap of prefixes to IRI namespaces. This prefix map will be used implicitly wherever a prefix map is expected, but not provided. For example, when you don't pass a prefix map to the Turtle serializer, this prefix map will be used. By default the standard_prefixes/0 are part of this prefix map, but you can define additional default prefixes via the default_prefixes compile-time configuration. For example: config :rdf , default_prefixes : %{ ex : &quot;http://example.com/&quot; } You can also set :default_prefixes to a module-function tuple {mod, fun} with a function which should be called to determine the default prefixes. If you don't want the standard_prefixes/0 to be part of the default prefixes, or you want to map the standard prefixes to different namespaces (strongly discouraged!), you can set the use_standard_prefixes compile-time configuration flag to false . config :rdf , use_standard_prefixes : false","ref":"RDF.html#default_prefixes/0","title":"RDF.default_prefixes/0","type":"function"},{"doc":"Returns the default_prefixes/0 with additional prefix mappings. The prefix_mappings can be given in any format accepted by RDF.PrefixMap.new/1 .","ref":"RDF.html#default_prefixes/1","title":"RDF.default_prefixes/1","type":"function"},{"doc":"See RDF.Description.new/2 .","ref":"RDF.html#description/2","title":"RDF.description/2","type":"function"},{"doc":"See RDF.Diff.diff/2 .","ref":"RDF.html#diff/2","title":"RDF.diff/2","type":"function"},{"doc":"See RDF.NS.RDF.first/0 .","ref":"RDF.html#first/0","title":"RDF.first/0","type":"function"},{"doc":"See RDF.Graph.new/0 .","ref":"RDF.html#graph/0","title":"RDF.graph/0","type":"function"},{"doc":"See RDF.Graph.new/1 .","ref":"RDF.html#graph/1","title":"RDF.graph/1","type":"function"},{"doc":"See RDF.Graph.new/2 .","ref":"RDF.html#graph/2","title":"RDF.graph/2","type":"function"},{"doc":"See RDF.IRI.new!/1 .","ref":"RDF.html#iri!/1","title":"RDF.iri!/1","type":"function"},{"doc":"See RDF.IRI.new/1 .","ref":"RDF.html#iri/1","title":"RDF.iri/1","type":"function"},{"doc":"See RDF.IRI.valid?/1 .","ref":"RDF.html#iri?/1","title":"RDF.iri?/1","type":"function"},{"doc":"See RDF.NS.RDF.langString/0 .","ref":"RDF.html#lang_string/0","title":"RDF.lang_string/0","type":"function"},{"doc":"See RDF.LangString.new/2 .","ref":"RDF.html#lang_string/2","title":"RDF.lang_string/2","type":"function"},{"doc":"See RDF.NS.RDF.langString/0 .","ref":"RDF.html#langString/0","title":"RDF.langString/0","type":"function"},{"doc":"See RDF.LangString.new/2 .","ref":"RDF.html#langString/2","title":"RDF.langString/2","type":"function"},{"doc":"","ref":"RDF.html#list/1","title":"RDF.list/1","type":"function"},{"doc":"","ref":"RDF.html#list/2","title":"RDF.list/2","type":"function"},{"doc":"See RDF.List.node?/1 .","ref":"RDF.html#list?/1","title":"RDF.list?/1","type":"function"},{"doc":"See RDF.List.node?/2 .","ref":"RDF.html#list?/2","title":"RDF.list?/2","type":"function"},{"doc":"See RDF.Literal.new/1 .","ref":"RDF.html#literal/1","title":"RDF.literal/1","type":"function"},{"doc":"See RDF.Literal.new/2 .","ref":"RDF.html#literal/2","title":"RDF.literal/2","type":"function"},{"doc":"Checks if the given value is a RDF literal.","ref":"RDF.html#literal?/1","title":"RDF.literal?/1","type":"function"},{"doc":"See RDF.NS.RDF.object/0 .","ref":"RDF.html#object/0","title":"RDF.object/0","type":"function"},{"doc":"See RDF.NS.RDF.predicate/0 .","ref":"RDF.html#predicate/0","title":"RDF.predicate/0","type":"function"},{"doc":"See RDF.PrefixMap.new/1 .","ref":"RDF.html#prefix_map/1","title":"RDF.prefix_map/1","type":"function"},{"doc":"See RDF.PropertyMap.new/1 .","ref":"RDF.html#property_map/1","title":"RDF.property_map/1","type":"function"},{"doc":"See RDF.Star.Quad.new/2 .","ref":"RDF.html#quad/2","title":"RDF.quad/2","type":"function"},{"doc":"See RDF.Star.Quad.new/5 .","ref":"RDF.html#quad/5","title":"RDF.quad/5","type":"function"},{"doc":"See RDF.Serialization.read_file!/2 .","ref":"RDF.html#read_file!/2","title":"RDF.read_file!/2","type":"function"},{"doc":"See RDF.Serialization.read_file/2 .","ref":"RDF.html#read_file/2","title":"RDF.read_file/2","type":"function"},{"doc":"See RDF.Serialization.read_stream!/2 .","ref":"RDF.html#read_stream!/2","title":"RDF.read_stream!/2","type":"function"},{"doc":"See RDF.Serialization.read_stream/2 .","ref":"RDF.html#read_stream/2","title":"RDF.read_stream/2","type":"function"},{"doc":"See RDF.Serialization.read_string!/2 .","ref":"RDF.html#read_string!/2","title":"RDF.read_string!/2","type":"function"},{"doc":"See RDF.Serialization.read_string/2 .","ref":"RDF.html#read_string/2","title":"RDF.read_string/2","type":"function"},{"doc":"Checks if the given value is a RDF resource. Examples Supposed EX is a RDF.Vocabulary.Namespace and Foo is not. iex&gt; RDF . resource? ( RDF . iri ( &quot;http://example.com/resource&quot; ) ) true iex&gt; RDF . resource? ( EX . resource ) true iex&gt; RDF . resource? ( EX.Resource ) true iex&gt; RDF . resource? ( Foo.Resource ) false iex&gt; RDF . resource? ( RDF . bnode ) true iex&gt; RDF . resource? ( RDF.XSD . integer ( 42 ) ) false iex&gt; RDF . resource? ( 42 ) false","ref":"RDF.html#resource?/1","title":"RDF.resource?/1","type":"function"},{"doc":"See RDF.NS.RDF.rest/0 .","ref":"RDF.html#rest/0","title":"RDF.rest/0","type":"function"},{"doc":"A fixed set prefixes that will always be part of the default_prefixes/0 . % RDF.PrefixMap { rdf : ~I&lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; , rdfs : ~I&lt;http://www.w3.org/2000/01/rdf-schema#&gt; , xsd : ~I&lt;http://www.w3.org/2001/XMLSchema#&gt; } See default_prefixes/0 , if you don't want these standard prefixes to be part of the default prefixes.","ref":"RDF.html#standard_prefixes/0","title":"RDF.standard_prefixes/0","type":"function"},{"doc":"Returns whether RDF-star support is enabled.","ref":"RDF.html#star?/0","title":"RDF.star?/0","type":"function"},{"doc":"See RDF.Star.Statement.new/2 .","ref":"RDF.html#statement/2","title":"RDF.statement/2","type":"function"},{"doc":"See RDF.Star.Statement.new/3 .","ref":"RDF.html#statement/3","title":"RDF.statement/3","type":"function"},{"doc":"See RDF.Star.Statement.new/4 .","ref":"RDF.html#statement/4","title":"RDF.statement/4","type":"function"},{"doc":"See RDF.NS.RDF.subject/0 .","ref":"RDF.html#subject/0","title":"RDF.subject/0","type":"function"},{"doc":"Checks if the given value is a RDF term. Examples Supposed EX is a RDF.Vocabulary.Namespace and Foo is not. iex&gt; RDF . term? ( RDF . iri ( &quot;http://example.com/resource&quot; ) ) true iex&gt; RDF . term? ( EX . resource ) true iex&gt; RDF . term? ( EX.Resource ) true iex&gt; RDF . term? ( Foo.Resource ) false iex&gt; RDF . term? ( RDF . bnode ) true iex&gt; RDF . term? ( RDF.XSD . integer ( 42 ) ) true iex&gt; RDF . term? ( 42 ) false","ref":"RDF.html#term?/1","title":"RDF.term?/1","type":"function"},{"doc":"See RDF.Star.Triple.new/2 .","ref":"RDF.html#triple/2","title":"RDF.triple/2","type":"function"},{"doc":"See RDF.Star.Triple.new/4 .","ref":"RDF.html#triple/4","title":"RDF.triple/4","type":"function"},{"doc":"See RDF.NS.RDF.type/0 .","ref":"RDF.html#type/0","title":"RDF.type/0","type":"function"},{"doc":"See RDF.IRI.new!/1 .","ref":"RDF.html#uri!/1","title":"RDF.uri!/1","type":"function"},{"doc":"See RDF.IRI.new/1 .","ref":"RDF.html#uri/1","title":"RDF.uri/1","type":"function"},{"doc":"See RDF.IRI.valid?/1 .","ref":"RDF.html#uri?/1","title":"RDF.uri?/1","type":"function"},{"doc":"See RDF.NS.RDF.value/0 .","ref":"RDF.html#value/0","title":"RDF.value/0","type":"function"},{"doc":"See RDF.Serialization.write_file!/3 .","ref":"RDF.html#write_file!/3","title":"RDF.write_file!/3","type":"function"},{"doc":"See RDF.Serialization.write_file/3 .","ref":"RDF.html#write_file/3","title":"RDF.write_file/3","type":"function"},{"doc":"See RDF.Serialization.write_stream/2 .","ref":"RDF.html#write_stream/2","title":"RDF.write_stream/2","type":"function"},{"doc":"See RDF.Serialization.write_string!/2 .","ref":"RDF.html#write_string!/2","title":"RDF.write_string!/2","type":"function"},{"doc":"See RDF.Serialization.write_string/2 .","ref":"RDF.html#write_string/2","title":"RDF.write_string/2","type":"function"},{"doc":"An RDF blank node (aka bnode) is a local node of a graph without an IRI. This module can also be used as RDF.Resource.Generator for the generation of random identifiers, which is using the new/0 function. For the generation of value-based blank nodes, you can use RDF.BlankNode.Generator . see https://www.w3.org/TR/rdf11-primer/#section-blank-node and https://www.w3.org/TR/rdf11-concepts/#section-blank-nodes","ref":"RDF.BlankNode.html","title":"RDF.BlankNode","type":"module"},{"doc":"Tests for value equality of blank nodes. Returns nil when the given arguments are not comparable as blank nodes.","ref":"RDF.BlankNode.html#equal_value?/2","title":"RDF.BlankNode.equal_value?/2","type":"function"},{"doc":"Creates a random RDF.BlankNode .","ref":"RDF.BlankNode.html#new/0","title":"RDF.BlankNode.new/0","type":"function"},{"doc":"Creates a RDF.BlankNode with a user-defined value for its identity. Examples iex&gt; RDF . bnode ( :foo ) % RDF.BlankNode { value : &quot;foo&quot; }","ref":"RDF.BlankNode.html#new/1","title":"RDF.BlankNode.new/1","type":"function"},{"doc":"Returns the internal string representation of a blank node.","ref":"RDF.BlankNode.html#value/1","title":"RDF.BlankNode.value/1","type":"function"},{"doc":"","ref":"RDF.BlankNode.html#t:t/0","title":"RDF.BlankNode.t/0","type":"type"},{"doc":"A GenServer which generates RDF.BlankNode s using a RDF.BlankNode.Generator.Algorithm . This module implements the RDF.Resource.Generator behaviour. The only RDF.Resource.Generator configuration it requires is the process identifier. The actual configuration of the behaviour of this generator is done on the GenServer itself via start_link/1 and start/1 .","ref":"RDF.BlankNode.Generator.html","title":"RDF.BlankNode.Generator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"RDF.BlankNode.Generator.html#child_spec/1","title":"RDF.BlankNode.Generator.child_spec/1","type":"function"},{"doc":"Generates a new blank node according to the RDF.BlankNode.Generator.Algorithm set up.","ref":"RDF.BlankNode.Generator.html#generate/1","title":"RDF.BlankNode.Generator.generate/1","type":"function"},{"doc":"Generates a blank node for a given value according to the RDF.BlankNode.Generator.Algorithm set up.","ref":"RDF.BlankNode.Generator.html#generate_for/2","title":"RDF.BlankNode.Generator.generate_for/2","type":"function"},{"doc":"Starts a blank node generator process without links (outside of a supervision tree). The options are handled the same as start_link/1 .","ref":"RDF.BlankNode.Generator.html#start/1","title":"RDF.BlankNode.Generator.start/1","type":"function"},{"doc":"Starts a blank node generator linked to the current process. The RDF.BlankNode.Generator.Algorithm implementation is the only required keyword option, which must be given with the :algorithm key or, if no other options are required, can be given directly (instead of a keyword list). The remaining options are used as the configuration for init/1 of the respective RDF.BlankNode.Generator.Algorithm implementation. If you want to pass GenServer.start_link/3 options, you'll can provide two separate keyword lists as a tuple with the first being the RDF.BlankNode.Generator configuration and the second the GenServer.start_link/3 options.","ref":"RDF.BlankNode.Generator.html#start_link/1","title":"RDF.BlankNode.Generator.start_link/1","type":"function"},{"doc":"Synchronously stops the blank node generator with the given reason . It returns :ok if the agent terminates with the given reason. If the agent terminates with another reason, the call will exit. This function keeps OTP semantics regarding error reporting. If the reason is any other than :normal , :shutdown or {:shutdown, _} , an error report will be logged.","ref":"RDF.BlankNode.Generator.html#stop/3","title":"RDF.BlankNode.Generator.stop/3","type":"function"},{"doc":"A behaviour for implementations of blank node identifier generation algorithms. The RDF.BlankNode.Generator executes such an algorithm and holds its state.","ref":"RDF.BlankNode.Generator.Algorithm.html","title":"RDF.BlankNode.Generator.Algorithm","type":"behaviour"},{"doc":"Generates a blank node. An implementation should compute a blank node from the given state and return a tuple consisting of the generated blank node and the new state.","ref":"RDF.BlankNode.Generator.Algorithm.html#c:generate/1","title":"RDF.BlankNode.Generator.Algorithm.generate/1","type":"callback"},{"doc":"Generates a blank node for a given string. Every call with the same string must return the same blank node. An implementation should compute a blank node for the given string from the given state and return a tuple consisting of the generated blank node and the new state.","ref":"RDF.BlankNode.Generator.Algorithm.html#c:generate_for/2","title":"RDF.BlankNode.Generator.Algorithm.generate_for/2","type":"callback"},{"doc":"Returns the initial state of the algorithm.","ref":"RDF.BlankNode.Generator.Algorithm.html#c:init/1","title":"RDF.BlankNode.Generator.Algorithm.init/1","type":"callback"},{"doc":"An implementation of a RDF.BlankNode.Generator.Algorithm which returns RDF.BlankNode s with incremented identifiers. The following options are supported when starting a RDF.BlankNode.Generator with this algorithm: prefix : a string prepended to the generated blank node identifier start_value : the number from which the incremented counter starts","ref":"RDF.BlankNode.Increment.html","title":"RDF.BlankNode.Increment","type":"module"},{"doc":"","ref":"RDF.BlankNode.Increment.html#t:state/0","title":"RDF.BlankNode.Increment.state/0","type":"type"},{"doc":"An abstraction over the different data structures for collections of RDF statements.","ref":"RDF.Data.html","title":"RDF.Data","type":"protocol"},{"doc":"Deletes statements from a RDF data structure. As opposed to the delete functions on RDF data structures directly, this function only deletes exactly matching structures.","ref":"RDF.Data.html#delete/3","title":"RDF.Data.delete/3","type":"function"},{"doc":"Checks if a RDF data structure contains statements about the given resource.","ref":"RDF.Data.html#describes?/2","title":"RDF.Data.describes?/2","type":"function"},{"doc":"Returns a RDF.Description of the given subject. Note: On a RDF.Dataset this will return an aggregated RDF.Description with the statements about this subject from all graphs.","ref":"RDF.Data.html#description/2","title":"RDF.Data.description/2","type":"function"},{"doc":"Returns all RDF.Description s within a RDF data structure. Note: On a RDF.Dataset this will return aggregated RDF.Description s about the same subject from all graphs.","ref":"RDF.Data.html#descriptions/1","title":"RDF.Data.descriptions/1","type":"function"},{"doc":"Returns if the given RDF data structure is empty.","ref":"RDF.Data.html#empty?/1","title":"RDF.Data.empty?/1","type":"function"},{"doc":"Checks if two RDF data structures are equal. Two RDF data structures are considered to be equal if they contain the same triples. comparing two RDF.Description s it's just the same as RDF.Description.equal?/2 comparing two RDF.Graph s differs in RDF.Graph.equal?/2 in that the graph name is ignored comparing two RDF.Dataset s differs in RDF.Dataset.equal?/2 in that the dataset name is ignored a RDF.Description is equal to a RDF.Graph , if the graph has just one description which equals the given description a RDF.Description is equal to a RDF.Dataset , if the dataset has just one graph which contains only the given description a RDF.Graph is equal to a RDF.Dataset , if the dataset has just one graph which equals the given graph; note that in this case the graph names must match","ref":"RDF.Data.html#equal?/2","title":"RDF.Data.equal?/2","type":"function"},{"doc":"Checks if the given statement exists within a RDF data structure.","ref":"RDF.Data.html#include?/3","title":"RDF.Data.include?/3","type":"function"},{"doc":"Returns a map representation of a RDF data structure where each element from its statements is mapped with the given function.","ref":"RDF.Data.html#map/2","title":"RDF.Data.map/2","type":"function"},{"doc":"Adds statements to a RDF data structure. As opposed to the specific add functions on the RDF data structures, which always return the same structure type than the first argument, merge might result in another RDF data structure, eg. merging two RDF.Description with different subjects results in a RDF.Graph or adding a quad to a RDF.Graph with a different name than the graph context of the quad results in a RDF.Dataset . But it is always guaranteed that the resulting structure has a RDF.Data implementation.","ref":"RDF.Data.html#merge/3","title":"RDF.Data.merge/3","type":"function"},{"doc":"Returns the set of all resources used in the objects within the statements of a RDF data structure.","ref":"RDF.Data.html#objects/1","title":"RDF.Data.objects/1","type":"function"},{"doc":"Deletes one statement from a RDF data structure and returns a tuple with deleted statement and the changed data structure.","ref":"RDF.Data.html#pop/1","title":"RDF.Data.pop/1","type":"function"},{"doc":"Returns the set of all properties used within the statements of RDF data structure.","ref":"RDF.Data.html#predicates/1","title":"RDF.Data.predicates/1","type":"function"},{"doc":"Returns the set of all resources used within the statements of a RDF data structure","ref":"RDF.Data.html#resources/1","title":"RDF.Data.resources/1","type":"function"},{"doc":"Returns the count of all statements of a RDF data structure.","ref":"RDF.Data.html#statement_count/1","title":"RDF.Data.statement_count/1","type":"function"},{"doc":"Returns the list of all statements of a RDF data structure.","ref":"RDF.Data.html#statements/1","title":"RDF.Data.statements/1","type":"function"},{"doc":"Returns the count of all resources which are subject of the statements of a RDF data structure.","ref":"RDF.Data.html#subject_count/1","title":"RDF.Data.subject_count/1","type":"function"},{"doc":"Returns the set of all resources which are subject of the statements of a RDF data structure.","ref":"RDF.Data.html#subjects/1","title":"RDF.Data.subjects/1","type":"function"},{"doc":"Returns a nested map of the native Elixir values of a RDF data structure. When a :context option is given with a RDF.PropertyMap , predicates will be mapped to the terms defined in the RDF.PropertyMap , if present.","ref":"RDF.Data.html#values/2","title":"RDF.Data.values/2","type":"function"},{"doc":"","ref":"RDF.Data.html#t:t/0","title":"RDF.Data.t/0","type":"type"},{"doc":"A set of RDF.Graph s. It may have multiple named graphs and at most one unnamed (&quot;default&quot;) graph. RDF.Dataset implements: Elixir's Access behaviour Elixir's Enumerable protocol Elixir's Inspect protocol the RDF.Data protocol","ref":"RDF.Dataset.html","title":"RDF.Dataset","type":"module"},{"doc":"Adds triples and quads to a RDF.Dataset . The triples can be provided in any form accepted by add/2 . as a single statement tuple an RDF.Description an RDF.Graph an RDF.Dataset or a list with any combination of the former The graph option allows to set a different destination graph to which the statements should be added, ignoring the graph context of given quads or the name of given graphs in input . Note: When the statements to be added are given as another RDF.Dataset and a destination graph is set with the graph option, the descriptions of the subjects in the different graphs are aggregated.","ref":"RDF.Dataset.html#add/3","title":"RDF.Dataset.add/3","type":"function"},{"doc":"Changes the dataset name of dataset .","ref":"RDF.Dataset.html#change_name/2","title":"RDF.Dataset.change_name/2","type":"function"},{"doc":"The default graph of a RDF.Dataset .","ref":"RDF.Dataset.html#default_graph/1","title":"RDF.Dataset.default_graph/1","type":"function"},{"doc":"Deletes statements from a RDF.Dataset . The graph option allows to set a different destination graph from which the statements should be deleted, ignoring the graph context of given quads or the name of given graphs. Note: When the statements to be deleted are given as another RDF.Dataset , the dataset name must not match dataset name of the dataset from which the statements are deleted. If you want to delete only datasets with matching names, you can use RDF.Data.delete/2 .","ref":"RDF.Dataset.html#delete/3","title":"RDF.Dataset.delete/3","type":"function"},{"doc":"Deletes the default graph.","ref":"RDF.Dataset.html#delete_default_graph/1","title":"RDF.Dataset.delete_default_graph/1","type":"function"},{"doc":"Deletes the given graph.","ref":"RDF.Dataset.html#delete_graph/2","title":"RDF.Dataset.delete_graph/2","type":"function"},{"doc":"Checks if a graph of a RDF.Dataset contains statements about the given resource. Examples iex&gt; RDF.Dataset . new ( [ { EX.S1 , EX . p1 , EX.O1 } ] ) |&gt; RDF.Dataset . describes? ( EX.S1 ) true iex&gt; RDF.Dataset . new ( [ { EX.S1 , EX . p1 , EX.O1 } ] ) |&gt; RDF.Dataset . describes? ( EX.S2 ) false","ref":"RDF.Dataset.html#describes?/3","title":"RDF.Dataset.describes?/3","type":"function"},{"doc":"Returns if the given dataset is empty. Note: You should always prefer this over the use of Enum.empty?/1 as it is significantly faster.","ref":"RDF.Dataset.html#empty?/1","title":"RDF.Dataset.empty?/1","type":"function"},{"doc":"Checks if two RDF.Dataset s are equal. Two RDF.Dataset s are considered to be equal if they contain the same triples and have the same name.","ref":"RDF.Dataset.html#equal?/2","title":"RDF.Dataset.equal?/2","type":"function"},{"doc":"Fetches the RDF.Graph with the given name. When a graph with the given name can not be found can not be found :error is returned. Examples iex&gt; dataset = RDF.Dataset . new ( [ { EX.S1 , EX.P1 , EX.O1 , EX.Graph } , { EX.S2 , EX.P2 , EX.O2 } ] ) ...&gt; RDF.Dataset . fetch ( dataset , EX.Graph ) { :ok , RDF.Graph . new ( { EX.S1 , EX.P1 , EX.O1 } , name : EX.Graph ) } iex&gt; RDF.Dataset . fetch ( dataset , nil ) { :ok , RDF.Graph . new ( { EX.S2 , EX.P2 , EX.O2 } ) } iex&gt; RDF.Dataset . fetch ( dataset , EX.Foo ) :error","ref":"RDF.Dataset.html#fetch/2","title":"RDF.Dataset.fetch/2","type":"function"},{"doc":"Fetches the RDF.Graph with the given name. When a graph with the given name can not be found can not be found the optionally given default value or nil is returned Examples iex&gt; dataset = RDF.Dataset . new ( [ { EX.S1 , EX.P1 , EX.O1 , EX.Graph } , { EX.S2 , EX.P2 , EX.O2 } ] ) ...&gt; RDF.Dataset . get ( dataset , EX.Graph ) RDF.Graph . new ( { EX.S1 , EX.P1 , EX.O1 } , name : EX.Graph ) iex&gt; RDF.Dataset . get ( dataset , nil ) RDF.Graph . new ( { EX.S2 , EX.P2 , EX.O2 } ) iex&gt; RDF.Dataset . get ( dataset , EX.Foo ) nil iex&gt; RDF.Dataset . get ( dataset , EX.Foo , :bar ) :bar","ref":"RDF.Dataset.html#get/3","title":"RDF.Dataset.get/3","type":"function"},{"doc":"Gets and updates the graph with the given name, in a single pass. Invokes the passed function on the RDF.Graph with the given name; this function should return either {graph_to_return, new_graph} or :pop . If the passed function returns {graph_to_return, new_graph} , the return value of get_and_update is {graph_to_return, new_dataset} where new_dataset is the input Dataset updated with new_graph for the given name. If the passed function returns :pop the graph with the given name is removed and a {removed_graph, new_dataset} tuple gets returned. Examples iex&gt; dataset = RDF.Dataset . new ( { EX.S , EX.P , EX.O , EX.Graph } ) ...&gt; RDF.Dataset . get_and_update ( dataset , EX.Graph , fn current_graph -&gt; ...&gt; { current_graph , { EX.S , EX.P , EX.NEW } } ...&gt; end ) { RDF.Graph . new ( { EX.S , EX.P , EX.O } , name : EX.Graph ) , RDF.Dataset . new ( { EX.S , EX.P , EX.NEW , EX.Graph } ) }","ref":"RDF.Dataset.html#get_and_update/3","title":"RDF.Dataset.get_and_update/3","type":"function"},{"doc":"The graph with given name.","ref":"RDF.Dataset.html#graph/2","title":"RDF.Dataset.graph/2","type":"function"},{"doc":"The number of graphs within a RDF.Dataset . Examples iex&gt; RDF.Dataset . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 , EX.Graph } ] ) ...&gt; |&gt; RDF.Dataset . graph_count ( ) 2","ref":"RDF.Dataset.html#graph_count/1","title":"RDF.Dataset.graph_count/1","type":"function"},{"doc":"The set of all graphs.","ref":"RDF.Dataset.html#graphs/1","title":"RDF.Dataset.graphs/1","type":"function"},{"doc":"Checks if the given input statements exist within dataset . The graph option allows to set a different destination graph in which the statements should be checked, ignoring the graph context of given quads or the name of given graphs. Examples iex&gt; dataset = RDF.Dataset . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 , EX.Graph } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 } ] ) ...&gt; RDF.Dataset . include? ( dataset , { EX.S1 , EX . p1 , EX.O1 , EX.Graph } ) true","ref":"RDF.Dataset.html#include?/3","title":"RDF.Dataset.include?/3","type":"function"},{"doc":"Returns a nested map of a RDF.Dataset where each element from its quads is mapped with the given function. The function fun will receive a tuple {statement_position, rdf_term} where statement_position is one of the atoms :subject , :predicate , :object or :graph_name while rdf_term is the RDF term to be mapped. When the given function returns nil this will be interpreted as an error and will become the overhaul result of the map/2 call. Examples iex&gt; [ ...&gt; { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , ~L&quot;Foo&quot; , ~I&lt;http://example.com/Graph&gt; } , ...&gt; { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF.XSD . integer ( 42 ) , } ...&gt; ] ...&gt; |&gt; RDF.Dataset . new ( ) ...&gt; |&gt; RDF.Dataset . map ( fn ...&gt; { :graph_name , graph_name } -&gt; ...&gt; graph_name ...&gt; { :predicate , predicate } -&gt; ...&gt; predicate ...&gt; |&gt; to_string ( ) ...&gt; |&gt; String . split ( &quot;/&quot; ) ...&gt; |&gt; List . last ( ) ...&gt; |&gt; String . to_atom ( ) ...&gt; { _ , term } -&gt; ...&gt; RDF.Term . value ( term ) ...&gt; end ) %{ ~I&lt;http://example.com/Graph&gt; =&gt; %{ &quot;http://example.com/S&quot; =&gt; %{ p : [ &quot;Foo&quot; ] } } , nil =&gt; %{ &quot;http://example.com/S&quot; =&gt; %{ p : [ 42 ] } } }","ref":"RDF.Dataset.html#map/2","title":"RDF.Dataset.map/2","type":"function"},{"doc":"Returns the dataset name IRI of dataset .","ref":"RDF.Dataset.html#name/1","title":"RDF.Dataset.name/1","type":"function"},{"doc":"Creates an empty unnamed RDF.Dataset .","ref":"RDF.Dataset.html#new/0","title":"RDF.Dataset.new/0","type":"function"},{"doc":"Creates an RDF.Dataset . If a keyword list is given an empty dataset is created. Otherwise an unnamed dataset initialized with the given data is created. See new/2 for available arguments and the different ways to provide data. Examples RDF.Dataset . new ( name : EX.GraphName ) RDF.Dataset . new ( init : { EX.S , EX . p , EX.O } ) RDF.Dataset . new ( { EX.S , EX . p , EX.O } )","ref":"RDF.Dataset.html#new/1","title":"RDF.Dataset.new/1","type":"function"},{"doc":"Creates an RDF.Dataset initialized with data. The initial RDF triples can be provided in any form accepted by add/3 . Available options: name : the name of the dataset to be created init : some data with which the dataset should be initialized; the data can be provided in any form accepted by add/3 and above that also with a function returning the initialization data in any of these forms","ref":"RDF.Dataset.html#new/2","title":"RDF.Dataset.new/2","type":"function"},{"doc":"The set of all resources used in the objects within a RDF.Dataset . Note: This function does collect only IRIs and BlankNodes, not Literals. Examples iex&gt; RDF.Dataset . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 , EX.Graph } , ...&gt; { EX.S2 , EX . p2 , EX.O2 , EX.Graph } , ...&gt; { EX.S3 , EX . p1 , EX.O2 } , ...&gt; { EX.S4 , EX . p2 , RDF . bnode ( :bnode ) } , ...&gt; { EX.S5 , EX . p3 , &quot;foo&quot; } ...&gt; ] ) |&gt; RDF.Dataset . objects MapSet . new ( [ RDF . iri ( EX.O1 ) , RDF . iri ( EX.O2 ) , RDF . bnode ( :bnode ) ] )","ref":"RDF.Dataset.html#objects/1","title":"RDF.Dataset.objects/1","type":"function"},{"doc":"Pops an arbitrary statement from a RDF.Dataset .","ref":"RDF.Dataset.html#pop/1","title":"RDF.Dataset.pop/1","type":"function"},{"doc":"Pops the graph with the given name. When a graph with given name can not be found the optionally given default value or nil is returned. Examples iex&gt; dataset = RDF.Dataset . new ( [ ...&gt; { EX.S1 , EX.P1 , EX.O1 , EX.Graph } , ...&gt; { EX.S2 , EX.P2 , EX.O2 } ] ) ...&gt; RDF.Dataset . pop ( dataset , EX.Graph ) { RDF.Graph . new ( { EX.S1 , EX.P1 , EX.O1 } , name : EX.Graph ) , RDF.Dataset . new ( { EX.S2 , EX.P2 , EX.O2 } ) } iex&gt; RDF.Dataset . pop ( dataset , EX.Foo ) { nil , dataset }","ref":"RDF.Dataset.html#pop/2","title":"RDF.Dataset.pop/2","type":"function"},{"doc":"The set of all properties used in the predicates within all graphs of a RDF.Dataset . Examples iex&gt; RDF.Dataset . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 , EX.Graph } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 } ] ) |&gt; ...&gt; RDF.Dataset . predicates MapSet . new ( [ EX . p1 , EX . p2 ] )","ref":"RDF.Dataset.html#predicates/1","title":"RDF.Dataset.predicates/1","type":"function"},{"doc":"Returns the aggregated prefixes of all graphs of dataset as a RDF.PrefixMap .","ref":"RDF.Dataset.html#prefixes/1","title":"RDF.Dataset.prefixes/1","type":"function"},{"doc":"Adds statements to a RDF.Dataset overwriting existing statements with the subjects given in the input data. The graph option allows to set a different destination graph to which the statements should be added, ignoring the graph context of given quads or the name of given graphs in input . Note: When the statements to be added are given as another RDF.Dataset and a destination graph is set with the graph option, the descriptions of the subjects in the different graphs are aggregated. Examples iex&gt; dataset = RDF.Dataset . new ( { EX.S , EX.P1 , EX.O1 } ) ...&gt; RDF.Dataset . put ( dataset , { EX.S , EX.P2 , EX.O2 } ) RDF.Dataset . new ( { EX.S , EX.P2 , EX.O2 } ) iex&gt; RDF.Dataset . put ( dataset , { EX.S2 , EX.P2 , EX.O2 } ) RDF.Dataset . new ( [ { EX.S , EX.P1 , EX.O1 } , { EX.S2 , EX.P2 , EX.O2 } ] )","ref":"RDF.Dataset.html#put/3","title":"RDF.Dataset.put/3","type":"function"},{"doc":"Adds statements to a RDF.Dataset and overwrites all existing statements with the same subject-predicate combinations given in the input data. The graph option allows to set a different destination graph to which the statements should be added, ignoring the graph context of given quads or the name of given graphs in input . Note: When the statements to be added are given as another RDF.Dataset and a destination graph is set with the graph option, the descriptions of the subjects in the different graphs are aggregated. Examples iex&gt; dataset = RDF.Dataset . new ( { EX.S , EX.P1 , EX.O1 } ) ...&gt; RDF.Dataset . put_properties ( dataset , { EX.S , EX.P1 , EX.O2 } ) RDF.Dataset . new ( { EX.S , EX.P1 , EX.O2 } ) iex&gt; RDF.Dataset . put_properties ( dataset , { EX.S , EX.P2 , EX.O2 } ) RDF.Dataset . new ( [ { EX.S , EX.P1 , EX.O1 } , { EX.S , EX.P2 , EX.O2 } ] ) iex&gt; RDF.Dataset . new ( [ { EX.S1 , EX.P1 , EX.O1 } , { EX.S2 , EX.P2 , EX.O2 } ] ) ...&gt; |&gt; RDF.Dataset . put_properties ( [ { EX.S1 , EX.P2 , EX.O3 } , { EX.S2 , EX.P2 , EX.O3 } ] ) RDF.Dataset . new ( [ { EX.S1 , EX.P1 , EX.O1 } , { EX.S1 , EX.P2 , EX.O3 } , { EX.S2 , EX.P2 , EX.O3 } ] )","ref":"RDF.Dataset.html#put_properties/3","title":"RDF.Dataset.put_properties/3","type":"function"},{"doc":"The set of all resources used within a RDF.Dataset . Examples iex&gt; RDF.Dataset.new([ ...&gt; {EX.S1, EX.p1, EX.O1, EX.Graph}, ...&gt; {EX.S2, EX.p1, EX.O2, EX.Graph}, ...&gt; {EX.S2, EX.p2, RDF.bnode(:bnode)}, ...&gt; {EX.S3, EX.p1, &quot;foo&quot;} ...&gt; ]) |&gt; RDF.Dataset.resources MapSet.new([RDF.iri(EX.S1), RDF.iri(EX.S2), RDF.iri(EX.S3), RDF . iri ( EX.O1 ) , RDF . iri ( EX.O2 ) , RDF . bnode ( :bnode ) , EX . p1 , EX . p2 ] )","ref":"RDF.Dataset.html#resources/1","title":"RDF.Dataset.resources/1","type":"function"},{"doc":"The number of statements within a RDF.Dataset . Examples iex&gt; RDF.Dataset . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 , EX.Graph } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 } ] ) |&gt; ...&gt; RDF.Dataset . statement_count 3","ref":"RDF.Dataset.html#statement_count/1","title":"RDF.Dataset.statement_count/1","type":"function"},{"doc":"All statements within all graphs of a RDF.Dataset . When the optional :filter_star flag is set to true RDF-star statements with a triple as subject or object will be filtered. The default value is false . Examples iex&gt; RDF.Dataset . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 , EX.Graph } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 } ] ) |&gt; ...&gt; RDF.Dataset . statements [ { RDF . iri ( EX.S1 ) , RDF . iri ( EX . p2 ) , RDF . iri ( EX.O3 ) } , { RDF . iri ( EX.S2 ) , RDF . iri ( EX . p2 ) , RDF . iri ( EX.O2 ) } , { RDF . iri ( EX.S1 ) , RDF . iri ( EX . p1 ) , RDF . iri ( EX.O1 ) , RDF . iri ( EX.Graph ) } ]","ref":"RDF.Dataset.html#statements/2","title":"RDF.Dataset.statements/2","type":"function"},{"doc":"The set of all subjects used in the statement within all graphs of a RDF.Dataset . Examples iex&gt; RDF.Dataset . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 , EX.Graph } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 } ] ) |&gt; ...&gt; RDF.Dataset . subjects MapSet . new ( [ RDF . iri ( EX.S1 ) , RDF . iri ( EX.S2 ) ] )","ref":"RDF.Dataset.html#subjects/1","title":"RDF.Dataset.subjects/1","type":"function"},{"doc":"Returns a nested map of the native Elixir values of a RDF.Dataset . When a :context option is given with a RDF.PropertyMap , predicates will be mapped to the terms defined in the RDF.PropertyMap , if present. Examples iex&gt; [ ...&gt; { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , ~L&quot;Foo&quot; , ~I&lt;http://example.com/Graph&gt; } , ...&gt; { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF.XSD . integer ( 42 ) , } ...&gt; ] ...&gt; |&gt; RDF.Dataset . new ( ) ...&gt; |&gt; RDF.Dataset . values ( ) %{ &quot;http://example.com/Graph&quot; =&gt; %{ &quot;http://example.com/S&quot; =&gt; %{ &quot;http://example.com/p&quot; =&gt; [ &quot;Foo&quot; ] } } , nil =&gt; %{ &quot;http://example.com/S&quot; =&gt; %{ &quot;http://example.com/p&quot; =&gt; [ 42 ] } } }","ref":"RDF.Dataset.html#values/2","title":"RDF.Dataset.values/2","type":"function"},{"doc":"Returns the names of all graphs of a RDF.Dataset containing statements about the given subject. Examples iex&gt; dataset = RDF.Dataset . new ( [ ...&gt; { EX.S1 , EX . p , EX.O } , ...&gt; { EX.S2 , EX . p , EX.O } , ...&gt; { EX.S1 , EX . p , EX.O , EX.Graph1 } , ...&gt; { EX.S2 , EX . p , EX.O , EX.Graph2 } ] ) ...&gt; RDF.Dataset . who_describes ( dataset , EX.S1 ) [ nil , RDF . iri ( EX.Graph1 ) ]","ref":"RDF.Dataset.html#who_describes/2","title":"RDF.Dataset.who_describes/2","type":"function"},{"doc":"","ref":"RDF.Dataset.html#t:graph_name/0","title":"RDF.Dataset.graph_name/0","type":"type"},{"doc":"","ref":"RDF.Dataset.html#t:input/0","title":"RDF.Dataset.input/0","type":"type"},{"doc":"","ref":"RDF.Dataset.html#t:t/0","title":"RDF.Dataset.t/0","type":"type"},{"doc":"","ref":"RDF.Dataset.html#t:update_graph_fun/0","title":"RDF.Dataset.update_graph_fun/0","type":"type"},{"doc":"A set of RDF triples about the same subject. RDF.Description implements: Elixir's Access behaviour Elixir's Enumerable protocol Elixir's Inspect protocol the RDF.Data protocol","ref":"RDF.Description.html","title":"RDF.Description","type":"module"},{"doc":"Add statements to a RDF.Description . Note: When the statements to be added are given as another RDF.Description , the subject must not match subject of the description to which the statements are added. As opposed to that RDF.Data.merge/2 will produce a RDF.Graph containing both descriptions. Examples iex&gt; RDF.Description . new ( EX.S , init : { EX.P1 , EX.O1 } ) ...&gt; |&gt; RDF.Description . add ( { EX.P2 , EX.O2 } ) RDF.Description . new ( EX.S , init : [ { EX.P1 , EX.O1 } , { EX.P2 , EX.O2 } ] ) iex&gt; RDF.Description . new ( EX.S , init : { EX.P , EX.O1 } ) ...&gt; |&gt; RDF.Description . add ( { EX.P , [ EX.O2 , EX.O3 ] } ) RDF.Description . new ( EX.S , init : [ { EX.P , EX.O1 } , { EX.P , EX.O2 } , { EX.P , EX.O3 } ] )","ref":"RDF.Description.html#add/3","title":"RDF.Description.add/3","type":"function"},{"doc":"Changes the subject of a description.","ref":"RDF.Description.html#change_subject/2","title":"RDF.Description.change_subject/2","type":"function"},{"doc":"See RDF.Description.statement_count/1 .","ref":"RDF.Description.html#count/1","title":"RDF.Description.count/1","type":"function"},{"doc":"Deletes statements from a RDF.Description . Note: When the statements to be deleted are given as another RDF.Description , the subject must not match subject of the description from which the statements are deleted. If you want to delete only a matching description subject, you can use RDF.Data.delete/2 .","ref":"RDF.Description.html#delete/3","title":"RDF.Description.delete/3","type":"function"},{"doc":"Deletes all statements with the given properties.","ref":"RDF.Description.html#delete_predicates/2","title":"RDF.Description.delete_predicates/2","type":"function"},{"doc":"Checks if a RDF.Description has the given resource as subject. Examples iex&gt; RDF.Description . new ( EX.S1 , init : { EX . p1 , EX.O1 } ) ...&gt; |&gt; RDF.Description . describes? ( EX.S1 ) true iex&gt; RDF.Description . new ( EX.S1 , init : { EX . p1 , EX.O1 } ) ...&gt; |&gt; RDF.Description . describes? ( EX.S2 ) false","ref":"RDF.Description.html#describes?/2","title":"RDF.Description.describes?/2","type":"function"},{"doc":"Returns if the given description is empty. Note: You should always prefer this over the use of Enum.empty?/1 as it is significantly faster.","ref":"RDF.Description.html#empty?/1","title":"RDF.Description.empty?/1","type":"function"},{"doc":"Checks if two RDF.Description s are equal. Two RDF.Description s are considered to be equal if they contain the same triples.","ref":"RDF.Description.html#equal?/2","title":"RDF.Description.equal?/2","type":"function"},{"doc":"Fetches the objects for the given predicate of a Description. When the predicate can not be found :error is returned. Examples iex&gt; RDF.Description . new ( EX.S , init : { EX . p , EX.O } ) |&gt; RDF.Description . fetch ( EX . p ) { :ok , [ RDF . iri ( EX.O ) ] } iex&gt; RDF.Description . new ( EX.S , init : [ { EX.P , EX.O1 } , { EX.P , EX.O2 } ] ) ...&gt; |&gt; RDF.Description . fetch ( EX.P ) { :ok , [ RDF . iri ( EX.O1 ) , RDF . iri ( EX.O2 ) ] } iex&gt; RDF.Description . new ( EX.S ) |&gt; RDF.Description . fetch ( EX . foo ) :error","ref":"RDF.Description.html#fetch/2","title":"RDF.Description.fetch/2","type":"function"},{"doc":"Gets a single object for the given predicate of a Description. When the predicate can not be found, the optionally given default value or nil is returned. Examples iex&gt; RDF.Description . new ( EX.S , init : { EX.P , EX.O } ) |&gt; RDF.Description . first ( EX.P ) RDF . iri ( EX.O ) iex&gt; RDF.Description . new ( EX.S ) |&gt; RDF.Description . first ( EX . foo ) nil iex&gt; RDF.Description . new ( EX.S ) |&gt; RDF.Description . first ( EX . foo , :bar ) :bar","ref":"RDF.Description.html#first/3","title":"RDF.Description.first/3","type":"function"},{"doc":"Gets the objects for the given predicate of a Description. When the predicate can not be found, the optionally given default value or nil is returned. Examples iex&gt; RDF.Description . new ( EX.S , init : { EX.P , EX.O } ) |&gt; RDF.Description . get ( EX.P ) [ RDF . iri ( EX.O ) ] iex&gt; RDF.Description . new ( EX.S ) |&gt; RDF.Description . get ( EX . foo ) nil iex&gt; RDF.Description . new ( EX.S ) |&gt; RDF.Description . get ( EX . foo , :bar ) :bar","ref":"RDF.Description.html#get/3","title":"RDF.Description.get/3","type":"function"},{"doc":"Gets and updates the objects of the given predicate of a Description, in a single pass. Invokes the passed function on the objects of the given predicate; this function should return either {objects_to_return, new_object} or :pop . If the passed function returns {objects_to_return, new_objects} , the return value of get_and_update is {objects_to_return, new_description} where new_description is the input Description updated with new_objects for the given predicate. If the passed function returns :pop the objects for the given predicate are removed and a {removed_objects, new_description} tuple gets returned. Examples iex&gt; RDF.Description . new ( EX.S , init : { EX.P , EX.O } ) ...&gt; |&gt; RDF.Description . get_and_update ( EX.P , fn current_objects -&gt; ...&gt; { current_objects , EX.New } ...&gt; end ) { [ RDF . iri ( EX.O ) ] , RDF.Description . new ( EX.S , init : { EX.P , EX.New } ) } iex&gt; RDF.Graph . new ( [ { EX.S , EX.P1 , EX.O1 } , { EX.S , EX.P2 , EX.O2 } ] ) ...&gt; |&gt; RDF.Graph . description ( EX.S ) ...&gt; |&gt; RDF.Description . get_and_update ( EX.P1 , fn _ -&gt; :pop end ) { [ RDF . iri ( EX.O1 ) ] , RDF.Description . new ( EX.S , init : { EX.P2 , EX.O2 } ) }","ref":"RDF.Description.html#get_and_update/3","title":"RDF.Description.get_and_update/3","type":"function"},{"doc":"Checks if the given input statements exist within description .","ref":"RDF.Description.html#include?/3","title":"RDF.Description.include?/3","type":"function"},{"doc":"Returns a map of a RDF.Description where each element from its triples is mapped with the given function. The subject is not part of the result. If you want the subject in an outer map, just put the the description in a graph and use RDF.Graph.map/2 . The function fun will receive a tuple {statement_position, rdf_term} where statement_position is one of the atoms :predicate or :object , while rdf_term is the RDF term to be mapped. When the given function returns nil this will be interpreted as an error and will become the overhaul result of the map/2 call. Note: RDF-star statements where the object is a triple will be ignored. Examples iex&gt; RDF.Description . new ( ~I&lt;http://example.com/S&gt; , init : { ~I&lt;http://example.com/p&gt; , ~L&quot;Foo&quot; } ) ...&gt; |&gt; RDF.Description . map ( fn ...&gt; { :predicate , predicate } -&gt; ...&gt; predicate ...&gt; |&gt; to_string ( ) ...&gt; |&gt; String . split ( &quot;/&quot; ) ...&gt; |&gt; List . last ( ) ...&gt; |&gt; String . to_atom ( ) ...&gt; { _ , term } -&gt; ...&gt; RDF.Term . value ( term ) ...&gt; end ) %{ p : [ &quot;Foo&quot; ] }","ref":"RDF.Description.html#map/2","title":"RDF.Description.map/2","type":"function"},{"doc":"Creates an RDF.Description about the given subject. The created RDF.Description can be initialized with any form of data which add/2 understands with the :init option. Additionally a function returning the initialization data in any of these forms can be as the :init value. Examples RDF.Description . new ( EX.S ) RDF.Description . new ( EX.S , init : { EX.S , EX . p , EX.O } ) RDF.Description . new ( EX.S , init : { EX . p , [ EX.O1 , EX.O2 ] } ) RDF.Description . new ( EX.S , init : [ { EX . p1 , EX.O1 } , { EX . p2 , EX.O2 } ] ) RDF.Description . new ( EX.S , init : RDF.Description . new ( EX.S , init : { EX.P , EX.O } ) ) RDF.Description . new ( EX.S , init : fn -&gt; { EX . p , EX.O } end )","ref":"RDF.Description.html#new/2","title":"RDF.Description.new/2","type":"function"},{"doc":"The set of all resources used in the objects within a RDF.Description . Note: This function does collect only IRIs and BlankNodes, not Literals. Examples iex&gt; RDF.Description . new ( EX.S1 , init : [ ...&gt; { EX . p1 , EX.O1 } , ...&gt; { EX . p2 , EX.O2 } , ...&gt; { EX . p3 , EX.O2 } , ...&gt; { EX . p4 , RDF . bnode ( :bnode ) } , ...&gt; { EX . p3 , &quot;foo&quot; } ] ) ...&gt; |&gt; RDF.Description . objects ( ) MapSet . new ( [ RDF . iri ( EX.O1 ) , RDF . iri ( EX.O2 ) , RDF . bnode ( :bnode ) ] )","ref":"RDF.Description.html#objects/1","title":"RDF.Description.objects/1","type":"function"},{"doc":"The set of all resources used in the objects within a RDF.Description satisfying the given filter criterion.","ref":"RDF.Description.html#objects/2","title":"RDF.Description.objects/2","type":"function"},{"doc":"Pops an arbitrary triple from a RDF.Description .","ref":"RDF.Description.html#pop/1","title":"RDF.Description.pop/1","type":"function"},{"doc":"Pops the objects of the given predicate of a Description. When the predicate can not be found the optionally given default value or nil is returned. Examples iex&gt; RDF.Description . new ( EX.S , init : { EX.P , EX.O } ) ...&gt; |&gt; RDF.Description . pop ( EX.P ) { [ RDF . iri ( EX.O ) ] , RDF.Description . new ( EX.S ) } iex&gt; RDF.Description . new ( EX.S , init : { EX.P , EX.O } ) ...&gt; |&gt; RDF.Description . pop ( EX.Missing ) { nil , RDF.Description . new ( EX.S , init : { EX.P , EX.O } ) }","ref":"RDF.Description.html#pop/2","title":"RDF.Description.pop/2","type":"function"},{"doc":"The set of all properties used in the predicates within a RDF.Description . Examples iex&gt; RDF.Description . new ( EX.S1 , init : [ ...&gt; { EX . p1 , EX.O1 } , ...&gt; { EX . p2 , EX.O2 } , ...&gt; { EX . p2 , EX.O3 } ] ) ...&gt; |&gt; RDF.Description . predicates ( ) MapSet . new ( [ EX . p1 , EX . p2 ] )","ref":"RDF.Description.html#predicates/1","title":"RDF.Description.predicates/1","type":"function"},{"doc":"Adds statements to a RDF.Description and overwrites all existing statements with already used predicates. Note: As it is a destructive function this function is more strict in its handling of RDF.Description s than add/3 . The subject of a RDF.Description to be put must match. If you want to overwrite existing statements with those from the description of another subject, you'll have to explicitly change the subject with change_subject/2 first before using put/3 . Examples iex&gt; RDF.Description . new ( EX.S , init : { EX.P , EX.O1 } ) ...&gt; |&gt; RDF.Description . put ( { EX.P , EX.O2 } ) RDF.Description . new ( EX.S , init : { EX.P , EX.O2 } )","ref":"RDF.Description.html#put/3","title":"RDF.Description.put/3","type":"function"},{"doc":"The set of all resources used within a RDF.Description . Examples iex&gt; RDF.Description . new ( EX.S1 , init : [ ...&gt; { EX . p1 , EX.O1 } , ...&gt; { EX . p2 , EX.O2 } , ...&gt; { EX . p1 , EX.O2 } , ...&gt; { EX . p2 , RDF . bnode ( :bnode ) } , ...&gt; { EX . p3 , &quot;foo&quot; } ] ) ...&gt; |&gt; RDF.Description . resources ( ) MapSet . new ( [ RDF . iri ( EX.O1 ) , RDF . iri ( EX.O2 ) , RDF . bnode ( :bnode ) , EX . p1 , EX . p2 , EX . p3 ] )","ref":"RDF.Description.html#resources/1","title":"RDF.Description.resources/1","type":"function"},{"doc":"Returns the number of statements of a RDF.Description .","ref":"RDF.Description.html#statement_count/1","title":"RDF.Description.statement_count/1","type":"function"},{"doc":"See RDF.Description.triples/2 .","ref":"RDF.Description.html#statements/2","title":"RDF.Description.statements/2","type":"function"},{"doc":"Returns the subject IRI or blank node of a description.","ref":"RDF.Description.html#subject/1","title":"RDF.Description.subject/1","type":"function"},{"doc":"Creates a description from another one by limiting its statements to those using one of the given predicates . If predicates contains properties that are not used in the description , they're simply ignored. If nil is passed, the description is left untouched.","ref":"RDF.Description.html#take/2","title":"RDF.Description.take/2","type":"function"},{"doc":"The list of all triples within a RDF.Description . When the optional :filter_star flag is set to true RDF-star triples with a triple as subject or object will be filtered. So, for a description with a triple as a subject you'll always get an empty list. The default value of the :filter_star flag is false .","ref":"RDF.Description.html#triples/2","title":"RDF.Description.triples/2","type":"function"},{"doc":"Updates the objects of the predicate in description with the given function. If predicate is present in description with objects as value, fun is invoked with argument objects and its result is used as the new list of objects of predicate . If predicate is not present in description , initial is inserted as the objects of predicate . The initial value will not be passed through the update function. The initial value and the returned objects by the update function will automatically coerced to proper RDF object values before added. Examples iex&gt; RDF.Description . new ( EX.S , init : { EX . p , EX.O } ) ...&gt; |&gt; RDF.Description . update ( EX . p , fn objects -&gt; [ EX.O2 | objects ] end ) RDF.Description . new ( EX.S , init : [ { EX . p , EX.O } , { EX . p , EX.O2 } ] ) iex&gt; RDF.Description . new ( EX.S ) ...&gt; |&gt; RDF.Description . update ( EX . p , EX.O , fn _ -&gt; EX.O2 end ) RDF.Description . new ( EX.S , init : { EX . p , EX.O } )","ref":"RDF.Description.html#update/4","title":"RDF.Description.update/4","type":"function"},{"doc":"Returns a map of the native Elixir values of a RDF.Description . The subject is not part of the result. It can be converted separately with RDF.Term.value/1 , or, if you want the subject in an outer map, just put the the description in a graph and use RDF.Graph.values/2 . When a :context option is given with a RDF.PropertyMap , predicates will be mapped to the terms defined in the RDF.PropertyMap , if present. Note: RDF-star statements where the object is a triple will be ignored. Examples iex&gt; RDF.Description . new ( ~I&lt;http://example.com/S&gt; , init : { ~I&lt;http://example.com/p&gt; , ~L&quot;Foo&quot; } ) ...&gt; |&gt; RDF.Description . values ( ) %{ &quot;http://example.com/p&quot; =&gt; [ &quot;Foo&quot; ] } iex&gt; RDF.Description . new ( ~I&lt;http://example.com/S&gt; , init : { ~I&lt;http://example.com/p&gt; , ~L&quot;Foo&quot; } ) ...&gt; |&gt; RDF.Description . values ( context : %{ p : ~I&lt;http://example.com/p&gt; } ) %{ p : [ &quot;Foo&quot; ] }","ref":"RDF.Description.html#values/2","title":"RDF.Description.values/2","type":"function"},{"doc":"Removes all objects from a description which are quoted triples.","ref":"RDF.Description.html#without_quoted_triple_objects/1","title":"RDF.Description.without_quoted_triple_objects/1","type":"function"},{"doc":"","ref":"RDF.Description.html#t:input/0","title":"RDF.Description.input/0","type":"type"},{"doc":"","ref":"RDF.Description.html#t:predications/0","title":"RDF.Description.predications/0","type":"type"},{"doc":"","ref":"RDF.Description.html#t:t/0","title":"RDF.Description.t/0","type":"type"},{"doc":"A data structure for diffs between RDF.Graph s and RDF.Description s. A RDF.Diff is a struct consisting of two fields additions and deletions with RDF.Graph s of added and deleted statements.","ref":"RDF.Diff.html","title":"RDF.Diff","type":"module"},{"doc":"Applies a diff to a RDF.Graph or RDF.Description by deleting the deletions and adding the additions of the diff . Deletions of statements which are not present in the given graph or description are simply ignored. The result of an application is always a RDF.Graph , even if a RDF.Description is given and the additions from the diff are all about the subject of this description.","ref":"RDF.Diff.html#apply/2","title":"RDF.Diff.apply/2","type":"function"},{"doc":"Computes a diff between two RDF.Graph s or RDF.Description s. The first argument represents the original and the second argument the new version of the RDF data to be compared. Any combination of RDF.Graph s or RDF.Description s can be passed as first and second argument. Examples iex&gt; RDF.Diff.diff( ...&gt; RDF.description(EX.S1, init: {EX.S1, EX.p1, [EX.O1, EX.O2]}), ...&gt; RDF.graph([ ...&gt; {EX.S1, EX.p1, [EX.O2, EX.O3]}, ...&gt; {EX.S2, EX.p2, EX.O4} ...&gt; ])) %RDF.Diff{ additions : RDF . graph ( [ { EX.S1 , EX . p1 , EX.O3 } , { EX.S2 , EX . p2 , EX.O4 } ] ) , deletions : RDF . graph ( { EX.S1 , EX . p1 , EX.O1 } ) }","ref":"RDF.Diff.html#diff/2","title":"RDF.Diff.diff/2","type":"function"},{"doc":"Determines if a diff is empty. A RDF.Diff is empty, if its additions and deletions graphs are empty.","ref":"RDF.Diff.html#empty?/1","title":"RDF.Diff.empty?/1","type":"function"},{"doc":"Merges two diffs. The diffs are merged by adding up the additions and deletions of both diffs respectively.","ref":"RDF.Diff.html#merge/2","title":"RDF.Diff.merge/2","type":"function"},{"doc":"Creates a RDF.Diff struct. Some initial additions and deletions can be provided optionally with the resp. additions and deletions keywords. The statements for the additions and deletions can be provided in any form supported by the RDF.Graph.new/1 function.","ref":"RDF.Diff.html#new/1","title":"RDF.Diff.new/1","type":"function"},{"doc":"","ref":"RDF.Diff.html#t:t/0","title":"RDF.Diff.t/0","type":"type"},{"doc":"A set of RDF triples with an optional name. RDF.Graph implements: Elixir's Access behaviour Elixir's Enumerable protocol Elixir's Inspect protocol the RDF.Data protocol","ref":"RDF.Graph.html","title":"RDF.Graph","type":"module"},{"doc":"Adds triples to a RDF.Graph . The input can be provided as a single statement tuple a nested subject-predicate-object map a RDF.Description a RDF.Graph or a list with any combination of the former When the statements to be added are given as another RDF.Graph , the graph name must not match graph name of the graph to which the statements are added. As opposed to that, RDF.Data.merge/2 will produce a RDF.Dataset containing both graphs. Also when the statements to be added are given as another RDF.Graph , the prefixes of this graph will be added. In case of conflicting prefix mappings the original prefix from graph will be kept. RDF-star annotations to be added to all of the given statements can be specified with the :add_annotations , :put_annotations or :put_annotation_properties keyword options. They have different addition semantics similar to the add_annotations/3 , put_annotations/3 and put_annotation_properties/3 counterparts.","ref":"RDF.Graph.html#add/3","title":"RDF.Graph.add/3","type":"function"},{"doc":"Adds RDF-star annotations to the given set of statements. The set of statements can be given in any input form (see add/3 ). The predicate-objects pairs to be added as annotations can be given as a tuple, a list of tuples or a map.","ref":"RDF.Graph.html#add_annotations/3","title":"RDF.Graph.add_annotations/3","type":"function"},{"doc":"Adds prefixes to the given graph . The prefixes mappings can be given as any structure convertible to a RDF.PrefixMap . When a prefix with another mapping already exists it will be overwritten with the new one. This behaviour can be customized by providing a conflict_resolver function. See RDF.PrefixMap.merge/3 for more on that.","ref":"RDF.Graph.html#add_prefixes/3","title":"RDF.Graph.add_prefixes/3","type":"function"},{"doc":"Returns the RDF.Graph of all annotations. Note: The graph includes only triples where the subject is a quoted triple. Triples where only the object is a quoted triple are NOT included.","ref":"RDF.Graph.html#annotations/1","title":"RDF.Graph.annotations/1","type":"function"},{"doc":"Returns the base IRI of the given graph .","ref":"RDF.Graph.html#base_iri/1","title":"RDF.Graph.base_iri/1","type":"function"},{"doc":"Builds an RDF.Graph from a description of its content in a graph DSL. All available opts of new/2 are also supported here. For a description of the DSL see this guide .","ref":"RDF.Graph.html#build/2","title":"RDF.Graph.build/2","type":"macro"},{"doc":"Changes the graph name of graph .","ref":"RDF.Graph.html#change_name/2","title":"RDF.Graph.change_name/2","type":"function"},{"doc":"Removes all triples from graph . This function is useful for getting an empty graph based on the settings of another graph, as this function keeps graph name, base IRI and default prefixes as they are and just removes the triples.","ref":"RDF.Graph.html#clear/1","title":"RDF.Graph.clear/1","type":"function"},{"doc":"Clears the base IRI of the given graph .","ref":"RDF.Graph.html#clear_base_iri/1","title":"RDF.Graph.clear_base_iri/1","type":"function"},{"doc":"Clears the base IRI and all prefixes of the given graph .","ref":"RDF.Graph.html#clear_metadata/1","title":"RDF.Graph.clear_metadata/1","type":"function"},{"doc":"Clears all prefixes of the given graph .","ref":"RDF.Graph.html#clear_prefixes/1","title":"RDF.Graph.clear_prefixes/1","type":"function"},{"doc":"Deletes statements from a RDF.Graph . When the statements to be deleted are given as another RDF.Graph , the graph name must not match graph name of the graph from which the statements are deleted. If you want to delete only statements with matching graph names, you can use RDF.Data.delete/2 . The optional :delete_annotations keyword option allows to set which of the RDF-star annotations of the deleted statements should be deleted. Any of the possible values of delete_annotations/3 can be provided here. By default no annotations of the deleted statements will be removed. Alternatively, the :add_annotations , :put_annotations or :put_annotation_properties keyword options can be used to add annotations about the deleted statements with the addition semantics similar to the respective add_annotations/3 , put_annotations/3 and put_annotation_properties/3 counterparts.","ref":"RDF.Graph.html#delete/3","title":"RDF.Graph.delete/3","type":"function"},{"doc":"Deletes RDF-star annotations of a given set of statements. The statements can be given in any input form (see add/3 ). If true is given as the third argument or is delete_annotations/2 is used, all annotations of the given statements are deleted. If a single predicate or list of predicates is given only statements with these predicates from the annotations of the given statements are deleted.","ref":"RDF.Graph.html#delete_annotations/2","title":"RDF.Graph.delete_annotations/2","type":"function"},{"doc":"See RDF.Star.Graph.delete_annotations/3 .","ref":"RDF.Graph.html#delete_annotations/3","title":"RDF.Graph.delete_annotations/3","type":"function"},{"doc":"Deletes all statements with the given subjects . If subjects contains subjects that are not in graph , they're simply ignored. The optional :delete_annotations keyword option allows to set which of the RDF-star annotations of the deleted statements should be deleted. Any of the possible values of delete_annotations/3 can be provided here. By default no annotations of the deleted statements will be removed. Alternatively, the :add_annotations , :put_annotations or :put_annotation_properties keyword options can be used to add annotations about the deleted statements with the addition semantics similar to the respective add_annotations/3 , put_annotations/3 and put_annotation_properties/3 counterparts.","ref":"RDF.Graph.html#delete_descriptions/3","title":"RDF.Graph.delete_descriptions/3","type":"function"},{"doc":"Deletes prefixes from the given graph . The prefixes can be a single prefix or a list of prefixes. Prefixes not in prefixes of the graph are simply ignored.","ref":"RDF.Graph.html#delete_prefixes/2","title":"RDF.Graph.delete_prefixes/2","type":"function"},{"doc":"See RDF.Graph.delete_descriptions/2 .","ref":"RDF.Graph.html#delete_subjects/2","title":"RDF.Graph.delete_subjects/2","type":"function"},{"doc":"See RDF.Graph.delete_descriptions/3 .","ref":"RDF.Graph.html#delete_subjects/3","title":"RDF.Graph.delete_subjects/3","type":"function"},{"doc":"Checks if a RDF.Graph contains statements about the given resource. Examples iex&gt; RDF.Graph . new ( [ { EX.S1 , EX . p1 , EX.O1 } ] ) |&gt; RDF.Graph . describes? ( EX.S1 ) true iex&gt; RDF.Graph . new ( [ { EX.S1 , EX . p1 , EX.O1 } ] ) |&gt; RDF.Graph . describes? ( EX.S2 ) false","ref":"RDF.Graph.html#describes?/2","title":"RDF.Graph.describes?/2","type":"function"},{"doc":"Returns the description of the given subject in the given graph . As opposed to get/3 this function returns an empty RDF.Description when the subject does not exist in the given graph . Examples iex&gt; RDF.Graph . new ( [ { EX.S1 , EX.P1 , EX.O1 } , { EX.S2 , EX.P2 , EX.O2 } ] ) ...&gt; |&gt; RDF.Graph . description ( EX.S1 ) RDF.Description . new ( EX.S1 , init : { EX.P1 , EX.O1 } ) iex&gt; RDF.Graph . description ( RDF.Graph . new ( ) , EX.Foo ) RDF.Description . new ( EX.Foo )","ref":"RDF.Graph.html#description/2","title":"RDF.Graph.description/2","type":"function"},{"doc":"All RDF.Description s within a RDF.Graph .","ref":"RDF.Graph.html#descriptions/1","title":"RDF.Graph.descriptions/1","type":"function"},{"doc":"Returns if the given graph is empty. Note: You should always prefer this over the use of Enum.empty?/1 as it is significantly faster.","ref":"RDF.Graph.html#empty?/1","title":"RDF.Graph.empty?/1","type":"function"},{"doc":"Checks if two RDF.Graph s are equal. Two RDF.Graph s are considered to be equal if they contain the same triples and have the same name. The prefixes of the graph are irrelevant for equality.","ref":"RDF.Graph.html#equal?/2","title":"RDF.Graph.equal?/2","type":"function"},{"doc":"Fetches the description of the given subject. When the subject can not be found :error is returned. Examples iex&gt; RDF.Graph . new ( [ { EX.S1 , EX.P1 , EX.O1 } , { EX.S2 , EX.P2 , EX.O2 } ] ) ...&gt; |&gt; RDF.Graph . fetch ( EX.S1 ) { :ok , RDF.Description . new ( EX.S1 , init : { EX.P1 , EX.O1 } ) } iex&gt; RDF.Graph . new ( ) |&gt; RDF.Graph . fetch ( EX . foo ) :error","ref":"RDF.Graph.html#fetch/2","title":"RDF.Graph.fetch/2","type":"function"},{"doc":"Gets the description of the given subject in the given graph . When the subject can not be found the optionally given default value or nil is returned. Examples iex&gt; RDF.Graph . new ( [ { EX.S1 , EX.P1 , EX.O1 } , { EX.S2 , EX.P2 , EX.O2 } ] ) ...&gt; |&gt; RDF.Graph . get ( EX.S1 ) RDF.Description . new ( EX.S1 , init : { EX.P1 , EX.O1 } ) iex&gt; RDF.Graph . get ( RDF.Graph . new ( ) , EX.Foo ) nil iex&gt; RDF.Graph . get ( RDF.Graph . new ( ) , EX.Foo , :bar ) :bar","ref":"RDF.Graph.html#get/3","title":"RDF.Graph.get/3","type":"function"},{"doc":"Gets and updates the description of the given subject, in a single pass. Invokes the passed function on the RDF.Description of the given subject; this function should return either {description_to_return, new_description} or :pop . If the passed function returns {description_to_return, new_description} , the return value of get_and_update is {description_to_return, new_graph} where new_graph is the input Graph updated with new_description for the given subject. If the passed function returns :pop the description for the given subject is removed and a {removed_description, new_graph} tuple gets returned. Examples iex&gt; RDF.Graph . new ( { EX.S , EX.P , EX.O } ) ...&gt; |&gt; RDF.Graph . get_and_update ( EX.S , fn current_description -&gt; ...&gt; { current_description , { EX.P , EX.NEW } } ...&gt; end ) { RDF.Description . new ( EX.S , init : { EX.P , EX.O } ) , RDF.Graph . new ( { EX.S , EX.P , EX.NEW } ) }","ref":"RDF.Graph.html#get_and_update/3","title":"RDF.Graph.get_and_update/3","type":"function"},{"doc":"Checks if the given input statements exist within graph .","ref":"RDF.Graph.html#include?/3","title":"RDF.Graph.include?/3","type":"function"},{"doc":"Returns a nested map of a RDF.Graph where each element from its triples is mapped with the given function. The function fun will receive a tuple {statement_position, rdf_term} where statement_position is one of the atoms :subject , :predicate or :object , while rdf_term is the RDF term to be mapped. When the given function returns nil this will be interpreted as an error and will become the overhaul result of the map/2 call. Note: RDF-star statements where the subject or object is a triple will be ignored. Examples iex&gt; RDF.Graph . new ( [ ...&gt; { ~I&lt;http://example.com/S1&gt; , ~I&lt;http://example.com/p&gt; , ~L&quot;Foo&quot; } , ...&gt; { ~I&lt;http://example.com/S2&gt; , ~I&lt;http://example.com/p&gt; , RDF.XSD . integer ( 42 ) } ...&gt; ] ) ...&gt; |&gt; RDF.Graph . map ( fn ...&gt; { :predicate , predicate } -&gt; ...&gt; predicate ...&gt; |&gt; to_string ( ) ...&gt; |&gt; String . split ( &quot;/&quot; ) ...&gt; |&gt; List . last ( ) ...&gt; |&gt; String . to_atom ( ) ...&gt; { _ , term } -&gt; ...&gt; RDF.Term . value ( term ) ...&gt; end ) %{ &quot;http://example.com/S1&quot; =&gt; %{ p : [ &quot;Foo&quot; ] } , &quot;http://example.com/S2&quot; =&gt; %{ p : [ 42 ] } }","ref":"RDF.Graph.html#map/2","title":"RDF.Graph.map/2","type":"function"},{"doc":"Returns the graph name IRI of graph .","ref":"RDF.Graph.html#name/1","title":"RDF.Graph.name/1","type":"function"},{"doc":"Creates an empty unnamed RDF.Graph .","ref":"RDF.Graph.html#new/0","title":"RDF.Graph.new/0","type":"function"},{"doc":"Creates an RDF.Graph . If a keyword list with options is given an empty graph is created. Otherwise an unnamed graph initialized with the given data is created. See new/2 for available arguments and the different ways to provide data. Examples RDF.Graph . new ( name : EX.GraphName ) RDF.Graph . new ( init : { EX.S , EX . p , EX.O } ) RDF.Graph . new ( { EX.S , EX . p , EX.O } )","ref":"RDF.Graph.html#new/1","title":"RDF.Graph.new/1","type":"function"},{"doc":"Creates an RDF.Graph initialized with data. The initial RDF triples can be provided as a single statement tuple a nested subject-predicate-object map a RDF.Description a RDF.Graph a RDF.Dataset or a list with any combination of the former Available options: name : the name of the graph to be created prefixes : some prefix mappings which should be stored alongside the graph and will be used for example when serializing in a format with prefix support base_iri : a base IRI which should be stored alongside the graph and will be used for example when serializing in a format with base IRI support init : some data with which the graph should be initialized; the data can be provided in any form accepted by add/3 and above that also with a function returning the initialization data in any of these forms Examples RDF.Graph . new ( { EX.S , EX . p , EX.O } ) RDF.Graph . new ( { EX.S , EX . p , EX.O } , name : EX.GraphName ) RDF.Graph . new ( { EX.S , EX . p , [ EX.O1 , EX.O2 ] } ) RDF.Graph . new ( [ { EX.S1 , EX . p1 , EX.O1 } , { EX.S2 , EX . p2 , EX.O2 } ] ) RDF.Graph . new ( RDF.Description . new ( EX.S , EX.P , EX.O ) ) RDF.Graph . new ( [ graph , description , triple ] ) RDF.Graph . new ( { EX.S , EX . p , EX.O } , name : EX.GraphName , base_iri : EX . base )","ref":"RDF.Graph.html#new/2","title":"RDF.Graph.new/2","type":"function"},{"doc":"The set of all resources used in the objects within a RDF.Graph . Note: This function does collect only IRIs and BlankNodes, not Literals. Examples iex&gt; RDF.Graph . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S3 , EX . p1 , EX.O2 } , ...&gt; { EX.S4 , EX . p2 , RDF . bnode ( :bnode ) } , ...&gt; { EX.S5 , EX . p3 , &quot;foo&quot; } ] ) ...&gt; |&gt; RDF.Graph . objects ( ) MapSet . new ( [ RDF . iri ( EX.O1 ) , RDF . iri ( EX.O2 ) , RDF . bnode ( :bnode ) ] )","ref":"RDF.Graph.html#objects/1","title":"RDF.Graph.objects/1","type":"function"},{"doc":"Pops an arbitrary triple from a RDF.Graph .","ref":"RDF.Graph.html#pop/1","title":"RDF.Graph.pop/1","type":"function"},{"doc":"Pops the description of the given subject. When the subject can not be found the optionally given default value or nil is returned. Examples iex&gt; RDF.Graph . new ( [ { EX.S1 , EX.P1 , EX.O1 } , { EX.S2 , EX.P2 , EX.O2 } ] ) ...&gt; |&gt; RDF.Graph . pop ( EX.S1 ) { RDF.Description . new ( EX.S1 , init : { EX.P1 , EX.O1 } ) , RDF.Graph . new ( { EX.S2 , EX.P2 , EX.O2 } ) } iex&gt; RDF.Graph . new ( { EX.S , EX.P , EX.O } ) |&gt; RDF.Graph . pop ( EX.Missing ) { nil , RDF.Graph . new ( { EX.S , EX.P , EX.O } ) }","ref":"RDF.Graph.html#pop/2","title":"RDF.Graph.pop/2","type":"function"},{"doc":"The set of all properties used in the predicates of the statements within a RDF.Graph . Examples iex&gt; RDF.Graph . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 } ] ) ...&gt; |&gt; RDF.Graph . predicates ( ) MapSet . new ( [ EX . p1 , EX . p2 ] )","ref":"RDF.Graph.html#predicates/1","title":"RDF.Graph.predicates/1","type":"function"},{"doc":"Returns the prefixes of the given graph as a RDF.PrefixMap .","ref":"RDF.Graph.html#prefixes/1","title":"RDF.Graph.prefixes/1","type":"function"},{"doc":"Adds statements to a RDF.Graph overwriting existing statements with the subjects given in the input data. When the statements to be added are given as another RDF.Graph , the prefixes of this graph will be added. In case of conflicting prefix mappings the original prefix from graph will be kept. RDF-star annotations to be added to all of the given statements can be specified with the :add_annotations , :put_annotations or :put_annotation_properties keyword options. They have different addition semantics similar to the add_annotations/3 , put_annotations/3 and put_annotation_properties/3 counterparts. What should happen with the annotations of statements which got deleted during the overwrite, can be controlled with these keyword options: :delete_annotations_on_deleted : deletes all or some annotations of the deleted statements (see delete_annotations/3 on possible values) :add_annotations_on_deleted , :put_annotations_on_deleted , :put_annotation_properties_on_deleted : add annotations about the deleted statements with the respective addition semantics similar to the keyword options with the _on_deleted suffix mentioned above Examples iex&gt; RDF.Graph . new ( [ { EX.S1 , EX.P1 , EX.O1 } , { EX.S2 , EX.P2 , EX.O2 } ] ) ...&gt; |&gt; RDF.Graph . put ( [ { EX.S1 , EX.P3 , EX.O3 } ] ) RDF.Graph . new ( [ { EX.S1 , EX.P3 , EX.O3 } , { EX.S2 , EX.P2 , EX.O2 } ] )","ref":"RDF.Graph.html#put/3","title":"RDF.Graph.put/3","type":"function"},{"doc":"Adds RDF-star annotations to the given set of statements overwriting all existing annotations with the given properties. The set of statements can be given in any input form (see add/3 ). The predicate-objects pairs to be added as annotations can be given as a tuple, a list of tuples or a map.","ref":"RDF.Graph.html#put_annotation_properties/3","title":"RDF.Graph.put_annotation_properties/3","type":"function"},{"doc":"Adds RDF-star annotations to the given set of statements overwriting all existing annotations. The set of statements can be given in any input form (see add/3 ). The predicate-objects pairs to be added as annotations can be given as a tuple, a list of tuples or a map.","ref":"RDF.Graph.html#put_annotations/3","title":"RDF.Graph.put_annotations/3","type":"function"},{"doc":"Adds statements to a RDF.Graph and overwrites all existing statements with the same subject-predicate combinations given in the input data. When the statements to be added are given as another RDF.Graph , the prefixes of this graph will be added. In case of conflicting prefix mappings the original prefix from graph will be kept. RDF-star annotations to be added to all of the given statements can be specified with the :add_annotations , :put_annotations or :put_annotation_properties keyword options. They have different addition semantics similar to the add_annotations/3 , put_annotations/3 and put_annotation_properties/3 counterparts. What should happen with the annotations of statements which got deleted during the overwrite, can be controlled with these keyword options: :delete_annotations_on_deleted : deletes all or some annotations of the deleted statements (see delete_annotations/3 on possible values) :add_annotations_on_deleted , :put_annotations_on_deleted , :put_annotation_properties_on_deleted : add annotations about the deleted statements with the respective addition semantics similar to the keyword options with the _on_deleted suffix mentioned above Examples iex&gt; RDF.Graph . new ( [ { EX.S1 , EX.P1 , EX.O1 } , { EX.S2 , EX.P2 , EX.O2 } ] ) ...&gt; |&gt; RDF.Graph . put_properties ( [ { EX.S1 , EX.P2 , EX.O3 } , { EX.S2 , EX.P2 , EX.O3 } ] ) RDF.Graph . new ( [ { EX.S1 , EX.P1 , EX.O1 } , { EX.S1 , EX.P2 , EX.O3 } , { EX.S2 , EX.P2 , EX.O3 } ] )","ref":"RDF.Graph.html#put_properties/3","title":"RDF.Graph.put_properties/3","type":"function"},{"doc":"Execute the given query against the given graph . This is just a convenience delegator function to RDF.Query.execute!/3 with the first two arguments swapped so it can be used in a pipeline on a RDF.Graph . See RDF.Query.execute/3 and RDF.Query.execute!/3 for more information and examples.","ref":"RDF.Graph.html#query/3","title":"RDF.Graph.query/3","type":"function"},{"doc":"Returns a Stream for the execution of the given query against the given graph . This is just a convenience delegator function to RDF.Query.stream!/3 with the first two arguments swapped so it can be used in a pipeline on a RDF.Graph . See RDF.Query.stream/3 and RDF.Query.stream!/3 for more information and examples.","ref":"RDF.Graph.html#query_stream/3","title":"RDF.Graph.query_stream/3","type":"function"},{"doc":"The set of all resources used within a RDF.Graph . Examples iex&gt; RDF.Graph . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 } , ...&gt; { EX.S2 , EX . p1 , EX.O2 } , ...&gt; { EX.S2 , EX . p2 , RDF . bnode ( :bnode ) } , ...&gt; { EX.S3 , EX . p1 , &quot;foo&quot; } ] ) ...&gt; |&gt; RDF.Graph . resources ( ) MapSet . new ( [ RDF . iri ( EX.S1 ) , RDF . iri ( EX.S2 ) , RDF . iri ( EX.S3 ) , RDF . iri ( EX.O1 ) , RDF . iri ( EX.O2 ) , RDF . bnode ( :bnode ) , EX . p1 , EX . p2 ] )","ref":"RDF.Graph.html#resources/1","title":"RDF.Graph.resources/1","type":"function"},{"doc":"Sets the base IRI of the given graph . The base_iri can be given as anything accepted by RDF.IRI.coerce_base/1 .","ref":"RDF.Graph.html#set_base_iri/2","title":"RDF.Graph.set_base_iri/2","type":"function"},{"doc":"The number of statements within a RDF.Graph . Examples iex&gt; RDF.Graph . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 } ] ) ...&gt; |&gt; RDF.Graph . statement_count ( ) 3","ref":"RDF.Graph.html#statement_count/1","title":"RDF.Graph.statement_count/1","type":"function"},{"doc":"See RDF.Graph.triples/2 .","ref":"RDF.Graph.html#statements/2","title":"RDF.Graph.statements/2","type":"function"},{"doc":"The number of subjects within a RDF.Graph . Examples iex&gt; RDF.Graph . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 } ] ) ...&gt; |&gt; RDF.Graph . subject_count ( ) 2","ref":"RDF.Graph.html#subject_count/1","title":"RDF.Graph.subject_count/1","type":"function"},{"doc":"The set of all subjects used in the statements within a RDF.Graph . Examples iex&gt; RDF.Graph . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 } ] ) ...&gt; |&gt; RDF.Graph . subjects ( ) MapSet . new ( [ RDF . iri ( EX.S1 ) , RDF . iri ( EX.S2 ) ] )","ref":"RDF.Graph.html#subjects/1","title":"RDF.Graph.subjects/1","type":"function"},{"doc":"Creates a graph from another one by limiting its statements to those using one of the given subjects . If subjects contains IRIs that are not used in the graph , they're simply ignored. The optional properties argument allows to limit also properties of the subject descriptions. If nil is passed as the subjects , the subjects will not be limited.","ref":"RDF.Graph.html#take/3","title":"RDF.Graph.take/3","type":"function"},{"doc":"See RDF.Graph.statement_count/1 .","ref":"RDF.Graph.html#triple_count/1","title":"RDF.Graph.triple_count/1","type":"function"},{"doc":"The list of all statements within a RDF.Graph . When the optional :filter_star flag is set to true RDF-star triples with a triple as subject or object will be filtered. The default value is false . Examples iex&gt; RDF.Graph . new ( [ ...&gt; { EX.S1 , EX . p1 , EX.O1 } , ...&gt; { EX.S2 , EX . p2 , EX.O2 } , ...&gt; { EX.S1 , EX . p2 , EX.O3 } ] ) ...&gt; |&gt; RDF.Graph . triples ( ) [ { RDF . iri ( EX.S1 ) , RDF . iri ( EX . p1 ) , RDF . iri ( EX.O1 ) } , { RDF . iri ( EX.S1 ) , RDF . iri ( EX . p2 ) , RDF . iri ( EX.O3 ) } , { RDF . iri ( EX.S2 ) , RDF . iri ( EX . p2 ) , RDF . iri ( EX.O2 ) } ]","ref":"RDF.Graph.html#triples/2","title":"RDF.Graph.triples/2","type":"function"},{"doc":"Updates the description of the subject in graph with the given function. If subject is present in graph with description as description, fun is invoked with argument description and its result is used as the new description of subject . If subject is not present in graph , initial is inserted as the description of subject . If no initial value is given, the graph remains unchanged. If nil is returned by fun , the respective description will be removed from graph . The initial value and the returned objects by the update function will be tried te coerced to proper RDF descriptions before added. If the initial or returned description is a RDF.Description with another subject, the respective statements are added with subject as subject. Examples iex&gt; RDF.Graph . new ( { EX.S , EX . p , EX.O } ) ...&gt; |&gt; RDF.Graph . update ( EX.S , ...&gt; fn description -&gt; Description . add ( description , { EX . p , EX.O2 } ) ...&gt; end ) RDF.Graph . new ( [ { EX.S , EX . p , EX.O } , { EX.S , EX . p , EX.O2 } ] ) iex&gt; RDF.Graph . new ( { EX.S , EX . p , EX.O } ) ...&gt; |&gt; RDF.Graph . update ( EX.S , ...&gt; fn _ -&gt; Description . new ( EX.S2 , init : { EX . p2 , EX.O2 } ) ...&gt; end ) RDF.Graph . new ( [ { EX.S , EX . p2 , EX.O2 } ] ) iex&gt; RDF.Graph . new ( ) ...&gt; |&gt; RDF.Graph . update ( EX.S , Description . new ( EX.S , init : { EX . p , EX.O } ) , ...&gt; fn description -&gt; Description . add ( description , { EX . p , EX.O2 } ) ...&gt; end ) RDF.Graph . new ( [ { EX.S , EX . p , EX.O } ] )","ref":"RDF.Graph.html#update/4","title":"RDF.Graph.update/4","type":"function"},{"doc":"Returns a nested map of the native Elixir values of a RDF.Graph . When a :context option is given with a RDF.PropertyMap , predicates will be mapped to the terms defined in the RDF.PropertyMap , if present. Examples iex&gt; RDF.Graph . new ( [ ...&gt; { ~I&lt;http://example.com/S1&gt; , ~I&lt;http://example.com/p&gt; , ~L&quot;Foo&quot; } , ...&gt; { ~I&lt;http://example.com/S2&gt; , ~I&lt;http://example.com/p&gt; , RDF.XSD . integer ( 42 ) } ...&gt; ] ) ...&gt; |&gt; RDF.Graph . values ( ) %{ &quot;http://example.com/S1&quot; =&gt; %{ &quot;http://example.com/p&quot; =&gt; [ &quot;Foo&quot; ] } , &quot;http://example.com/S2&quot; =&gt; %{ &quot;http://example.com/p&quot; =&gt; [ 42 ] } } iex&gt; RDF.Graph . new ( [ ...&gt; { ~I&lt;http://example.com/S1&gt; , ~I&lt;http://example.com/p&gt; , ~L&quot;Foo&quot; } , ...&gt; { ~I&lt;http://example.com/S2&gt; , ~I&lt;http://example.com/p&gt; , RDF.XSD . integer ( 42 ) } ...&gt; ] ) ...&gt; |&gt; RDF.Graph . values ( context : [ p : ~I&lt;http://example.com/p&gt; ] ) %{ &quot;http://example.com/S1&quot; =&gt; %{ p : [ &quot;Foo&quot; ] } , &quot;http://example.com/S2&quot; =&gt; %{ p : [ 42 ] } }","ref":"RDF.Graph.html#values/2","title":"RDF.Graph.values/2","type":"function"},{"doc":"Returns the RDF.Graph without all annotations. Note: This function excludes only triples where the subject is a quoted triple. If you want to exclude also triples where the object is a quoted triple, you'll have to use RDF.Graph.without_star_statements/1 .","ref":"RDF.Graph.html#without_annotations/1","title":"RDF.Graph.without_annotations/1","type":"function"},{"doc":"Returns the RDF.Graph without all statements including quoted triples on subject or object position. This function is relatively costly, since it requires a full walk-through of all triples. In many cases quoted triples are only used on subject position, where you can use the significantly faster RDF.Graph.without_annotations/1 .","ref":"RDF.Graph.html#without_star_statements/1","title":"RDF.Graph.without_star_statements/1","type":"function"},{"doc":"","ref":"RDF.Graph.html#t:get_and_update_description_fun/0","title":"RDF.Graph.get_and_update_description_fun/0","type":"type"},{"doc":"","ref":"RDF.Graph.html#t:graph_description/0","title":"RDF.Graph.graph_description/0","type":"type"},{"doc":"","ref":"RDF.Graph.html#t:input/0","title":"RDF.Graph.input/0","type":"type"},{"doc":"","ref":"RDF.Graph.html#t:t/0","title":"RDF.Graph.t/0","type":"type"},{"doc":"","ref":"RDF.Graph.html#t:update_description_fun/0","title":"RDF.Graph.update_description_fun/0","type":"type"},{"doc":"","ref":"RDF.Graph.Builder.html","title":"RDF.Graph.Builder","type":"module"},{"doc":"","ref":"RDF.Graph.Builder.html#build/2","title":"RDF.Graph.Builder.build/2","type":"function"},{"doc":"","ref":"RDF.Graph.Builder.Helper.html","title":"RDF.Graph.Builder.Helper","type":"module"},{"doc":"See RDF.NS.RDF.type/0 .","ref":"RDF.Graph.Builder.Helper.html#a/0","title":"RDF.Graph.Builder.Helper.a/0","type":"function"},{"doc":"See RDF.NS.RDF.type/2 .","ref":"RDF.Graph.Builder.Helper.html#a/2","title":"RDF.Graph.Builder.Helper.a/2","type":"function"},{"doc":"See RDF.NS.RDF.type/3 .","ref":"RDF.Graph.Builder.Helper.html#a/3","title":"RDF.Graph.Builder.Helper.a/3","type":"function"},{"doc":"See RDF.NS.RDF.type/4 .","ref":"RDF.Graph.Builder.Helper.html#a/4","title":"RDF.Graph.Builder.Helper.a/4","type":"function"},{"doc":"See RDF.NS.RDF.type/5 .","ref":"RDF.Graph.Builder.Helper.html#a/5","title":"RDF.Graph.Builder.Helper.a/5","type":"function"},{"doc":"See RDF.NS.RDF.type/6 .","ref":"RDF.Graph.Builder.Helper.html#a/6","title":"RDF.Graph.Builder.Helper.a/6","type":"function"},{"doc":"","ref":"RDF.Graph.Builder.Helper.html#exclude/1","title":"RDF.Graph.Builder.Helper.exclude/1","type":"function"},{"doc":"A collection of guards.","ref":"RDF.Guards.html","title":"RDF.Guards","type":"module"},{"doc":"Returns if the given value is a quad, i.e. a tuple with four elements.","ref":"RDF.Guards.html#is_quad/1","title":"RDF.Guards.is_quad/1","type":"macro"},{"doc":"Returns if the given value is a triple or a quad in terms of is_triple/1 and is_quad/1 .","ref":"RDF.Guards.html#is_statement/1","title":"RDF.Guards.is_statement/1","type":"macro"},{"doc":"Returns if the given value is a triple, i.e. a tuple with three elements.","ref":"RDF.Guards.html#is_triple/1","title":"RDF.Guards.is_triple/1","type":"macro"},{"doc":"Returns if the given value is an atom which could potentially be an RDF.Vocabulary.Namespace term.","ref":"RDF.Guards.html#maybe_ns_term/1","title":"RDF.Guards.maybe_ns_term/1","type":"macro"},{"doc":"A structure for IRIs. This structure just wraps a plain IRI string and doesn't bother with the components of the IRI, since in the context of RDF there are usually very many IRIs and parsing them isn't needed in most cases. For these reasons we don't use Elixirs built-in URI structure, because it would be unnecessary expensive in terms of performance and memory. The component parts can always be retrieved with the RDF.IRI.parse/1 function, which returns Elixirs built-in URI structure. Note, that URI doesn't escape Unicode characters by default, so it's a suitable structure for IRIs. see https://tools.ietf.org/html/rfc3987","ref":"RDF.IRI.html","title":"RDF.IRI","type":"module"},{"doc":"Resolves a relative IRI against a base IRI. as specified in section 5.1 Establishing a Base URI of RFC3986 . Only the basic algorithm in section 5.2 of RFC3986 is used; neither Syntax-Based Normalization nor Scheme-Based Normalization are performed. Characters additionally allowed in IRI references are treated in the same way that unreserved characters are treated in URI references, per section 6.5 of RFC3987 If the given base is not an absolute IRI nil is returned.","ref":"RDF.IRI.html#absolute/2","title":"RDF.IRI.absolute/2","type":"function"},{"doc":"Checks if the given value is an absolute IRI. An absolute IRI is defined in RFC3987 containing a scheme along with a path and optional query and fragment segments.","ref":"RDF.IRI.html#absolute?/1","title":"RDF.IRI.absolute?/1","type":"function"},{"doc":"Appends a String to a RDF.IRI . Example iex&gt; ~I&lt;http://example.com/&gt; |&gt; RDF.IRI . append ( &quot;foo&quot; ) ~I&lt;http://example.com/foo&gt; iex&gt; EX . foo |&gt; RDF.IRI . append ( &quot;bar&quot; ) EX . foobar iex&gt; EX.Foo |&gt; RDF.IRI . append ( &quot;bar&quot; ) RDF . iri ( EX.Foobar )","ref":"RDF.IRI.html#append/2","title":"RDF.IRI.append/2","type":"function"},{"doc":"Coerces an IRI serving as a base IRI. As opposed to new/1 this also accepts bare RDF.Vocabulary.Namespace modules and uses the base IRI from their definition.","ref":"RDF.IRI.html#coerce_base/1","title":"RDF.IRI.coerce_base/1","type":"function"},{"doc":"The default base IRI to be used when reading a serialization and no base_iri option is provided. The value can be set via the default_base_iri configuration. For example: config :rdf , default_base_iri : &quot;http://my_app.example/&quot; You can also set :default_base_iri to a module-function tuple {mod, fun} with a function which should be called to determine the default base IRI. See section 5.1.4 of RFC 3987","ref":"RDF.IRI.html#default_base/0","title":"RDF.IRI.default_base/0","type":"function"},{"doc":"Tests for value equality of IRIs. Returns nil when the given arguments are not comparable as IRIs. see https://www.w3.org/TR/rdf-concepts/#section-Graph-URIref","ref":"RDF.IRI.html#equal_value?/2","title":"RDF.IRI.equal_value?/2","type":"function"},{"doc":"Checks whether iri lies in namespace . Examples iex&gt; RDF.IRI . in_namespace? ( ~I&lt;http://example.com/foo&gt; , ~I&lt;http://example.com/&gt; ) true iex&gt; RDF.IRI . in_namespace? ( ~I&lt;http://example.com/foo/bar&gt; , &quot;http://example.com/&quot; ) true iex&gt; RDF.IRI . in_namespace? ( ~I&lt;http://example.com/#foo&gt; , EX ) true","ref":"RDF.IRI.html#in_namespace?/2","title":"RDF.IRI.in_namespace?/2","type":"function"},{"doc":"Merges two IRIs. This function merges two IRIs as per RFC 3986, section 5.2 .","ref":"RDF.IRI.html#merge/2","title":"RDF.IRI.merge/2","type":"function"},{"doc":"Creates a RDF.IRI , but checks if the given IRI is valid. If the given IRI is not valid a RDF.IRI.InvalidError is raised. see valid?/1","ref":"RDF.IRI.html#new!/1","title":"RDF.IRI.new!/1","type":"function"},{"doc":"Creates a RDF.IRI .","ref":"RDF.IRI.html#new/1","title":"RDF.IRI.new/1","type":"function"},{"doc":"Parses an IRI into its components and returns them as an URI struct.","ref":"RDF.IRI.html#parse/1","title":"RDF.IRI.parse/1","type":"function"},{"doc":"Returns the scheme of the given IRI If the given string is not a valid absolute IRI, nil is returned. Examples iex&gt; RDF.IRI . scheme ( &quot;http://www.example.com/foo&quot; ) &quot;http&quot; iex&gt; RDF.IRI . scheme ( &quot;not an iri&quot; ) nil","ref":"RDF.IRI.html#scheme/1","title":"RDF.IRI.scheme/1","type":"function"},{"doc":"Returns the given IRI as a string. Note that this function can also handle RDF.Vocabulary.Namespace terms. Examples iex&gt; RDF.IRI . to_string RDF.IRI . new ( &quot;http://example.com/#foo&quot; ) &quot;http://example.com/#foo&quot; iex&gt; RDF.IRI . to_string EX . foo &quot;http://example.com/#foo&quot; iex&gt; RDF.IRI . to_string EX.Foo &quot;http://example.com/#Foo&quot;","ref":"RDF.IRI.html#to_string/1","title":"RDF.IRI.to_string/1","type":"function"},{"doc":"Returns the given value unchanged if it's a valid IRI, otherwise raises an exception. Examples iex&gt; RDF.IRI . valid! ( &quot;http://www.example.com/foo&quot; ) &quot;http://www.example.com/foo&quot; iex&gt; RDF.IRI . valid! ( RDF.IRI . new ( &quot;http://www.example.com/foo&quot; ) ) RDF.IRI . new ( &quot;http://www.example.com/foo&quot; ) iex&gt; RDF.IRI . valid! ( &quot;not an iri&quot; ) ** (RDF.IRI.InvalidError) Invalid IRI: &quot;not an iri&quot;","ref":"RDF.IRI.html#valid!/1","title":"RDF.IRI.valid!/1","type":"function"},{"doc":"Checks if the given IRI is valid. Note: This currently checks only if the given IRI is absolute. Examples iex&gt; RDF.IRI . valid? ( &quot;http://www.example.com/foo&quot; ) true iex&gt; RDF.IRI . valid? ( &quot;not an iri&quot; ) false","ref":"RDF.IRI.html#valid?/1","title":"RDF.IRI.valid?/1","type":"function"},{"doc":"","ref":"RDF.IRI.html#t:coercible/0","title":"RDF.IRI.coercible/0","type":"type"},{"doc":"","ref":"RDF.IRI.html#t:t/0","title":"RDF.IRI.t/0","type":"type"},{"doc":"A RDF.Resource.Generator for various kinds of UUID-based IRI identifiers. This generator is only available when you have defined the elixir_uuid package as dependency in the Mixfile of your application. Configuration options :prefix : The URI prefix to be prepended to the generated UUID. It can be given also as RDF.Vocabulary.Namespace module. If the :uuid_format is set explicitly to something other than :urn (which is the default), this is a required parameter. :uuid_version : The UUID version to be used. Can be any of the integers 1 and 4 for random-based identifiers (4 being the default) and 3 and 5 for value-based identifiers (5 being the default). :uuid_format : The format of the UUID to be generated. Can be any of the following atoms: :urn : a standard UUID representation, prefixed with the UUID URN (in this case the :prefix is not used) (the default when no :prefix given) :default : a standard UUID representation, appended to the :prefix value (the default when a :prefix is given) :hex : a standard UUID without the - (dash) characters, appended to the :prefix value :uuid_namespace (only with :uuid_version 3 and 5, where it is a required parameter) When your generator configuration is just for a function producing one of the two kinds of identifiers, you can use these options directly. Otherwise you must provide the identifier-specific configuration under one of the keys :random_based and :value_based . Example configuration config :example , :id , generator : RDF.IRI.UUID.Generator , prefix : &quot;http://example.com/&quot; , uuid_format : :hex , random_based : [ uuid_version : 1 ] , value_based : [ uuid_version : 3 , uuid_namespace : UUID . uuid5 ( :url , &quot;http://your.application.com/example&quot; ) ]","ref":"RDF.IRI.UUID.Generator.html","title":"RDF.IRI.UUID.Generator","type":"module"},{"doc":"RDF.Literal.Datatype for rdf:langString s.","ref":"RDF.LangString.html","title":"RDF.LangString","type":"module"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.LangString.html#canonical_lexical/1","title":"RDF.LangString.canonical_lexical/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.LangString.html#cast/1","title":"RDF.LangString.cast/1","type":"function"},{"doc":"","ref":"RDF.LangString.html#compare/2","title":"RDF.LangString.compare/2","type":"function"},{"doc":"Checks if the given literal has this datatype.","ref":"RDF.LangString.html#datatype?/1","title":"RDF.LangString.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.LangString.html#equal_value?/2","title":"RDF.LangString.equal_value?/2","type":"function"},{"doc":"Checks if a language tagged string literal or language tag matches a language range. The check is performed per the basic filtering scheme defined in RFC4647 section 3.3.1. A language range is a basic language range per Matching of Language Tags in RFC4647 section 2.1. A language range of &quot;*&quot; matches any non-empty language-tag string. see https://www.w3.org/TR/sparql11-query/#func-langMatches","ref":"RDF.LangString.html#match_language?/2","title":"RDF.LangString.match_language?/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value and language .","ref":"RDF.LangString.html#new/2","title":"RDF.LangString.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.LangString.html#update/3","title":"RDF.LangString.update/3","type":"function"},{"doc":"","ref":"RDF.LangString.html#t:t/0","title":"RDF.LangString.t/0","type":"type"},{"doc":"A structure for RDF lists. see https://www.w3.org/TR/rdf-schema/#ch_collectionvocab https://www.w3.org/TR/rdf11-mt/#rdf-collections","ref":"RDF.List.html","title":"RDF.List","type":"module"},{"doc":"Checks if a list is the empty list.","ref":"RDF.List.html#empty?/1","title":"RDF.List.empty?/1","type":"function"},{"doc":"Creates a RDF.List from a native Elixir list or any other Enumerable with coercible RDF values. By default the statements constituting the Enumerable are added to an empty graph. An already existing graph to which the statements are added can be specified with the graph option. The name of the head node can be specified with the head option (default: RDF.bnode() , i.e. an arbitrary unique name). Note: When the given Enumerable is empty, the name option will be ignored - the head node of the empty list is always RDF.nil .","ref":"RDF.List.html#from/2","title":"RDF.List.from/2","type":"function"},{"doc":"Creates a RDF.List for a given RDF list node of a given RDF.Graph . If the given node does not refer to a well-formed list in the graph, nil is returned. A well-formed list consists of list nodes which have exactly one rdf:first and rdf:rest statement each does not contain cycles, i.e. rdf:rest statements don't refer to preceding list nodes","ref":"RDF.List.html#new/2","title":"RDF.List.new/2","type":"function"},{"doc":"Checks if the given RDF.Description describes a RDF list node.","ref":"RDF.List.html#node?/1","title":"RDF.List.node?/1","type":"function"},{"doc":"Checks if a given resource is a RDF list node in a given RDF.Graph . Although, technically a resource is a list, if it uses at least one rdf:first or rdf:rest , we pragmatically require the usage of both. Note: This function doesn't indicate if the list is valid. See new/2 and valid?/2 for validations.","ref":"RDF.List.html#node?/2","title":"RDF.List.node?/2","type":"function"},{"doc":"The RDF nodes constituting a RDF.List as an Elixir list.","ref":"RDF.List.html#nodes/1","title":"RDF.List.nodes/1","type":"function"},{"doc":"Checks if the given list consists of list nodes which are all blank nodes.","ref":"RDF.List.html#valid?/1","title":"RDF.List.valid?/1","type":"function"},{"doc":"The values of a RDF.List as an Elixir list. Nested lists are converted recursively.","ref":"RDF.List.html#values/1","title":"RDF.List.values/1","type":"function"},{"doc":"","ref":"RDF.List.html#t:t/0","title":"RDF.List.t/0","type":"type"},{"doc":"RDF literals are leaf nodes of a RDF graph containing raw data, like strings, numbers etc. A literal is a struct consisting of a literal field holding either a RDF.Literal.Datatype struct for the respective known datatype of the literal or a RDF.Literal.Generic struct if the datatype is unknown, i.e. has no RDF.Literal.Datatype implementation.","ref":"RDF.Literal.html","title":"RDF.Literal","type":"module"},{"doc":"Transforms the given literal into its canonical form.","ref":"RDF.Literal.html#canonical/1","title":"RDF.Literal.canonical/1","type":"function"},{"doc":"Returns the canonical lexical of the given literal .","ref":"RDF.Literal.html#canonical_lexical/1","title":"RDF.Literal.canonical_lexical/1","type":"function"},{"doc":"Returns if the lexical of the given literal has the canonical form.","ref":"RDF.Literal.html#canonical?/1","title":"RDF.Literal.canonical?/1","type":"function"},{"doc":"Coerces a new RDF.Literal from another value. The following mapping of Elixir types to XSD datatypes is applied: Elixir datatype XSD datatype string xsd:string boolean xsd:boolean integer xsd:integer float xsd:double Decimal xsd:decimal Time xsd:time Date xsd:date DateTime xsd:dateTime NaiveDateTime xsd:dateTime URI xsd:AnyURI When an RDF.Literal can not be coerced, nil is returned (as opposed to new/1 which fails in this case). Examples iex&gt; RDF.Literal . coerce ( 42 ) % RDF.Literal { literal : % RDF.XSD.Integer { value : 42 } }","ref":"RDF.Literal.html#coerce/1","title":"RDF.Literal.coerce/1","type":"function"},{"doc":"","ref":"RDF.Literal.html#compare/2","title":"RDF.Literal.compare/2","type":"function"},{"doc":"Returns the IRI of datatype of the given literal .","ref":"RDF.Literal.html#datatype_id/1","title":"RDF.Literal.datatype_id/1","type":"function"},{"doc":"Returns if the given value is a RDF.Literal or RDF.Literal.Datatype struct. If you simply want to check for a RDF.Literal use pattern matching or RDF.literal?/1 . This function is a bit slower than those and most of the time only needed when implementing RDF.Literal.Datatype s where you have to deal with the raw, i.e. unwrapped RDF.Literal.Datatype structs.","ref":"RDF.Literal.html#datatype?/1","title":"RDF.Literal.datatype?/1","type":"function"},{"doc":"Checks if two literals have equal values.","ref":"RDF.Literal.html#equal_value?/2","title":"RDF.Literal.equal_value?/2","type":"function"},{"doc":"Checks if two literals are equal. Two literals are equal if they have the same datatype, value and lexical form.","ref":"RDF.Literal.html#equal?/2","title":"RDF.Literal.equal?/2","type":"function"},{"doc":"Returns if the literal uses the RDF.Literal.Generic datatype or on of the dedicated builtin or custom RDF.Literal.Datatype s.","ref":"RDF.Literal.html#generic?/1","title":"RDF.Literal.generic?/1","type":"function"},{"doc":"Checks if the first of two RDF.Literal s is greater then the other.","ref":"RDF.Literal.html#greater_than?/2","title":"RDF.Literal.greater_than?/2","type":"function"},{"doc":"Returns if a literal is a datatyped literal. For historical reasons, this excludes xsd:string and rdf:langString . see http://www.w3.org/TR/rdf-concepts/#dfn-typed-literal","ref":"RDF.Literal.html#has_datatype?/1","title":"RDF.Literal.has_datatype?/1","type":"function"},{"doc":"Returns if a literal is a language-tagged literal. see http://www.w3.org/TR/rdf-concepts/#dfn-plain-literal","ref":"RDF.Literal.html#has_language?/1","title":"RDF.Literal.has_language?/1","type":"function"},{"doc":"Checks if 'literal' is literal with the given datatype . datatype can be one of the following: a RDF.Literal.Datatype module which checks if the literal is of this datatype or derived from it RDF.XSD.Numeric which checks if the literal is one of the numeric XSD datatypes or derived of one of them RDF.XSD.Datatype which checks if the literal is a XSD datatype or derived of one of them","ref":"RDF.Literal.html#is_a?/2","title":"RDF.Literal.is_a?/2","type":"function"},{"doc":"Returns the language of the given literal if present.","ref":"RDF.Literal.html#language/1","title":"RDF.Literal.language/1","type":"function"},{"doc":"Checks if the first of two RDF.Literal s is smaller then the other.","ref":"RDF.Literal.html#less_than?/2","title":"RDF.Literal.less_than?/2","type":"function"},{"doc":"Returns the lexical form of the given literal .","ref":"RDF.Literal.html#lexical/1","title":"RDF.Literal.lexical/1","type":"function"},{"doc":"Matches the lexical form of the given RDF.Literal against a XPath and XQuery regular expression pattern with flags. The regular expression language is defined in XQuery 1.0 and XPath 2.0 Functions and Operators . see https://www.w3.org/TR/xpath-functions/#func-matches","ref":"RDF.Literal.html#matches?/3","title":"RDF.Literal.matches?/3","type":"function"},{"doc":"Creates a new RDF.Literal , but fails if it's not valid. Note: Validation is only possible if an RDF.Datatype with an implementation of RDF.Datatype.valid?/1 exists. Examples iex&gt; RDF.Literal . new ( &quot;foo&quot; ) % RDF.Literal { literal : % RDF.XSD.String { value : &quot;foo&quot; } } iex&gt; RDF.Literal . new! ( &quot;foo&quot; , datatype : RDF.NS.XSD . integer ) ** (RDF.Literal.InvalidError) invalid RDF.Literal: %RDF.Literal{literal: %RDF.XSD.Integer{value: nil, lexical: &quot;foo&quot;}, valid: false} iex&gt; RDF.Literal . new! ( &quot;foo&quot; , datatype : RDF . langString ) ** (RDF.Literal.InvalidError) invalid RDF.Literal: %RDF.Literal{literal: %RDF.LangString{language: nil, value: &quot;foo&quot;}, valid: false}","ref":"RDF.Literal.html#new!/2","title":"RDF.Literal.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal of the given value and tries to infer an appropriate XSD datatype. See coerce/1 for applied mapping of Elixir types to XSD datatypes. Note: The RDF.literal function is a shortcut to this function. Examples iex&gt; RDF.Literal . new ( 42 ) % RDF.Literal { literal : % RDF.XSD.Integer { value : 42 } }","ref":"RDF.Literal.html#new/1","title":"RDF.Literal.new/1","type":"function"},{"doc":"Creates a new RDF.Literal with the given datatype or language tag.","ref":"RDF.Literal.html#new/2","title":"RDF.Literal.new/2","type":"function"},{"doc":"Returns if a literal is a plain literal. A plain literal may have a language, but may not have a datatype. For all practical purposes, this includes xsd:string literals too. see http://www.w3.org/TR/rdf-concepts/#dfn-plain-literal","ref":"RDF.Literal.html#plain?/1","title":"RDF.Literal.plain?/1","type":"function"},{"doc":"Returns if a literal is a simple literal. A simple literal has no datatype or language. see http://www.w3.org/TR/sparql11-query/#simple_literal","ref":"RDF.Literal.html#simple?/1","title":"RDF.Literal.simple?/1","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else. The optional second argument allows to specify what will be passed to fun with the :as option, eg. with as: :lexical the lexical is passed to the function. Example iex&gt; RDF.XSD . integer ( 42 ) |&gt; RDF.Literal . update ( fn value -&gt; value + 1 end ) RDF.XSD . integer ( 43 ) iex&gt; ~L&quot;foo&quot;de |&gt; RDF.Literal . update ( fn _ -&gt; &quot;bar&quot; end ) ~L&quot;bar&quot;de iex&gt; RDF . literal ( &quot;foo&quot; , datatype : &quot;http://example.com/dt&quot; ) |&gt; RDF.Literal . update ( fn _ -&gt; &quot;bar&quot; end ) RDF . literal ( &quot;bar&quot; , datatype : &quot;http://example.com/dt&quot; ) iex&gt; RDF.XSD . integer ( 42 ) |&gt; RDF.XSD.Integer . update ( ...&gt; fn value -&gt; value &lt;&gt; &quot;1&quot; end , as : :lexical ) RDF.XSD . integer ( 421 )","ref":"RDF.Literal.html#update/3","title":"RDF.Literal.update/3","type":"function"},{"doc":"Returns if the given literal is valid with respect to its datatype.","ref":"RDF.Literal.html#valid?/1","title":"RDF.Literal.valid?/1","type":"function"},{"doc":"Returns the value of the given literal .","ref":"RDF.Literal.html#value/1","title":"RDF.Literal.value/1","type":"function"},{"doc":"","ref":"RDF.Literal.html#t:t/0","title":"RDF.Literal.t/0","type":"type"},{"doc":"A behaviour for datatypes for RDF.Literal s. An implementation of this behaviour defines a struct for a datatype IRI and the semantics of its values via the functions defined by this behaviour. There are three important groups of RDF.Literal.Datatype implementations: RDF.XSD.Datatype : This is another, more specific behaviour for XSD datatypes. RDF.ex comes with builtin implementations of this behaviour for the most important XSD datatypes, but you define your own custom datatypes by deriving from these builtin datatypes and constraining them via RDF.XSD.Facet s. Non-XSD datatypes which implement the RDF.Literal.Datatype directly: There's currently only one builtin datatype of this category - RDF.LangString for language tagged RDF literals. RDF.Literal.Generic : This is a generic implementation which is used for RDF.Literal s with a datatype that has no own RDF.Literal.Datatype implementation defining its semantics.","ref":"RDF.Literal.Datatype.html","title":"RDF.Literal.Datatype","type":"behaviour"},{"doc":"Produces the canonical representation of a RDF.Literal .","ref":"RDF.Literal.Datatype.html#c:canonical/1","title":"RDF.Literal.Datatype.canonical/1","type":"callback"},{"doc":"Returns the canonical lexical form of a RDF.Literal . If the given literal is invalid, nil is returned.","ref":"RDF.Literal.Datatype.html#c:canonical_lexical/1","title":"RDF.Literal.Datatype.canonical_lexical/1","type":"callback"},{"doc":"Determines if the lexical form of a RDF.Literal is the canonical form. Note: For RDF.Literal.Generic literals with the canonical form not defined, this always returns true .","ref":"RDF.Literal.Datatype.html#c:canonical?/1","title":"RDF.Literal.Datatype.canonical?/1","type":"callback"},{"doc":"The datatype IRI of the given RDF.Literal .","ref":"RDF.Literal.Datatype.html#c:datatype_id/1","title":"RDF.Literal.Datatype.datatype_id/1","type":"callback"},{"doc":"Checks if the given RDF.Literal has the datatype for which the RDF.Literal.Datatype is implemented or is derived from it. Example iex&gt; RDF.XSD . byte ( 42 ) |&gt; RDF.XSD.Integer . datatype? ( ) true","ref":"RDF.Literal.Datatype.html#c:datatype?/1","title":"RDF.Literal.Datatype.datatype?/1","type":"callback"},{"doc":"Callback for datatype specific castings. This callback is called by the auto-generated cast/1 function on the implementations, which already deals with the basic cases. So, implementations can assume the passed argument is a valid RDF.Literal.Datatype struct, a RDF.IRI or a RDF.BlankNode . If the given literal can not be converted into this datatype an implementation should return nil . A final catch-all clause should delegate to super . For example RDF.XSD.Datatype s will handle casting from derived datatypes in the default implementation.","ref":"RDF.Literal.Datatype.html#c:do_cast/1","title":"RDF.Literal.Datatype.do_cast/1","type":"callback"},{"doc":"Callback for datatype specific compare/2 comparisons between two RDF.Literal s. This callback is called by auto-generated compare/2 function on the implementations, which already deals with the basic cases. So, implementations can assume the passed arguments are valid RDF.Literal.Datatype structs and have the same datatypes or are derived from each other. Should return :gt if value of the first literal is greater than the value of the second in terms of their datatype and :lt for vice versa. If the two literals can be considered equal :eq should be returned. For datatypes with only partial ordering :indeterminate should be returned when the order of the given literals is not defined. nil should be returned when the given arguments are not comparable datatypes or if one them is invalid. The default implementation of the _using__ macro of RDF.Literal.Datatype s just compares the values of the given literals.","ref":"RDF.Literal.Datatype.html#c:do_compare/2","title":"RDF.Literal.Datatype.do_compare/2","type":"callback"},{"doc":"Callback for datatype specific equal_value?/2 comparisons when the given literals have different datatypes. This callback is called by auto-generated equal_value?/2 function when the given literals have different datatypes and are not derived from each other. Should return nil when the given arguments are not comparable as literals of this datatype. This behaviour is particularly important for SPARQL.ex where this function is used for the = operator, where comparisons between incomparable terms are treated as errors and immediately leads to a rejection of a possible match. See also do_equal_value_same_or_derived_datatypes?/2 .","ref":"RDF.Literal.Datatype.html#c:do_equal_value_different_datatypes?/2","title":"RDF.Literal.Datatype.do_equal_value_different_datatypes?/2","type":"callback"},{"doc":"Callback for datatype specific equal_value?/2 comparisons when the given literals have the same or derived datatypes. This callback is called by auto-generated equal_value?/2 function when the given literals have the same datatype or one is derived from the other. Should return nil when the given arguments are not comparable as literals of this datatype. This behaviour is particularly important for SPARQL.ex where this function is used for the = operator, where comparisons between incomparable terms are treated as errors and immediately leads to a rejection of a possible match. See also do_equal_value_different_datatypes?/2 .","ref":"RDF.Literal.Datatype.html#c:do_equal_value_same_or_derived_datatypes?/2","title":"RDF.Literal.Datatype.do_equal_value_same_or_derived_datatypes?/2","type":"callback"},{"doc":"Returns the RDF.Literal.Datatype for a datatype IRI.","ref":"RDF.Literal.Datatype.html#get/1","title":"RDF.Literal.Datatype.get/1","type":"function"},{"doc":"The IRI of the datatype.","ref":"RDF.Literal.Datatype.html#c:id/0","title":"RDF.Literal.Datatype.id/0","type":"callback"},{"doc":"The language of the given RDF.Literal if present.","ref":"RDF.Literal.Datatype.html#c:language/1","title":"RDF.Literal.Datatype.language/1","type":"callback"},{"doc":"Returns the lexical form of a RDF.Literal .","ref":"RDF.Literal.Datatype.html#c:lexical/1","title":"RDF.Literal.Datatype.lexical/1","type":"callback"},{"doc":"The name of the datatype.","ref":"RDF.Literal.Datatype.html#c:name/0","title":"RDF.Literal.Datatype.name/0","type":"callback"},{"doc":"","ref":"RDF.Literal.Datatype.html#c:new!/1","title":"RDF.Literal.Datatype.new!/1","type":"callback"},{"doc":"","ref":"RDF.Literal.Datatype.html#c:new!/2","title":"RDF.Literal.Datatype.new!/2","type":"callback"},{"doc":"","ref":"RDF.Literal.Datatype.html#c:new/1","title":"RDF.Literal.Datatype.new/1","type":"callback"},{"doc":"","ref":"RDF.Literal.Datatype.html#c:new/2","title":"RDF.Literal.Datatype.new/2","type":"callback"},{"doc":"Updates the value of a RDF.Literal without changing everything else. Example iex&gt; RDF.XSD . integer ( 42 ) |&gt; RDF.XSD.Integer . update ( fn value -&gt; value + 1 end ) RDF.XSD . integer ( 43 ) iex&gt; ~L&quot;foo&quot;de |&gt; RDF.LangString . update ( fn _ -&gt; &quot;bar&quot; end ) ~L&quot;bar&quot;de iex&gt; RDF . literal ( &quot;foo&quot; , datatype : &quot;http://example.com/dt&quot; ) |&gt; RDF.Literal.Generic . update ( fn _ -&gt; &quot;bar&quot; end ) RDF . literal ( &quot;bar&quot; , datatype : &quot;http://example.com/dt&quot; )","ref":"RDF.Literal.Datatype.html#c:update/2","title":"RDF.Literal.Datatype.update/2","type":"callback"},{"doc":"Updates the value of a RDF.Literal without changing anything else. This variant of update/2 allows with the :as option to specify what will be passed to fun , eg. with as: :lexical the lexical is passed to the function. Example iex&gt; RDF.XSD . integer ( 42 ) |&gt; RDF.XSD.Integer . update ( ...&gt; fn value -&gt; value &lt;&gt; &quot;1&quot; end , as : :lexical ) RDF.XSD . integer ( 421 )","ref":"RDF.Literal.Datatype.html#c:update/3","title":"RDF.Literal.Datatype.update/3","type":"callback"},{"doc":"Determines if a RDF.Literal has a proper value of the value space of its datatype. This function also accepts literals of derived datatypes.","ref":"RDF.Literal.Datatype.html#c:valid?/1","title":"RDF.Literal.Datatype.valid?/1","type":"callback"},{"doc":"Returns the value of a RDF.Literal . This function also accepts literals of derived datatypes.","ref":"RDF.Literal.Datatype.html#c:value/1","title":"RDF.Literal.Datatype.value/1","type":"callback"},{"doc":"","ref":"RDF.Literal.Datatype.html#t:comparison_result/0","title":"RDF.Literal.Datatype.comparison_result/0","type":"type"},{"doc":"","ref":"RDF.Literal.Datatype.html#t:literal/0","title":"RDF.Literal.Datatype.literal/0","type":"type"},{"doc":"","ref":"RDF.Literal.Datatype.html#t:t/0","title":"RDF.Literal.Datatype.t/0","type":"type"},{"doc":"A generic RDF.Literal.Datatype for literals of an unknown datatype.","ref":"RDF.Literal.Generic.html","title":"RDF.Literal.Generic","type":"module"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.Literal.Generic.html#canonical_lexical/1","title":"RDF.Literal.Generic.canonical_lexical/1","type":"function"},{"doc":"Since generic literals don't support casting, always returns nil .","ref":"RDF.Literal.Generic.html#cast/1","title":"RDF.Literal.Generic.cast/1","type":"function"},{"doc":"","ref":"RDF.Literal.Generic.html#compare/2","title":"RDF.Literal.Generic.compare/2","type":"function"},{"doc":"Checks if the given literal has this datatype.","ref":"RDF.Literal.Generic.html#datatype?/1","title":"RDF.Literal.Generic.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.Literal.Generic.html#equal_value?/2","title":"RDF.Literal.Generic.equal_value?/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.Literal.Generic.html#update/3","title":"RDF.Literal.Generic.update/3","type":"function"},{"doc":"","ref":"RDF.Literal.Generic.html#t:t/0","title":"RDF.Literal.Generic.t/0","type":"type"},{"doc":"RDF.NQuads provides support for the N-Quads serialization format. N-Quads is a line-based plain-text format for encoding an RDF dataset, i.e. a collection of RDF graphs. An example of an RDF statement in N-Quads format: &lt; https :// hex . pm / &gt; &lt; http :// purl . org / dc / terms / title &gt; &quot;Hex&quot; &lt; http :// example . org / graphs / example &gt; . see https://www.w3.org/TR/n-quads/","ref":"RDF.NQuads.html","title":"RDF.NQuads","type":"module"},{"doc":"Deserializes a graph or dataset from a file. As opposed to read_file/2 , it raises an exception if an error occurs and defaults to stream: true . See read_file/3 for the available format-independent options. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NQuads.html#read_file!/2","title":"RDF.NQuads.read_file!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a file. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. Options General serialization-independent options: :stream : Allows to enable reading the data from a file directly via a stream (default: false on this function, true on the bang version) :gzip : Allows to read directly from a gzipped file (default: false ) :file_mode : A list with the Elixir File.open modes to be used for reading (default: [:read, :utf8] ) See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NQuads.html#read_file/2","title":"RDF.NQuads.read_file/2","type":"function"},{"doc":"Deserializes a graph or dataset from a stream. As opposed to read_stream/2 , it raises an exception if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NQuads.html#read_stream!/2","title":"RDF.NQuads.read_stream!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a stream. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NQuads.html#read_stream/2","title":"RDF.NQuads.read_stream/2","type":"function"},{"doc":"Deserializes a graph or dataset from a string. As opposed to read_string/2 , it raises an exception if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NQuads.html#read_string!/2","title":"RDF.NQuads.read_string!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a string. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NQuads.html#read_string/2","title":"RDF.NQuads.read_string/2","type":"function"},{"doc":"Serializes a RDF data structure to a file. As opposed to write_file/3 , it raises an exception if an error occurs. See write_file/3 for the available format-independent options. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.NQuads.html#write_file!/3","title":"RDF.NQuads.write_file!/3","type":"function"},{"doc":"Serializes a RDF data structure to a file. It returns :ok if successful or {:error, reason} if an error occurs. Options General serialization-independent options: :stream : Allows to enable writing the serialized data to the file directly via a stream. Possible values: :string or :iodata for writing to the file with a stream of strings respective IO lists, true if you want to use streams, but don't care for the exact method or false for not writing with a stream (default: false on this function, :iodata on the bang version) :gzip : Allows to write directly to a gzipped file (default: false ) :force : If not set to true , an error is raised when the given file already exists (default: false ) :file_mode : A list with the Elixir File.open modes to be used for writing (default: [:write, :exclusive] ) See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.NQuads.html#write_file/3","title":"RDF.NQuads.write_file/3","type":"function"},{"doc":"Serializes a RDF data structure to a stream. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.NQuads.html#write_stream/2","title":"RDF.NQuads.write_stream/2","type":"function"},{"doc":"Serializes a RDF data structure to a string. As opposed to write_string/2 , it raises an exception if an error occurs. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.NQuads.html#write_string!/2","title":"RDF.NQuads.write_string!/2","type":"function"},{"doc":"Serializes a RDF data structure to a string. It returns an {:ok, string} tuple, with string being the serialized graph or dataset, or {:error, reason} if an error occurs. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.NQuads.html#write_string/2","title":"RDF.NQuads.write_string/2","type":"function"},{"doc":"A decoder for N-Quads serializations to RDF.Dataset s. As for all decoders of RDF.Serialization.Format s, you normally won't use these functions directly, but via one of the read_ functions on the RDF.NQuads format module or the generic RDF.Serialization module.","ref":"RDF.NQuads.Decoder.html","title":"RDF.NQuads.Decoder","type":"module"},{"doc":"An encoder for N-Quads serializations of RDF.ex data structures. As for all encoders of RDF.Serialization.Format s, you normally won't use these functions directly, but via one of the write_ functions on the RDF.NQuads format module or the generic RDF.Serialization module. Options :default_graph_name : The graph name to be used as the default for triples from a RDF.Graph or RDF.Description . When the input to be encoded is a RDF.Description the default is nil for the default graph. In case of a RDF.Graph the default is the RDF.Graph.name/1 . The option doesn't have any effect at all when the input to be encoded is a RDF.Dataset .","ref":"RDF.NQuads.Encoder.html","title":"RDF.NQuads.Encoder","type":"behaviour"},{"doc":"","ref":"RDF.NQuads.Encoder.html#c:encode/2","title":"RDF.NQuads.Encoder.encode/2","type":"callback"},{"doc":"","ref":"RDF.NQuads.Encoder.html#iolist_statement/2","title":"RDF.NQuads.Encoder.iolist_statement/2","type":"function"},{"doc":"See RDF.NTriples.Encoder.iolist_term/1 .","ref":"RDF.NQuads.Encoder.html#iolist_term/1","title":"RDF.NQuads.Encoder.iolist_term/1","type":"function"},{"doc":"","ref":"RDF.NQuads.Encoder.html#statement/2","title":"RDF.NQuads.Encoder.statement/2","type":"function"},{"doc":"See RDF.NTriples.Encoder.term/1 .","ref":"RDF.NQuads.Encoder.html#term/1","title":"RDF.NQuads.Encoder.term/1","type":"function"},{"doc":"RDF.Namespace s for fundamental RDF vocabularies. Namely: RDF.NS.RDF RDF.NS.RDFS RDF.NS.OWL RDF.NS.SKOS RDF.NS.XSD","ref":"RDF.NS.html","title":"RDF.NS","type":"module"},{"doc":"The OWL vocabulary. See https://www.w3.org/TR/owl-overview/","ref":"RDF.NS.OWL.html","title":"RDF.NS.OWL","type":"module"},{"doc":"Returns all known IRIs of the vocabulary.","ref":"RDF.NS.OWL.html#__iris__/0","title":"RDF.NS.OWL.__iris__/0","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#allValuesFrom","ref":"RDF.NS.OWL.html#allValuesFrom/0","title":"RDF.NS.OWL.allValuesFrom/0","type":"function"},{"doc":"RDF.Description builder for allValuesFrom/0","ref":"RDF.NS.OWL.html#allValuesFrom/2","title":"RDF.NS.OWL.allValuesFrom/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#annotatedProperty","ref":"RDF.NS.OWL.html#annotatedProperty/0","title":"RDF.NS.OWL.annotatedProperty/0","type":"function"},{"doc":"RDF.Description builder for annotatedProperty/0","ref":"RDF.NS.OWL.html#annotatedProperty/2","title":"RDF.NS.OWL.annotatedProperty/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#annotatedSource","ref":"RDF.NS.OWL.html#annotatedSource/0","title":"RDF.NS.OWL.annotatedSource/0","type":"function"},{"doc":"RDF.Description builder for annotatedSource/0","ref":"RDF.NS.OWL.html#annotatedSource/2","title":"RDF.NS.OWL.annotatedSource/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#annotatedTarget","ref":"RDF.NS.OWL.html#annotatedTarget/0","title":"RDF.NS.OWL.annotatedTarget/0","type":"function"},{"doc":"RDF.Description builder for annotatedTarget/0","ref":"RDF.NS.OWL.html#annotatedTarget/2","title":"RDF.NS.OWL.annotatedTarget/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#assertionProperty","ref":"RDF.NS.OWL.html#assertionProperty/0","title":"RDF.NS.OWL.assertionProperty/0","type":"function"},{"doc":"RDF.Description builder for assertionProperty/0","ref":"RDF.NS.OWL.html#assertionProperty/2","title":"RDF.NS.OWL.assertionProperty/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#backwardCompatibleWith","ref":"RDF.NS.OWL.html#backwardCompatibleWith/0","title":"RDF.NS.OWL.backwardCompatibleWith/0","type":"function"},{"doc":"RDF.Description builder for backwardCompatibleWith/0","ref":"RDF.NS.OWL.html#backwardCompatibleWith/2","title":"RDF.NS.OWL.backwardCompatibleWith/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#bottomDataProperty","ref":"RDF.NS.OWL.html#bottomDataProperty/0","title":"RDF.NS.OWL.bottomDataProperty/0","type":"function"},{"doc":"RDF.Description builder for bottomDataProperty/0","ref":"RDF.NS.OWL.html#bottomDataProperty/2","title":"RDF.NS.OWL.bottomDataProperty/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#bottomObjectProperty","ref":"RDF.NS.OWL.html#bottomObjectProperty/0","title":"RDF.NS.OWL.bottomObjectProperty/0","type":"function"},{"doc":"RDF.Description builder for bottomObjectProperty/0","ref":"RDF.NS.OWL.html#bottomObjectProperty/2","title":"RDF.NS.OWL.bottomObjectProperty/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#cardinality","ref":"RDF.NS.OWL.html#cardinality/0","title":"RDF.NS.OWL.cardinality/0","type":"function"},{"doc":"RDF.Description builder for cardinality/0","ref":"RDF.NS.OWL.html#cardinality/2","title":"RDF.NS.OWL.cardinality/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#complementOf","ref":"RDF.NS.OWL.html#complementOf/0","title":"RDF.NS.OWL.complementOf/0","type":"function"},{"doc":"RDF.Description builder for complementOf/0","ref":"RDF.NS.OWL.html#complementOf/2","title":"RDF.NS.OWL.complementOf/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#datatypeComplementOf","ref":"RDF.NS.OWL.html#datatypeComplementOf/0","title":"RDF.NS.OWL.datatypeComplementOf/0","type":"function"},{"doc":"RDF.Description builder for datatypeComplementOf/0","ref":"RDF.NS.OWL.html#datatypeComplementOf/2","title":"RDF.NS.OWL.datatypeComplementOf/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#deprecated","ref":"RDF.NS.OWL.html#deprecated/0","title":"RDF.NS.OWL.deprecated/0","type":"function"},{"doc":"RDF.Description builder for deprecated/0","ref":"RDF.NS.OWL.html#deprecated/2","title":"RDF.NS.OWL.deprecated/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#differentFrom","ref":"RDF.NS.OWL.html#differentFrom/0","title":"RDF.NS.OWL.differentFrom/0","type":"function"},{"doc":"RDF.Description builder for differentFrom/0","ref":"RDF.NS.OWL.html#differentFrom/2","title":"RDF.NS.OWL.differentFrom/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#disjointUnionOf","ref":"RDF.NS.OWL.html#disjointUnionOf/0","title":"RDF.NS.OWL.disjointUnionOf/0","type":"function"},{"doc":"RDF.Description builder for disjointUnionOf/0","ref":"RDF.NS.OWL.html#disjointUnionOf/2","title":"RDF.NS.OWL.disjointUnionOf/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#disjointWith","ref":"RDF.NS.OWL.html#disjointWith/0","title":"RDF.NS.OWL.disjointWith/0","type":"function"},{"doc":"RDF.Description builder for disjointWith/0","ref":"RDF.NS.OWL.html#disjointWith/2","title":"RDF.NS.OWL.disjointWith/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#distinctMembers","ref":"RDF.NS.OWL.html#distinctMembers/0","title":"RDF.NS.OWL.distinctMembers/0","type":"function"},{"doc":"RDF.Description builder for distinctMembers/0","ref":"RDF.NS.OWL.html#distinctMembers/2","title":"RDF.NS.OWL.distinctMembers/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#equivalentClass","ref":"RDF.NS.OWL.html#equivalentClass/0","title":"RDF.NS.OWL.equivalentClass/0","type":"function"},{"doc":"RDF.Description builder for equivalentClass/0","ref":"RDF.NS.OWL.html#equivalentClass/2","title":"RDF.NS.OWL.equivalentClass/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#equivalentProperty","ref":"RDF.NS.OWL.html#equivalentProperty/0","title":"RDF.NS.OWL.equivalentProperty/0","type":"function"},{"doc":"RDF.Description builder for equivalentProperty/0","ref":"RDF.NS.OWL.html#equivalentProperty/2","title":"RDF.NS.OWL.equivalentProperty/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#hasKey","ref":"RDF.NS.OWL.html#hasKey/0","title":"RDF.NS.OWL.hasKey/0","type":"function"},{"doc":"RDF.Description builder for hasKey/0","ref":"RDF.NS.OWL.html#hasKey/2","title":"RDF.NS.OWL.hasKey/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#hasSelf","ref":"RDF.NS.OWL.html#hasSelf/0","title":"RDF.NS.OWL.hasSelf/0","type":"function"},{"doc":"RDF.Description builder for hasSelf/0","ref":"RDF.NS.OWL.html#hasSelf/2","title":"RDF.NS.OWL.hasSelf/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#hasValue","ref":"RDF.NS.OWL.html#hasValue/0","title":"RDF.NS.OWL.hasValue/0","type":"function"},{"doc":"RDF.Description builder for hasValue/0","ref":"RDF.NS.OWL.html#hasValue/2","title":"RDF.NS.OWL.hasValue/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#imports","ref":"RDF.NS.OWL.html#imports/0","title":"RDF.NS.OWL.imports/0","type":"function"},{"doc":"RDF.Description builder for imports/0","ref":"RDF.NS.OWL.html#imports/2","title":"RDF.NS.OWL.imports/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#incompatibleWith","ref":"RDF.NS.OWL.html#incompatibleWith/0","title":"RDF.NS.OWL.incompatibleWith/0","type":"function"},{"doc":"RDF.Description builder for incompatibleWith/0","ref":"RDF.NS.OWL.html#incompatibleWith/2","title":"RDF.NS.OWL.incompatibleWith/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#intersectionOf","ref":"RDF.NS.OWL.html#intersectionOf/0","title":"RDF.NS.OWL.intersectionOf/0","type":"function"},{"doc":"RDF.Description builder for intersectionOf/0","ref":"RDF.NS.OWL.html#intersectionOf/2","title":"RDF.NS.OWL.intersectionOf/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#inverseOf","ref":"RDF.NS.OWL.html#inverseOf/0","title":"RDF.NS.OWL.inverseOf/0","type":"function"},{"doc":"RDF.Description builder for inverseOf/0","ref":"RDF.NS.OWL.html#inverseOf/2","title":"RDF.NS.OWL.inverseOf/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#maxCardinality","ref":"RDF.NS.OWL.html#maxCardinality/0","title":"RDF.NS.OWL.maxCardinality/0","type":"function"},{"doc":"RDF.Description builder for maxCardinality/0","ref":"RDF.NS.OWL.html#maxCardinality/2","title":"RDF.NS.OWL.maxCardinality/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#maxQualifiedCardinality","ref":"RDF.NS.OWL.html#maxQualifiedCardinality/0","title":"RDF.NS.OWL.maxQualifiedCardinality/0","type":"function"},{"doc":"RDF.Description builder for maxQualifiedCardinality/0","ref":"RDF.NS.OWL.html#maxQualifiedCardinality/2","title":"RDF.NS.OWL.maxQualifiedCardinality/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#members","ref":"RDF.NS.OWL.html#members/0","title":"RDF.NS.OWL.members/0","type":"function"},{"doc":"RDF.Description builder for members/0","ref":"RDF.NS.OWL.html#members/2","title":"RDF.NS.OWL.members/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#minCardinality","ref":"RDF.NS.OWL.html#minCardinality/0","title":"RDF.NS.OWL.minCardinality/0","type":"function"},{"doc":"RDF.Description builder for minCardinality/0","ref":"RDF.NS.OWL.html#minCardinality/2","title":"RDF.NS.OWL.minCardinality/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#minQualifiedCardinality","ref":"RDF.NS.OWL.html#minQualifiedCardinality/0","title":"RDF.NS.OWL.minQualifiedCardinality/0","type":"function"},{"doc":"RDF.Description builder for minQualifiedCardinality/0","ref":"RDF.NS.OWL.html#minQualifiedCardinality/2","title":"RDF.NS.OWL.minQualifiedCardinality/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#onClass","ref":"RDF.NS.OWL.html#onClass/0","title":"RDF.NS.OWL.onClass/0","type":"function"},{"doc":"RDF.Description builder for onClass/0","ref":"RDF.NS.OWL.html#onClass/2","title":"RDF.NS.OWL.onClass/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#onDataRange","ref":"RDF.NS.OWL.html#onDataRange/0","title":"RDF.NS.OWL.onDataRange/0","type":"function"},{"doc":"RDF.Description builder for onDataRange/0","ref":"RDF.NS.OWL.html#onDataRange/2","title":"RDF.NS.OWL.onDataRange/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#onDatatype","ref":"RDF.NS.OWL.html#onDatatype/0","title":"RDF.NS.OWL.onDatatype/0","type":"function"},{"doc":"RDF.Description builder for onDatatype/0","ref":"RDF.NS.OWL.html#onDatatype/2","title":"RDF.NS.OWL.onDatatype/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#oneOf","ref":"RDF.NS.OWL.html#oneOf/0","title":"RDF.NS.OWL.oneOf/0","type":"function"},{"doc":"RDF.Description builder for oneOf/0","ref":"RDF.NS.OWL.html#oneOf/2","title":"RDF.NS.OWL.oneOf/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#onProperties","ref":"RDF.NS.OWL.html#onProperties/0","title":"RDF.NS.OWL.onProperties/0","type":"function"},{"doc":"RDF.Description builder for onProperties/0","ref":"RDF.NS.OWL.html#onProperties/2","title":"RDF.NS.OWL.onProperties/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#onProperty","ref":"RDF.NS.OWL.html#onProperty/0","title":"RDF.NS.OWL.onProperty/0","type":"function"},{"doc":"RDF.Description builder for onProperty/0","ref":"RDF.NS.OWL.html#onProperty/2","title":"RDF.NS.OWL.onProperty/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#priorVersion","ref":"RDF.NS.OWL.html#priorVersion/0","title":"RDF.NS.OWL.priorVersion/0","type":"function"},{"doc":"RDF.Description builder for priorVersion/0","ref":"RDF.NS.OWL.html#priorVersion/2","title":"RDF.NS.OWL.priorVersion/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#propertyChainAxiom","ref":"RDF.NS.OWL.html#propertyChainAxiom/0","title":"RDF.NS.OWL.propertyChainAxiom/0","type":"function"},{"doc":"RDF.Description builder for propertyChainAxiom/0","ref":"RDF.NS.OWL.html#propertyChainAxiom/2","title":"RDF.NS.OWL.propertyChainAxiom/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#propertyDisjointWith","ref":"RDF.NS.OWL.html#propertyDisjointWith/0","title":"RDF.NS.OWL.propertyDisjointWith/0","type":"function"},{"doc":"RDF.Description builder for propertyDisjointWith/0","ref":"RDF.NS.OWL.html#propertyDisjointWith/2","title":"RDF.NS.OWL.propertyDisjointWith/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#qualifiedCardinality","ref":"RDF.NS.OWL.html#qualifiedCardinality/0","title":"RDF.NS.OWL.qualifiedCardinality/0","type":"function"},{"doc":"RDF.Description builder for qualifiedCardinality/0","ref":"RDF.NS.OWL.html#qualifiedCardinality/2","title":"RDF.NS.OWL.qualifiedCardinality/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#sameAs","ref":"RDF.NS.OWL.html#sameAs/0","title":"RDF.NS.OWL.sameAs/0","type":"function"},{"doc":"RDF.Description builder for sameAs/0","ref":"RDF.NS.OWL.html#sameAs/2","title":"RDF.NS.OWL.sameAs/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#someValuesFrom","ref":"RDF.NS.OWL.html#someValuesFrom/0","title":"RDF.NS.OWL.someValuesFrom/0","type":"function"},{"doc":"RDF.Description builder for someValuesFrom/0","ref":"RDF.NS.OWL.html#someValuesFrom/2","title":"RDF.NS.OWL.someValuesFrom/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#sourceIndividual","ref":"RDF.NS.OWL.html#sourceIndividual/0","title":"RDF.NS.OWL.sourceIndividual/0","type":"function"},{"doc":"RDF.Description builder for sourceIndividual/0","ref":"RDF.NS.OWL.html#sourceIndividual/2","title":"RDF.NS.OWL.sourceIndividual/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#targetIndividual","ref":"RDF.NS.OWL.html#targetIndividual/0","title":"RDF.NS.OWL.targetIndividual/0","type":"function"},{"doc":"RDF.Description builder for targetIndividual/0","ref":"RDF.NS.OWL.html#targetIndividual/2","title":"RDF.NS.OWL.targetIndividual/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#targetValue","ref":"RDF.NS.OWL.html#targetValue/0","title":"RDF.NS.OWL.targetValue/0","type":"function"},{"doc":"RDF.Description builder for targetValue/0","ref":"RDF.NS.OWL.html#targetValue/2","title":"RDF.NS.OWL.targetValue/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#topDataProperty","ref":"RDF.NS.OWL.html#topDataProperty/0","title":"RDF.NS.OWL.topDataProperty/0","type":"function"},{"doc":"RDF.Description builder for topDataProperty/0","ref":"RDF.NS.OWL.html#topDataProperty/2","title":"RDF.NS.OWL.topDataProperty/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#topObjectProperty","ref":"RDF.NS.OWL.html#topObjectProperty/0","title":"RDF.NS.OWL.topObjectProperty/0","type":"function"},{"doc":"RDF.Description builder for topObjectProperty/0","ref":"RDF.NS.OWL.html#topObjectProperty/2","title":"RDF.NS.OWL.topObjectProperty/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#unionOf","ref":"RDF.NS.OWL.html#unionOf/0","title":"RDF.NS.OWL.unionOf/0","type":"function"},{"doc":"RDF.Description builder for unionOf/0","ref":"RDF.NS.OWL.html#unionOf/2","title":"RDF.NS.OWL.unionOf/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#versionInfo","ref":"RDF.NS.OWL.html#versionInfo/0","title":"RDF.NS.OWL.versionInfo/0","type":"function"},{"doc":"RDF.Description builder for versionInfo/0","ref":"RDF.NS.OWL.html#versionInfo/2","title":"RDF.NS.OWL.versionInfo/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#versionIRI","ref":"RDF.NS.OWL.html#versionIRI/0","title":"RDF.NS.OWL.versionIRI/0","type":"function"},{"doc":"RDF.Description builder for versionIRI/0","ref":"RDF.NS.OWL.html#versionIRI/2","title":"RDF.NS.OWL.versionIRI/2","type":"function"},{"doc":"http://www.w3.org/2002/07/owl#withRestrictions","ref":"RDF.NS.OWL.html#withRestrictions/0","title":"RDF.NS.OWL.withRestrictions/0","type":"function"},{"doc":"RDF.Description builder for withRestrictions/0","ref":"RDF.NS.OWL.html#withRestrictions/2","title":"RDF.NS.OWL.withRestrictions/2","type":"function"},{"doc":"The RDF vocabulary. Since this module has the same basename as the top-level module, you can't alias it. Therefore, the top-level RDF module has delegators for all of the property functions in this module, so you can use them directly on the top-level module without an alias. See https://www.w3.org/TR/rdf11-concepts/","ref":"RDF.NS.RDF.html","title":"RDF.NS.RDF","type":"module"},{"doc":"http://www.w3.org/1999/02/22-rdf-syntax-ns#nil","ref":"RDF.NS.RDF.html#/0","title":"RDF.NS.RDF./0","type":"function"},{"doc":"RDF.Description builder for /0","ref":"RDF.NS.RDF.html#/2","title":"RDF.NS.RDF./2","type":"function"},{"doc":"Returns all known IRIs of the vocabulary.","ref":"RDF.NS.RDF.html#__iris__/0","title":"RDF.NS.RDF.__iris__/0","type":"function"},{"doc":"http://www.w3.org/1999/02/22-rdf-syntax-ns#first","ref":"RDF.NS.RDF.html#first/0","title":"RDF.NS.RDF.first/0","type":"function"},{"doc":"RDF.Description builder for first/0","ref":"RDF.NS.RDF.html#first/2","title":"RDF.NS.RDF.first/2","type":"function"},{"doc":"http://www.w3.org/1999/02/22-rdf-syntax-ns#langString","ref":"RDF.NS.RDF.html#langString/0","title":"RDF.NS.RDF.langString/0","type":"function"},{"doc":"RDF.Description builder for langString/0","ref":"RDF.NS.RDF.html#langString/2","title":"RDF.NS.RDF.langString/2","type":"function"},{"doc":"http://www.w3.org/1999/02/22-rdf-syntax-ns#object","ref":"RDF.NS.RDF.html#object/0","title":"RDF.NS.RDF.object/0","type":"function"},{"doc":"RDF.Description builder for object/0","ref":"RDF.NS.RDF.html#object/2","title":"RDF.NS.RDF.object/2","type":"function"},{"doc":"http://www.w3.org/1999/02/22-rdf-syntax-ns#predicate","ref":"RDF.NS.RDF.html#predicate/0","title":"RDF.NS.RDF.predicate/0","type":"function"},{"doc":"RDF.Description builder for predicate/0","ref":"RDF.NS.RDF.html#predicate/2","title":"RDF.NS.RDF.predicate/2","type":"function"},{"doc":"http://www.w3.org/1999/02/22-rdf-syntax-ns#rest","ref":"RDF.NS.RDF.html#rest/0","title":"RDF.NS.RDF.rest/0","type":"function"},{"doc":"RDF.Description builder for rest/0","ref":"RDF.NS.RDF.html#rest/2","title":"RDF.NS.RDF.rest/2","type":"function"},{"doc":"http://www.w3.org/1999/02/22-rdf-syntax-ns#subject","ref":"RDF.NS.RDF.html#subject/0","title":"RDF.NS.RDF.subject/0","type":"function"},{"doc":"RDF.Description builder for subject/0","ref":"RDF.NS.RDF.html#subject/2","title":"RDF.NS.RDF.subject/2","type":"function"},{"doc":"http://www.w3.org/1999/02/22-rdf-syntax-ns#type","ref":"RDF.NS.RDF.html#type/0","title":"RDF.NS.RDF.type/0","type":"function"},{"doc":"RDF.Description builder for type/0","ref":"RDF.NS.RDF.html#type/2","title":"RDF.NS.RDF.type/2","type":"function"},{"doc":"http://www.w3.org/1999/02/22-rdf-syntax-ns#value","ref":"RDF.NS.RDF.html#value/0","title":"RDF.NS.RDF.value/0","type":"function"},{"doc":"RDF.Description builder for value/0","ref":"RDF.NS.RDF.html#value/2","title":"RDF.NS.RDF.value/2","type":"function"},{"doc":"The RDFS vocabulary. See https://www.w3.org/TR/rdf-schema/","ref":"RDF.NS.RDFS.html","title":"RDF.NS.RDFS","type":"module"},{"doc":"Returns all known IRIs of the vocabulary.","ref":"RDF.NS.RDFS.html#__iris__/0","title":"RDF.NS.RDFS.__iris__/0","type":"function"},{"doc":"http://www.w3.org/2000/01/rdf-schema#comment","ref":"RDF.NS.RDFS.html#comment/0","title":"RDF.NS.RDFS.comment/0","type":"function"},{"doc":"RDF.Description builder for comment/0","ref":"RDF.NS.RDFS.html#comment/2","title":"RDF.NS.RDFS.comment/2","type":"function"},{"doc":"http://www.w3.org/2000/01/rdf-schema#domain","ref":"RDF.NS.RDFS.html#domain/0","title":"RDF.NS.RDFS.domain/0","type":"function"},{"doc":"RDF.Description builder for domain/0","ref":"RDF.NS.RDFS.html#domain/2","title":"RDF.NS.RDFS.domain/2","type":"function"},{"doc":"http://www.w3.org/2000/01/rdf-schema#isDefinedBy","ref":"RDF.NS.RDFS.html#isDefinedBy/0","title":"RDF.NS.RDFS.isDefinedBy/0","type":"function"},{"doc":"RDF.Description builder for isDefinedBy/0","ref":"RDF.NS.RDFS.html#isDefinedBy/2","title":"RDF.NS.RDFS.isDefinedBy/2","type":"function"},{"doc":"http://www.w3.org/2000/01/rdf-schema#label","ref":"RDF.NS.RDFS.html#label/0","title":"RDF.NS.RDFS.label/0","type":"function"},{"doc":"RDF.Description builder for label/0","ref":"RDF.NS.RDFS.html#label/2","title":"RDF.NS.RDFS.label/2","type":"function"},{"doc":"http://www.w3.org/2000/01/rdf-schema#member","ref":"RDF.NS.RDFS.html#member/0","title":"RDF.NS.RDFS.member/0","type":"function"},{"doc":"RDF.Description builder for member/0","ref":"RDF.NS.RDFS.html#member/2","title":"RDF.NS.RDFS.member/2","type":"function"},{"doc":"http://www.w3.org/2000/01/rdf-schema#range","ref":"RDF.NS.RDFS.html#range/0","title":"RDF.NS.RDFS.range/0","type":"function"},{"doc":"RDF.Description builder for range/0","ref":"RDF.NS.RDFS.html#range/2","title":"RDF.NS.RDFS.range/2","type":"function"},{"doc":"http://www.w3.org/2000/01/rdf-schema#seeAlso","ref":"RDF.NS.RDFS.html#seeAlso/0","title":"RDF.NS.RDFS.seeAlso/0","type":"function"},{"doc":"RDF.Description builder for seeAlso/0","ref":"RDF.NS.RDFS.html#seeAlso/2","title":"RDF.NS.RDFS.seeAlso/2","type":"function"},{"doc":"http://www.w3.org/2000/01/rdf-schema#subClassOf","ref":"RDF.NS.RDFS.html#subClassOf/0","title":"RDF.NS.RDFS.subClassOf/0","type":"function"},{"doc":"RDF.Description builder for subClassOf/0","ref":"RDF.NS.RDFS.html#subClassOf/2","title":"RDF.NS.RDFS.subClassOf/2","type":"function"},{"doc":"http://www.w3.org/2000/01/rdf-schema#subPropertyOf","ref":"RDF.NS.RDFS.html#subPropertyOf/0","title":"RDF.NS.RDFS.subPropertyOf/0","type":"function"},{"doc":"RDF.Description builder for subPropertyOf/0","ref":"RDF.NS.RDFS.html#subPropertyOf/2","title":"RDF.NS.RDFS.subPropertyOf/2","type":"function"},{"doc":"The SKOS vocabulary. See http://www.w3.org/TR/skos-reference/","ref":"RDF.NS.SKOS.html","title":"RDF.NS.SKOS","type":"module"},{"doc":"Returns all known IRIs of the vocabulary.","ref":"RDF.NS.SKOS.html#__iris__/0","title":"RDF.NS.SKOS.__iris__/0","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#altLabel","ref":"RDF.NS.SKOS.html#altLabel/0","title":"RDF.NS.SKOS.altLabel/0","type":"function"},{"doc":"RDF.Description builder for altLabel/0","ref":"RDF.NS.SKOS.html#altLabel/2","title":"RDF.NS.SKOS.altLabel/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#broader","ref":"RDF.NS.SKOS.html#broader/0","title":"RDF.NS.SKOS.broader/0","type":"function"},{"doc":"RDF.Description builder for broader/0","ref":"RDF.NS.SKOS.html#broader/2","title":"RDF.NS.SKOS.broader/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#broaderTransitive","ref":"RDF.NS.SKOS.html#broaderTransitive/0","title":"RDF.NS.SKOS.broaderTransitive/0","type":"function"},{"doc":"RDF.Description builder for broaderTransitive/0","ref":"RDF.NS.SKOS.html#broaderTransitive/2","title":"RDF.NS.SKOS.broaderTransitive/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#broadMatch","ref":"RDF.NS.SKOS.html#broadMatch/0","title":"RDF.NS.SKOS.broadMatch/0","type":"function"},{"doc":"RDF.Description builder for broadMatch/0","ref":"RDF.NS.SKOS.html#broadMatch/2","title":"RDF.NS.SKOS.broadMatch/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#changeNote","ref":"RDF.NS.SKOS.html#changeNote/0","title":"RDF.NS.SKOS.changeNote/0","type":"function"},{"doc":"RDF.Description builder for changeNote/0","ref":"RDF.NS.SKOS.html#changeNote/2","title":"RDF.NS.SKOS.changeNote/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#closeMatch","ref":"RDF.NS.SKOS.html#closeMatch/0","title":"RDF.NS.SKOS.closeMatch/0","type":"function"},{"doc":"RDF.Description builder for closeMatch/0","ref":"RDF.NS.SKOS.html#closeMatch/2","title":"RDF.NS.SKOS.closeMatch/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#definition","ref":"RDF.NS.SKOS.html#definition/0","title":"RDF.NS.SKOS.definition/0","type":"function"},{"doc":"RDF.Description builder for definition/0","ref":"RDF.NS.SKOS.html#definition/2","title":"RDF.NS.SKOS.definition/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#editorialNote","ref":"RDF.NS.SKOS.html#editorialNote/0","title":"RDF.NS.SKOS.editorialNote/0","type":"function"},{"doc":"RDF.Description builder for editorialNote/0","ref":"RDF.NS.SKOS.html#editorialNote/2","title":"RDF.NS.SKOS.editorialNote/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#exactMatch","ref":"RDF.NS.SKOS.html#exactMatch/0","title":"RDF.NS.SKOS.exactMatch/0","type":"function"},{"doc":"RDF.Description builder for exactMatch/0","ref":"RDF.NS.SKOS.html#exactMatch/2","title":"RDF.NS.SKOS.exactMatch/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#example","ref":"RDF.NS.SKOS.html#example/0","title":"RDF.NS.SKOS.example/0","type":"function"},{"doc":"RDF.Description builder for example/0","ref":"RDF.NS.SKOS.html#example/2","title":"RDF.NS.SKOS.example/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#hasTopConcept","ref":"RDF.NS.SKOS.html#hasTopConcept/0","title":"RDF.NS.SKOS.hasTopConcept/0","type":"function"},{"doc":"RDF.Description builder for hasTopConcept/0","ref":"RDF.NS.SKOS.html#hasTopConcept/2","title":"RDF.NS.SKOS.hasTopConcept/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#hiddenLabel","ref":"RDF.NS.SKOS.html#hiddenLabel/0","title":"RDF.NS.SKOS.hiddenLabel/0","type":"function"},{"doc":"RDF.Description builder for hiddenLabel/0","ref":"RDF.NS.SKOS.html#hiddenLabel/2","title":"RDF.NS.SKOS.hiddenLabel/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#historyNote","ref":"RDF.NS.SKOS.html#historyNote/0","title":"RDF.NS.SKOS.historyNote/0","type":"function"},{"doc":"RDF.Description builder for historyNote/0","ref":"RDF.NS.SKOS.html#historyNote/2","title":"RDF.NS.SKOS.historyNote/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#inScheme","ref":"RDF.NS.SKOS.html#inScheme/0","title":"RDF.NS.SKOS.inScheme/0","type":"function"},{"doc":"RDF.Description builder for inScheme/0","ref":"RDF.NS.SKOS.html#inScheme/2","title":"RDF.NS.SKOS.inScheme/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#mappingRelation","ref":"RDF.NS.SKOS.html#mappingRelation/0","title":"RDF.NS.SKOS.mappingRelation/0","type":"function"},{"doc":"RDF.Description builder for mappingRelation/0","ref":"RDF.NS.SKOS.html#mappingRelation/2","title":"RDF.NS.SKOS.mappingRelation/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#member","ref":"RDF.NS.SKOS.html#member/0","title":"RDF.NS.SKOS.member/0","type":"function"},{"doc":"RDF.Description builder for member/0","ref":"RDF.NS.SKOS.html#member/2","title":"RDF.NS.SKOS.member/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#memberList","ref":"RDF.NS.SKOS.html#memberList/0","title":"RDF.NS.SKOS.memberList/0","type":"function"},{"doc":"RDF.Description builder for memberList/0","ref":"RDF.NS.SKOS.html#memberList/2","title":"RDF.NS.SKOS.memberList/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#narrower","ref":"RDF.NS.SKOS.html#narrower/0","title":"RDF.NS.SKOS.narrower/0","type":"function"},{"doc":"RDF.Description builder for narrower/0","ref":"RDF.NS.SKOS.html#narrower/2","title":"RDF.NS.SKOS.narrower/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#narrowerTransitive","ref":"RDF.NS.SKOS.html#narrowerTransitive/0","title":"RDF.NS.SKOS.narrowerTransitive/0","type":"function"},{"doc":"RDF.Description builder for narrowerTransitive/0","ref":"RDF.NS.SKOS.html#narrowerTransitive/2","title":"RDF.NS.SKOS.narrowerTransitive/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#narrowMatch","ref":"RDF.NS.SKOS.html#narrowMatch/0","title":"RDF.NS.SKOS.narrowMatch/0","type":"function"},{"doc":"RDF.Description builder for narrowMatch/0","ref":"RDF.NS.SKOS.html#narrowMatch/2","title":"RDF.NS.SKOS.narrowMatch/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#notation","ref":"RDF.NS.SKOS.html#notation/0","title":"RDF.NS.SKOS.notation/0","type":"function"},{"doc":"RDF.Description builder for notation/0","ref":"RDF.NS.SKOS.html#notation/2","title":"RDF.NS.SKOS.notation/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#note","ref":"RDF.NS.SKOS.html#note/0","title":"RDF.NS.SKOS.note/0","type":"function"},{"doc":"RDF.Description builder for note/0","ref":"RDF.NS.SKOS.html#note/2","title":"RDF.NS.SKOS.note/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#prefLabel","ref":"RDF.NS.SKOS.html#prefLabel/0","title":"RDF.NS.SKOS.prefLabel/0","type":"function"},{"doc":"RDF.Description builder for prefLabel/0","ref":"RDF.NS.SKOS.html#prefLabel/2","title":"RDF.NS.SKOS.prefLabel/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#related","ref":"RDF.NS.SKOS.html#related/0","title":"RDF.NS.SKOS.related/0","type":"function"},{"doc":"RDF.Description builder for related/0","ref":"RDF.NS.SKOS.html#related/2","title":"RDF.NS.SKOS.related/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#relatedMatch","ref":"RDF.NS.SKOS.html#relatedMatch/0","title":"RDF.NS.SKOS.relatedMatch/0","type":"function"},{"doc":"RDF.Description builder for relatedMatch/0","ref":"RDF.NS.SKOS.html#relatedMatch/2","title":"RDF.NS.SKOS.relatedMatch/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#scopeNote","ref":"RDF.NS.SKOS.html#scopeNote/0","title":"RDF.NS.SKOS.scopeNote/0","type":"function"},{"doc":"RDF.Description builder for scopeNote/0","ref":"RDF.NS.SKOS.html#scopeNote/2","title":"RDF.NS.SKOS.scopeNote/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#semanticRelation","ref":"RDF.NS.SKOS.html#semanticRelation/0","title":"RDF.NS.SKOS.semanticRelation/0","type":"function"},{"doc":"RDF.Description builder for semanticRelation/0","ref":"RDF.NS.SKOS.html#semanticRelation/2","title":"RDF.NS.SKOS.semanticRelation/2","type":"function"},{"doc":"http://www.w3.org/2004/02/skos/core#topConceptOf","ref":"RDF.NS.SKOS.html#topConceptOf/0","title":"RDF.NS.SKOS.topConceptOf/0","type":"function"},{"doc":"RDF.Description builder for topConceptOf/0","ref":"RDF.NS.SKOS.html#topConceptOf/2","title":"RDF.NS.SKOS.topConceptOf/2","type":"function"},{"doc":"The XML Schema datatypes vocabulary. See https://www.w3.org/TR/xmlschema11-2/","ref":"RDF.NS.XSD.html","title":"RDF.NS.XSD","type":"module"},{"doc":"Returns all known IRIs of the vocabulary.","ref":"RDF.NS.XSD.html#__iris__/0","title":"RDF.NS.XSD.__iris__/0","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#anyURI","ref":"RDF.NS.XSD.html#anyURI/0","title":"RDF.NS.XSD.anyURI/0","type":"function"},{"doc":"RDF.Description builder for anyURI/0","ref":"RDF.NS.XSD.html#anyURI/2","title":"RDF.NS.XSD.anyURI/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#base64Binary","ref":"RDF.NS.XSD.html#base64Binary/0","title":"RDF.NS.XSD.base64Binary/0","type":"function"},{"doc":"RDF.Description builder for base64Binary/0","ref":"RDF.NS.XSD.html#base64Binary/2","title":"RDF.NS.XSD.base64Binary/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#boolean","ref":"RDF.NS.XSD.html#boolean/0","title":"RDF.NS.XSD.boolean/0","type":"function"},{"doc":"RDF.Description builder for boolean/0","ref":"RDF.NS.XSD.html#boolean/2","title":"RDF.NS.XSD.boolean/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#byte","ref":"RDF.NS.XSD.html#byte/0","title":"RDF.NS.XSD.byte/0","type":"function"},{"doc":"RDF.Description builder for byte/0","ref":"RDF.NS.XSD.html#byte/2","title":"RDF.NS.XSD.byte/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#date","ref":"RDF.NS.XSD.html#date/0","title":"RDF.NS.XSD.date/0","type":"function"},{"doc":"RDF.Description builder for date/0","ref":"RDF.NS.XSD.html#date/2","title":"RDF.NS.XSD.date/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#dateTime","ref":"RDF.NS.XSD.html#dateTime/0","title":"RDF.NS.XSD.dateTime/0","type":"function"},{"doc":"RDF.Description builder for dateTime/0","ref":"RDF.NS.XSD.html#dateTime/2","title":"RDF.NS.XSD.dateTime/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#dayTimeDuration","ref":"RDF.NS.XSD.html#dayTimeDuration/0","title":"RDF.NS.XSD.dayTimeDuration/0","type":"function"},{"doc":"RDF.Description builder for dayTimeDuration/0","ref":"RDF.NS.XSD.html#dayTimeDuration/2","title":"RDF.NS.XSD.dayTimeDuration/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#decimal","ref":"RDF.NS.XSD.html#decimal/0","title":"RDF.NS.XSD.decimal/0","type":"function"},{"doc":"RDF.Description builder for decimal/0","ref":"RDF.NS.XSD.html#decimal/2","title":"RDF.NS.XSD.decimal/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#double","ref":"RDF.NS.XSD.html#double/0","title":"RDF.NS.XSD.double/0","type":"function"},{"doc":"RDF.Description builder for double/0","ref":"RDF.NS.XSD.html#double/2","title":"RDF.NS.XSD.double/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#duration","ref":"RDF.NS.XSD.html#duration/0","title":"RDF.NS.XSD.duration/0","type":"function"},{"doc":"RDF.Description builder for duration/0","ref":"RDF.NS.XSD.html#duration/2","title":"RDF.NS.XSD.duration/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#float","ref":"RDF.NS.XSD.html#float/0","title":"RDF.NS.XSD.float/0","type":"function"},{"doc":"RDF.Description builder for float/0","ref":"RDF.NS.XSD.html#float/2","title":"RDF.NS.XSD.float/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#gDay","ref":"RDF.NS.XSD.html#gDay/0","title":"RDF.NS.XSD.gDay/0","type":"function"},{"doc":"RDF.Description builder for gDay/0","ref":"RDF.NS.XSD.html#gDay/2","title":"RDF.NS.XSD.gDay/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#gMonth","ref":"RDF.NS.XSD.html#gMonth/0","title":"RDF.NS.XSD.gMonth/0","type":"function"},{"doc":"RDF.Description builder for gMonth/0","ref":"RDF.NS.XSD.html#gMonth/2","title":"RDF.NS.XSD.gMonth/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#gMonthDay","ref":"RDF.NS.XSD.html#gMonthDay/0","title":"RDF.NS.XSD.gMonthDay/0","type":"function"},{"doc":"RDF.Description builder for gMonthDay/0","ref":"RDF.NS.XSD.html#gMonthDay/2","title":"RDF.NS.XSD.gMonthDay/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#gYear","ref":"RDF.NS.XSD.html#gYear/0","title":"RDF.NS.XSD.gYear/0","type":"function"},{"doc":"RDF.Description builder for gYear/0","ref":"RDF.NS.XSD.html#gYear/2","title":"RDF.NS.XSD.gYear/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#gYearMonth","ref":"RDF.NS.XSD.html#gYearMonth/0","title":"RDF.NS.XSD.gYearMonth/0","type":"function"},{"doc":"RDF.Description builder for gYearMonth/0","ref":"RDF.NS.XSD.html#gYearMonth/2","title":"RDF.NS.XSD.gYearMonth/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#hexBinary","ref":"RDF.NS.XSD.html#hexBinary/0","title":"RDF.NS.XSD.hexBinary/0","type":"function"},{"doc":"RDF.Description builder for hexBinary/0","ref":"RDF.NS.XSD.html#hexBinary/2","title":"RDF.NS.XSD.hexBinary/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#int","ref":"RDF.NS.XSD.html#int/0","title":"RDF.NS.XSD.int/0","type":"function"},{"doc":"RDF.Description builder for int/0","ref":"RDF.NS.XSD.html#int/2","title":"RDF.NS.XSD.int/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#integer","ref":"RDF.NS.XSD.html#integer/0","title":"RDF.NS.XSD.integer/0","type":"function"},{"doc":"RDF.Description builder for integer/0","ref":"RDF.NS.XSD.html#integer/2","title":"RDF.NS.XSD.integer/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#language","ref":"RDF.NS.XSD.html#language/0","title":"RDF.NS.XSD.language/0","type":"function"},{"doc":"RDF.Description builder for language/0","ref":"RDF.NS.XSD.html#language/2","title":"RDF.NS.XSD.language/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#long","ref":"RDF.NS.XSD.html#long/0","title":"RDF.NS.XSD.long/0","type":"function"},{"doc":"RDF.Description builder for long/0","ref":"RDF.NS.XSD.html#long/2","title":"RDF.NS.XSD.long/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#negativeInteger","ref":"RDF.NS.XSD.html#negativeInteger/0","title":"RDF.NS.XSD.negativeInteger/0","type":"function"},{"doc":"RDF.Description builder for negativeInteger/0","ref":"RDF.NS.XSD.html#negativeInteger/2","title":"RDF.NS.XSD.negativeInteger/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#nonNegativeInteger","ref":"RDF.NS.XSD.html#nonNegativeInteger/0","title":"RDF.NS.XSD.nonNegativeInteger/0","type":"function"},{"doc":"RDF.Description builder for nonNegativeInteger/0","ref":"RDF.NS.XSD.html#nonNegativeInteger/2","title":"RDF.NS.XSD.nonNegativeInteger/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#nonPositiveInteger","ref":"RDF.NS.XSD.html#nonPositiveInteger/0","title":"RDF.NS.XSD.nonPositiveInteger/0","type":"function"},{"doc":"RDF.Description builder for nonPositiveInteger/0","ref":"RDF.NS.XSD.html#nonPositiveInteger/2","title":"RDF.NS.XSD.nonPositiveInteger/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#normalizedString","ref":"RDF.NS.XSD.html#normalizedString/0","title":"RDF.NS.XSD.normalizedString/0","type":"function"},{"doc":"RDF.Description builder for normalizedString/0","ref":"RDF.NS.XSD.html#normalizedString/2","title":"RDF.NS.XSD.normalizedString/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#positiveInteger","ref":"RDF.NS.XSD.html#positiveInteger/0","title":"RDF.NS.XSD.positiveInteger/0","type":"function"},{"doc":"RDF.Description builder for positiveInteger/0","ref":"RDF.NS.XSD.html#positiveInteger/2","title":"RDF.NS.XSD.positiveInteger/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#short","ref":"RDF.NS.XSD.html#short/0","title":"RDF.NS.XSD.short/0","type":"function"},{"doc":"RDF.Description builder for short/0","ref":"RDF.NS.XSD.html#short/2","title":"RDF.NS.XSD.short/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#string","ref":"RDF.NS.XSD.html#string/0","title":"RDF.NS.XSD.string/0","type":"function"},{"doc":"RDF.Description builder for string/0","ref":"RDF.NS.XSD.html#string/2","title":"RDF.NS.XSD.string/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#time","ref":"RDF.NS.XSD.html#time/0","title":"RDF.NS.XSD.time/0","type":"function"},{"doc":"RDF.Description builder for time/0","ref":"RDF.NS.XSD.html#time/2","title":"RDF.NS.XSD.time/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#token","ref":"RDF.NS.XSD.html#token/0","title":"RDF.NS.XSD.token/0","type":"function"},{"doc":"RDF.Description builder for token/0","ref":"RDF.NS.XSD.html#token/2","title":"RDF.NS.XSD.token/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#unsignedByte","ref":"RDF.NS.XSD.html#unsignedByte/0","title":"RDF.NS.XSD.unsignedByte/0","type":"function"},{"doc":"RDF.Description builder for unsignedByte/0","ref":"RDF.NS.XSD.html#unsignedByte/2","title":"RDF.NS.XSD.unsignedByte/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#unsignedInt","ref":"RDF.NS.XSD.html#unsignedInt/0","title":"RDF.NS.XSD.unsignedInt/0","type":"function"},{"doc":"RDF.Description builder for unsignedInt/0","ref":"RDF.NS.XSD.html#unsignedInt/2","title":"RDF.NS.XSD.unsignedInt/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#unsignedLong","ref":"RDF.NS.XSD.html#unsignedLong/0","title":"RDF.NS.XSD.unsignedLong/0","type":"function"},{"doc":"RDF.Description builder for unsignedLong/0","ref":"RDF.NS.XSD.html#unsignedLong/2","title":"RDF.NS.XSD.unsignedLong/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#unsignedShort","ref":"RDF.NS.XSD.html#unsignedShort/0","title":"RDF.NS.XSD.unsignedShort/0","type":"function"},{"doc":"RDF.Description builder for unsignedShort/0","ref":"RDF.NS.XSD.html#unsignedShort/2","title":"RDF.NS.XSD.unsignedShort/2","type":"function"},{"doc":"http://www.w3.org/2001/XMLSchema#yearMonthDuration","ref":"RDF.NS.XSD.html#yearMonthDuration/0","title":"RDF.NS.XSD.yearMonthDuration/0","type":"function"},{"doc":"RDF.Description builder for yearMonthDuration/0","ref":"RDF.NS.XSD.html#yearMonthDuration/2","title":"RDF.NS.XSD.yearMonthDuration/2","type":"function"},{"doc":"RDF.NTriples provides support for the N-Triples serialization format. N-Triples is a line-based plain-text format for encoding an RDF graph. It is a very restricted, explicit and well-defined subset of both Turtle and Notation3 (N3). An example of an RDF statement in N-Triples format: &lt; https :// hex . pm / &gt; &lt; http :// purl . org / dc / terms / title &gt; &quot;Hex&quot; . see https://www.w3.org/TR/n-triples/","ref":"RDF.NTriples.html","title":"RDF.NTriples","type":"module"},{"doc":"Deserializes a graph or dataset from a file. As opposed to read_file/2 , it raises an exception if an error occurs and defaults to stream: true . See read_file/3 for the available format-independent options. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NTriples.html#read_file!/2","title":"RDF.NTriples.read_file!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a file. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. Options General serialization-independent options: :stream : Allows to enable reading the data from a file directly via a stream (default: false on this function, true on the bang version) :gzip : Allows to read directly from a gzipped file (default: false ) :file_mode : A list with the Elixir File.open modes to be used for reading (default: [:read, :utf8] ) See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NTriples.html#read_file/2","title":"RDF.NTriples.read_file/2","type":"function"},{"doc":"Deserializes a graph or dataset from a stream. As opposed to read_stream/2 , it raises an exception if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NTriples.html#read_stream!/2","title":"RDF.NTriples.read_stream!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a stream. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NTriples.html#read_stream/2","title":"RDF.NTriples.read_stream/2","type":"function"},{"doc":"Deserializes a graph or dataset from a string. As opposed to read_string/2 , it raises an exception if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NTriples.html#read_string!/2","title":"RDF.NTriples.read_string!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a string. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.NTriples.html#read_string/2","title":"RDF.NTriples.read_string/2","type":"function"},{"doc":"Serializes a RDF data structure to a file. As opposed to write_file/3 , it raises an exception if an error occurs. See write_file/3 for the available format-independent options. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.NTriples.html#write_file!/3","title":"RDF.NTriples.write_file!/3","type":"function"},{"doc":"Serializes a RDF data structure to a file. It returns :ok if successful or {:error, reason} if an error occurs. Options General serialization-independent options: :stream : Allows to enable writing the serialized data to the file directly via a stream. Possible values: :string or :iodata for writing to the file with a stream of strings respective IO lists, true if you want to use streams, but don't care for the exact method or false for not writing with a stream (default: false on this function, :iodata on the bang version) :gzip : Allows to write directly to a gzipped file (default: false ) :force : If not set to true , an error is raised when the given file already exists (default: false ) :file_mode : A list with the Elixir File.open modes to be used for writing (default: [:write, :exclusive] ) See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.NTriples.html#write_file/3","title":"RDF.NTriples.write_file/3","type":"function"},{"doc":"Serializes a RDF data structure to a stream. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.NTriples.html#write_stream/2","title":"RDF.NTriples.write_stream/2","type":"function"},{"doc":"Serializes a RDF data structure to a string. As opposed to write_string/2 , it raises an exception if an error occurs. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.NTriples.html#write_string!/2","title":"RDF.NTriples.write_string!/2","type":"function"},{"doc":"Serializes a RDF data structure to a string. It returns an {:ok, string} tuple, with string being the serialized graph or dataset, or {:error, reason} if an error occurs. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.NTriples.html#write_string/2","title":"RDF.NTriples.write_string/2","type":"function"},{"doc":"A decoder for N-Triples serializations to RDF.Graph s. As for all decoders of RDF.Serialization.Format s, you normally won't use these functions directly, but via one of the read_ functions on the RDF.NTriples format module or the generic RDF.Serialization module.","ref":"RDF.NTriples.Decoder.html","title":"RDF.NTriples.Decoder","type":"module"},{"doc":"An encoder for N-Triples serializations of RDF.ex data structures. As for all encoders of RDF.Serialization.Format s, you normally won't use these functions directly, but via one of the write_ functions on the RDF.NTriples format module or the generic RDF.Serialization module.","ref":"RDF.NTriples.Encoder.html","title":"RDF.NTriples.Encoder","type":"behaviour"},{"doc":"","ref":"RDF.NTriples.Encoder.html#c:encode/2","title":"RDF.NTriples.Encoder.encode/2","type":"callback"},{"doc":"","ref":"RDF.NTriples.Encoder.html#iolist_statement/1","title":"RDF.NTriples.Encoder.iolist_statement/1","type":"function"},{"doc":"","ref":"RDF.NTriples.Encoder.html#iolist_term/1","title":"RDF.NTriples.Encoder.iolist_term/1","type":"function"},{"doc":"","ref":"RDF.NTriples.Encoder.html#statement/1","title":"RDF.NTriples.Encoder.statement/1","type":"function"},{"doc":"","ref":"RDF.NTriples.Encoder.html#term/1","title":"RDF.NTriples.Encoder.term/1","type":"function"},{"doc":"A behaviour for resolvers of atoms to RDF.IRI s. Currently there's only one type of such namespaces: RDF.Vocabulary.Namespace , but other types are thinkable and might be implemented in the future, eg. namespaces for JSON-LD contexts.","ref":"RDF.Namespace.html","title":"RDF.Namespace","type":"behaviour"},{"doc":"Resolves a term to a RDF.IRI .","ref":"RDF.Namespace.html#c:__resolve_term__/1","title":"RDF.Namespace.__resolve_term__/1","type":"callback"},{"doc":"All terms of a RDF.Namespace .","ref":"RDF.Namespace.html#c:__terms__/0","title":"RDF.Namespace.__terms__/0","type":"callback"},{"doc":"Resolves a qualified term to a RDF.IRI or raises an error when that's not possible. See resolve_term/1 for more.","ref":"RDF.Namespace.html#resolve_term!/1","title":"RDF.Namespace.resolve_term!/1","type":"function"},{"doc":"Resolves a qualified term to a RDF.IRI . It determines a RDF.Namespace from the qualifier of the given term and delegates to remaining part of the term to __resolve_term__/1 of this determined namespace.","ref":"RDF.Namespace.html#resolve_term/1","title":"RDF.Namespace.resolve_term/1","type":"function"},{"doc":"A mapping a prefix atoms to IRI namespaces. RDF.PrefixMap implements the Enumerable protocol.","ref":"RDF.PrefixMap.html","title":"RDF.PrefixMap","type":"module"},{"doc":"Adds a prefix mapping to the given RDF.PrefixMap and raises an exception in error cases.","ref":"RDF.PrefixMap.html#add!/3","title":"RDF.PrefixMap.add!/3","type":"function"},{"doc":"Adds a prefix mapping to prefix_map . Unless a mapping of prefix to a different namespace already exists, an :ok tuple is returned, otherwise an :error tuple.","ref":"RDF.PrefixMap.html#add/3","title":"RDF.PrefixMap.add/3","type":"function"},{"doc":"Deletes the prefix mapping for prefix from prefix_map . If no mapping for prefix exists, prefix_map is returned unchanged.","ref":"RDF.PrefixMap.html#delete/2","title":"RDF.PrefixMap.delete/2","type":"function"},{"doc":"Drops the given prefixes from prefix_map . If prefixes contains prefixes that are not in prefix_map , they're simply ignored.","ref":"RDF.PrefixMap.html#drop/2","title":"RDF.PrefixMap.drop/2","type":"function"},{"doc":"Returns whether the given prefix exists in the given RDF.PrefixMap .","ref":"RDF.PrefixMap.html#has_prefix?/2","title":"RDF.PrefixMap.has_prefix?/2","type":"function"},{"doc":"Merges two RDF.PrefixMap s and raises an exception in error cases. See merge/2 and merge/3 for more information on merging prefix maps.","ref":"RDF.PrefixMap.html#merge!/3","title":"RDF.PrefixMap.merge!/3","type":"function"},{"doc":"Merges two RDF.PrefixMap s. The second prefix map can also be given as any structure which can converted to a RDF.PrefixMap via new/1 . If the prefix maps can be merged without conflicts, that is there are no prefixes mapped to different namespaces an :ok tuple is returned. Otherwise an :error tuple with the list of prefixes with conflicting namespaces is returned. See also merge/3 which allows you to resolve conflicts with a function.","ref":"RDF.PrefixMap.html#merge/2","title":"RDF.PrefixMap.merge/2","type":"function"},{"doc":"Merges two RDF.PrefixMap s, resolving conflicts through the given conflict_resolver function. The second prefix map can also be given as any structure which can converted to a RDF.PrefixMap via new/1 . The given function will be invoked when there are conflicting mappings of prefixes to different namespaces; its arguments are prefix , namespace1 (the namespace for the prefix in the first prefix map), and namespace2 (the namespace for the prefix in the second prefix map). The value returned by the conflict_resolver function is used as the namespace for the prefix in the resulting prefix map. Non- RDF.IRI values will be tried to be converted to RDF.IRI s via RDF.IRI.new implicitly. The most common conflict resolution strategies on can be chosen directly with the following atoms: :ignore : keep the original namespace from prefix_map1 :overwrite : use the other namespace from prefix_map2 If a conflict can't be resolved, the provided function can return nil . This will result in an overall return of an :error tuple with the list of prefixes for which the conflict couldn't be resolved. If everything could be merged, an :ok tuple is returned.","ref":"RDF.PrefixMap.html#merge/3","title":"RDF.PrefixMap.merge/3","type":"function"},{"doc":"Returns the namespace for the given prefix in prefix_map . Returns nil , when the given prefix is not present in prefix_map .","ref":"RDF.PrefixMap.html#namespace/2","title":"RDF.PrefixMap.namespace/2","type":"function"},{"doc":"Returns all namespaces from the given RDF.PrefixMap .","ref":"RDF.PrefixMap.html#namespaces/1","title":"RDF.PrefixMap.namespaces/1","type":"function"},{"doc":"Creates an empty RDF.PrefixMap .","ref":"RDF.PrefixMap.html#new/0","title":"RDF.PrefixMap.new/0","type":"function"},{"doc":"Creates a new RDF.PrefixMap with initial mappings. The initial prefix mappings can be passed as keyword lists or maps. The keys for the prefixes can be given as atoms or strings and will be normalized to atoms. The namespaces can be given as RDF.IRI s or strings and will be normalized to RDF.IRI s.","ref":"RDF.PrefixMap.html#new/1","title":"RDF.PrefixMap.new/1","type":"function"},{"doc":"Returns the prefix for the given namespace in prefix_map . Returns nil , when the given namespace is not present in prefix_map .","ref":"RDF.PrefixMap.html#prefix/2","title":"RDF.PrefixMap.prefix/2","type":"function"},{"doc":"Converts an IRI into a prefixed name. Returns nil when no prefix for the namespace of iri is defined in prefix_map . Examples iex&gt; RDF.PrefixMap . new ( ex : &quot;http://example.com/&quot; ) ...&gt; |&gt; RDF.PrefixMap . prefixed_name ( ~I&lt;http://example.com/Foo&gt; ) &quot;ex:Foo&quot; iex&gt; RDF.PrefixMap . new ( ex : &quot;http://example.com/&quot; ) ...&gt; |&gt; RDF.PrefixMap . prefixed_name ( &quot;http://example.com/Foo&quot; ) &quot;ex:Foo&quot;","ref":"RDF.PrefixMap.html#prefixed_name/2","title":"RDF.PrefixMap.prefixed_name/2","type":"function"},{"doc":"Converts a prefixed name into an IRI. Returns nil when the prefix in prefixed_name is not defined in prefix_map . Examples iex&gt; RDF.PrefixMap . new ( ex : &quot;http://example.com/&quot; ) ...&gt; |&gt; RDF.PrefixMap . prefixed_name_to_iri ( &quot;ex:Foo&quot; ) ~I&lt;http://example.com/Foo&gt;","ref":"RDF.PrefixMap.html#prefixed_name_to_iri/2","title":"RDF.PrefixMap.prefixed_name_to_iri/2","type":"function"},{"doc":"Returns all prefixes from the given RDF.PrefixMap .","ref":"RDF.PrefixMap.html#prefixes/1","title":"RDF.PrefixMap.prefixes/1","type":"function"},{"doc":"Adds a prefix mapping to prefix_map overwriting an existing mapping.","ref":"RDF.PrefixMap.html#put/3","title":"RDF.PrefixMap.put/3","type":"function"},{"doc":"","ref":"RDF.PrefixMap.html#t:coercible_namespace/0","title":"RDF.PrefixMap.coercible_namespace/0","type":"type"},{"doc":"","ref":"RDF.PrefixMap.html#t:coercible_prefix/0","title":"RDF.PrefixMap.coercible_prefix/0","type":"type"},{"doc":"","ref":"RDF.PrefixMap.html#t:conflict_resolver/0","title":"RDF.PrefixMap.conflict_resolver/0","type":"type"},{"doc":"","ref":"RDF.PrefixMap.html#t:namespace/0","title":"RDF.PrefixMap.namespace/0","type":"type"},{"doc":"","ref":"RDF.PrefixMap.html#t:prefix/0","title":"RDF.PrefixMap.prefix/0","type":"type"},{"doc":"","ref":"RDF.PrefixMap.html#t:prefix_map/0","title":"RDF.PrefixMap.prefix_map/0","type":"type"},{"doc":"","ref":"RDF.PrefixMap.html#t:t/0","title":"RDF.PrefixMap.t/0","type":"type"},{"doc":"A bidirectional mappings from atom names to RDF.IRI s of properties. These mapping can be used in all functions of the RDF data structures to provide the meaning of the predicate terms in input statements or define how the IRIs of predicates should be mapped with the value mapping functions like RDF.Description.values/2 etc. The :context option of these functions either take a RDF.PropertyMap directly or anything from which a RDF.PropertyMap can be created with new/1 . Because the mapping is bidirectional each term and IRI can be used only in one mapping of a RDF.PropertyMap . RDF.PropertyMap implements the Enumerable protocol and the Access behaviour.","ref":"RDF.PropertyMap.html","title":"RDF.PropertyMap","type":"module"},{"doc":"Adds a set of property mappings to property_map and raises an error on conflicts. See add/2 for the different forms in which mappings can be provided.","ref":"RDF.PropertyMap.html#add!/2","title":"RDF.PropertyMap.add!/2","type":"function"},{"doc":"Adds a set of property mappings to property_map . The mappings can be passed in various ways: as keyword lists or maps where terms for the RDF properties can be given as atoms or strings, while the property IRIs can be given as RDF.IRI s or strings a strict RDF.Vocabulary.Namespace from which all lowercased terms are added with their respective IRI; since IRIs can also be once in a RDF.PropertyMap a defined alias term is preferred over an original term another RDF.PropertyMap from which all mappings are merged Unless a mapping for any of the terms or IRIs in the input already exists, an :ok tuple is returned, otherwise an :error tuple.","ref":"RDF.PropertyMap.html#add/2","title":"RDF.PropertyMap.add/2","type":"function"},{"doc":"Adds a property mapping between term and iri to property_map . Unless another mapping for term or iri already exists, an :ok tuple is returned, otherwise an :error tuple.","ref":"RDF.PropertyMap.html#add/3","title":"RDF.PropertyMap.add/3","type":"function"},{"doc":"Deletes the property mapping for term from property_map . If no mapping for term exists, property_map is returned unchanged.","ref":"RDF.PropertyMap.html#delete/2","title":"RDF.PropertyMap.delete/2","type":"function"},{"doc":"Drops the given terms from the property_map . If terms contains terms that are not in property_map , they're simply ignored.","ref":"RDF.PropertyMap.html#drop/2","title":"RDF.PropertyMap.drop/2","type":"function"},{"doc":"Returns the IRI for the given term in property_map . Returns nil , when the given term is not present in property_map .","ref":"RDF.PropertyMap.html#iri/2","title":"RDF.PropertyMap.iri/2","type":"function"},{"doc":"Returns whether a mapping for the given term is defined in property_map .","ref":"RDF.PropertyMap.html#iri_defined?/2","title":"RDF.PropertyMap.iri_defined?/2","type":"function"},{"doc":"Returns the list of all IRIs in the given property_map .","ref":"RDF.PropertyMap.html#iris/1","title":"RDF.PropertyMap.iris/1","type":"function"},{"doc":"Creates an empty RDF.PropertyMap .","ref":"RDF.PropertyMap.html#new/0","title":"RDF.PropertyMap.new/0","type":"function"},{"doc":"Creates a new RDF.PropertyMap with initial mappings. See add/2 for the different forms in which mappings can be provided.","ref":"RDF.PropertyMap.html#new/1","title":"RDF.PropertyMap.new/1","type":"function"},{"doc":"Adds a set of property mappings to property_map overwriting all existing mappings. See add/2 for the different forms in which mappings can be provided. Note, that not just all mappings with the used terms in the input mappings are overwritten, but also all mappings with IRIs in the input mappings","ref":"RDF.PropertyMap.html#put/2","title":"RDF.PropertyMap.put/2","type":"function"},{"doc":"Adds a property mapping between term and iri to property_map overwriting existing mappings.","ref":"RDF.PropertyMap.html#put/3","title":"RDF.PropertyMap.put/3","type":"function"},{"doc":"Returns the term for the given namespace in prefix_map . Returns nil , when the given namespace is not present in prefix_map .","ref":"RDF.PropertyMap.html#term/2","title":"RDF.PropertyMap.term/2","type":"function"},{"doc":"Returns whether a mapping for the given iri is defined in property_map .","ref":"RDF.PropertyMap.html#term_defined?/2","title":"RDF.PropertyMap.term_defined?/2","type":"function"},{"doc":"Returns the list of all terms in the given property_map .","ref":"RDF.PropertyMap.html#terms/1","title":"RDF.PropertyMap.terms/1","type":"function"},{"doc":"","ref":"RDF.PropertyMap.html#t:coercible_term/0","title":"RDF.PropertyMap.coercible_term/0","type":"type"},{"doc":"","ref":"RDF.PropertyMap.html#t:input/0","title":"RDF.PropertyMap.input/0","type":"type"},{"doc":"","ref":"RDF.PropertyMap.html#t:t/0","title":"RDF.PropertyMap.t/0","type":"type"},{"doc":"Helper functions for RDF quads. An RDF Quad is represented as a plain Elixir tuple consisting of four valid RDF values for subject, predicate, object and a graph name.","ref":"RDF.Quad.html","title":"RDF.Quad","type":"module"},{"doc":"Returns a tuple where each element from a RDF.Quad is mapped with the given function. Returns nil if one of the components of the given tuple is not convertible via RDF.Term.value/1 . The function fun will receive a tuple {statement_position, rdf_term} where statement_position is one of the atoms :subject , :predicate , :object or :graph_name while rdf_term is the RDF term to be mapped. When the given function returns nil this will be interpreted as an error and will become the overhaul result of the map/2 call. Examples iex&gt; { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; } ...&gt; |&gt; RDF.Quad . map ( fn ...&gt; { :object , object } -&gt; ...&gt; RDF.Term . value ( object ) ...&gt; { :graph_name , graph_name } -&gt; ...&gt; graph_name ...&gt; { _ , resource } -&gt; ...&gt; resource |&gt; to_string ( ) |&gt; String . last ( ) |&gt; String . to_atom ( ) ...&gt; end ) { :S , :p , 42 , ~I&lt;http://example.com/Graph&gt; }","ref":"RDF.Quad.html#map/2","title":"RDF.Quad.map/2","type":"function"},{"doc":"Creates a RDF.Quad with proper RDF values. An error is raised when the given elements are not coercible to RDF values. Note: The RDF.quad function is a shortcut to this function. Examples iex&gt; RDF.Quad . new { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 , &quot;http://example.com/Graph&quot; } { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; } iex&gt; RDF.Quad . new { EX.S , EX . p , 42 , EX.Graph } { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) } iex&gt; RDF.Quad . new { EX.S , EX . p , 42 } { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , nil } iex&gt; RDF.Quad . new { EX.S , :p , 42 , EX.Graph } , RDF.PropertyMap . new ( p : EX . p ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) }","ref":"RDF.Quad.html#new/2","title":"RDF.Quad.new/2","type":"function"},{"doc":"Creates a RDF.Quad with proper RDF values. An error is raised when the given elements are not coercible to RDF values. Note: The RDF.quad function is a shortcut to this function. Examples iex&gt; RDF.Quad . new ( &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 , &quot;http://example.com/Graph&quot; ) { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; } iex&gt; RDF.Quad . new ( EX.S , EX . p , 42 , EX.Graph ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) } iex&gt; RDF.Quad . new ( EX.S , :p , 42 , EX.Graph , RDF.PropertyMap . new ( p : EX . p ) ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) }","ref":"RDF.Quad.html#new/5","title":"RDF.Quad.new/5","type":"function"},{"doc":"Checks if the given tuple is a valid RDF quad. The elements of a valid RDF quad must be RDF terms. On the subject position only IRIs and blank nodes allowed, while on the predicate and graph name position only IRIs allowed. The object position can be any RDF term.","ref":"RDF.Quad.html#valid?/1","title":"RDF.Quad.valid?/1","type":"function"},{"doc":"Returns a tuple of native Elixir values from a RDF.Quad of RDF terms. When a :context option is given with a RDF.PropertyMap , predicates will be mapped to the terms defined in the RDF.PropertyMap , if present. Returns nil if one of the components of the given tuple is not convertible via RDF.Term.value/1 . Examples iex&gt; RDF.Quad . values { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; } { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 , &quot;http://example.com/Graph&quot; } iex&gt; { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; } ...&gt; |&gt; RDF.Quad . values ( context : %{ p : ~I&lt;http://example.com/p&gt; } ) { &quot;http://example.com/S&quot; , :p , 42 , &quot;http://example.com/Graph&quot; }","ref":"RDF.Quad.html#values/2","title":"RDF.Quad.values/2","type":"function"},{"doc":"","ref":"RDF.Quad.html#t:coercible/0","title":"RDF.Quad.coercible/0","type":"type"},{"doc":"","ref":"RDF.Quad.html#t:mapping_value/0","title":"RDF.Quad.mapping_value/0","type":"type"},{"doc":"","ref":"RDF.Quad.html#t:t/0","title":"RDF.Quad.t/0","type":"type"},{"doc":"","ref":"RDF.Quad.html#t:t_values/0","title":"RDF.Quad.t_values/0","type":"type"},{"doc":"The RDF Graph query API.","ref":"RDF.Query.html","title":"RDF.Query","type":"module"},{"doc":"Creates a RDF.Query.BGP struct. A basic graph pattern consist of single or list of triple patterns. A triple pattern is a tuple which consists of RDF terms or variables for the subject, predicate and object of a RDF triple. As RDF terms RDF.IRI s, RDF.BlankNode s, RDF.Literal s or all Elixir values which can be coerced to any of those are allowed, i.e. RDF.Vocabulary.Namespace atoms or Elixir values which can be coerced to RDF literals with RDF.Literal.coerce/1 (only on object position). On predicate position the :a atom can be used for the rdf:type property. Variables are written as atoms ending with a question mark. Blank nodes which in a graph query patterns act like a variable which doesn't show up in the results can be written as atoms starting with an underscore. Here's a basic graph pattern example: [ { :s? , :a , EX.Foo } , { :s? , :a , EX.Bar } , { :s? , RDFS . label , &quot;foo&quot; } , { :s? , :p? , :o? } ] Multiple triple patterns sharing the same subject and/or predicate can be grouped: Multiple objects to the same subject-predicate pair can be written by just writing them one by one in the same triple pattern. Multiple predicate-objects pair on the same subject can be written by grouping them with square brackets. With these, the previous example can be shortened to: { :s? , [ :a , EX.Foo , EX.Bar ] , [ RDFS . label , &quot;foo&quot; ] , [ :p? , :o? ] }","ref":"RDF.Query.html#bgp/1","title":"RDF.Query.bgp/1","type":"function"},{"doc":"Execute the given query against the given graph . As opposed to execute/3 this returns the results directly or fails with an exception.","ref":"RDF.Query.html#execute!/3","title":"RDF.Query.execute!/3","type":"function"},{"doc":"Execute the given query against the given graph . The query can be given directly as RDF.Query.BGP struct created with one of the builder functions in this module or as basic graph pattern expression accepted by bgp/1 . The result is a list of maps with the solutions for the variables in the graph pattern query and will be returned in a :ok tuple. In case of an error a :error tuple is returned. Example Let's assume we have an example_graph with these triples: @prefix foaf: &lt;http://xmlns.com/foaf/0.1/&gt; . @prefix ex: &lt;http://example.com/&gt; . ex:Outlaw foaf:name &quot;Johnny Lee Outlaw&quot; ; foaf:mbox &lt;mailto:jlow@example.com&gt; . ex:Goodguy foaf:name &quot;Peter Goodguy&quot; ; foaf:mbox &lt;mailto:peter@example.org&gt; ; foaf:friend ex:Outlaw . iex&gt; { :_ , FOAF . name , :name? } |&gt; RDF.Query . execute ( example_graph ( ) ) { :ok , [ %{ name : ~L&quot;Peter Goodguy&quot; } , %{ name : ~L&quot;Johnny Lee Outlaw&quot; } ] } iex&gt; [ ...&gt; { :_ , FOAF . name , :name? } , ...&gt; { :_ , FOAF . mbox , :mbox? } , ...&gt; ] |&gt; RDF.Query . execute ( example_graph ( ) ) { :ok , [ %{ name : ~L&quot;Peter Goodguy&quot; , mbox : ~I&lt;mailto:peter@example.org&gt; } , %{ name : ~L&quot;Johnny Lee Outlaw&quot; , mbox : ~I&lt;mailto:jlow@example.com&gt; } ] } iex&gt; query = [ ...&gt; { :_ , FOAF . name , :name? } , ...&gt; { :_ , FOAF . mbox , :mbox? } , ...&gt; ] |&gt; RDF.Query . bgp ( ) ...&gt; RDF.Query . execute ( query , example_graph ( ) ) { :ok , [ %{ name : ~L&quot;Peter Goodguy&quot; , mbox : ~I&lt;mailto:peter@example.org&gt; } , %{ name : ~L&quot;Johnny Lee Outlaw&quot; , mbox : ~I&lt;mailto:jlow@example.com&gt; } ] } iex&gt; [ ...&gt; EX.Goodguy , FOAF . friend , FOAF . name , :name? ...&gt; ] |&gt; RDF.Query . path ( ) |&gt; RDF.Query . execute ( example_graph ( ) ) { :ok , [ %{ name : ~L&quot;Johnny Lee Outlaw&quot; } ] }","ref":"RDF.Query.html#execute/3","title":"RDF.Query.execute/3","type":"function"},{"doc":"Creates a RDF.Query.BGP struct for a path through a graph. The elements of the path can consist of the same RDF terms and variable expressions allowed in bgp/1 expressions. Example The RDF.Query.BGP struct build with this: RDF.Query . path [ EX.S , EX . p , RDFS . label , :name? ] is the same as the one build by this bgp/1 call: RDF.Query . bgp [ { EX.S , EX . p , :_o } , { :_o , RDFS . label , :name? } , ]","ref":"RDF.Query.html#path/2","title":"RDF.Query.path/2","type":"function"},{"doc":"Returns a Stream for the execution of the given query against the given graph . As opposed to stream/3 this returns the stream directly or fails with an exception.","ref":"RDF.Query.html#stream!/3","title":"RDF.Query.stream!/3","type":"function"},{"doc":"Returns a Stream for the execution of the given query against the given graph . Just like on execute/3 the query can be given directly as RDF.Query.BGP struct created with one of the builder functions in this module or as basic graph pattern expression accepted by bgp/1 . The stream of solutions for variable bindings will be returned in a :ok tuple. In case of an error a :error tuple is returned. Example Let's assume we have an example_graph with these triples: @prefix foaf: &lt;http://xmlns.com/foaf/0.1/&gt; . @prefix ex: &lt;http://example.com/&gt; . ex:Outlaw foaf:name &quot;Johnny Lee Outlaw&quot; ; foaf:mbox &lt;mailto:jlow@example.com&gt; . ex:Goodguy foaf:name &quot;Peter Goodguy&quot; ; foaf:mbox &lt;mailto:peter@example.org&gt; ; foaf:friend ex:Outlaw . iex&gt; { :ok , stream } = { :_ , FOAF . name , :name? } |&gt; RDF.Query . stream ( example_graph ( ) ) ...&gt; Enum . to_list ( stream ) [ %{ name : ~L&quot;Peter Goodguy&quot; } , %{ name : ~L&quot;Johnny Lee Outlaw&quot; } ] iex&gt; { :ok , stream } = [ ...&gt; { :_ , FOAF . name , :name? } , ...&gt; { :_ , FOAF . mbox , :mbox? } , ...&gt; ] |&gt; RDF.Query . stream ( example_graph ( ) ) ...&gt; Enum . take ( stream , 1 ) [ %{ name : ~L&quot;Peter Goodguy&quot; , mbox : ~I&lt;mailto:peter@example.org&gt; } , ]","ref":"RDF.Query.html#stream/3","title":"RDF.Query.stream/3","type":"function"},{"doc":"A struct for Basic Graph Pattern queries. See RDF.Query and its functions on how to construct this query struct and apply it on RDF.Graph s.","ref":"RDF.Query.BGP.html","title":"RDF.Query.BGP","type":"module"},{"doc":"Return a list of all variables in a BGP.","ref":"RDF.Query.BGP.html#variables/1","title":"RDF.Query.BGP.variables/1","type":"function"},{"doc":"","ref":"RDF.Query.BGP.html#t:t/0","title":"RDF.Query.BGP.t/0","type":"type"},{"doc":"","ref":"RDF.Query.BGP.html#t:triple_pattern/0","title":"RDF.Query.BGP.triple_pattern/0","type":"type"},{"doc":"","ref":"RDF.Query.BGP.html#t:triple_patterns/0","title":"RDF.Query.BGP.triple_patterns/0","type":"type"},{"doc":"","ref":"RDF.Query.BGP.html#t:variable/0","title":"RDF.Query.BGP.variable/0","type":"type"},{"doc":"Shared functions over RDF.IRI s and RDF.BlankNode s.","ref":"RDF.Resource.html","title":"RDF.Resource","type":"module"},{"doc":"","ref":"RDF.Resource.html#t:coercible/0","title":"RDF.Resource.coercible/0","type":"type"},{"doc":"","ref":"RDF.Resource.html#t:t/0","title":"RDF.Resource.t/0","type":"type"},{"doc":"A configurable and customizable way to generate resource identifiers. The basis are different implementations of the behaviour defined in this module for configurable resource identifier generation methods. Generally two kinds of identifiers are differentiated: parameter-less identifiers which are generally random identifiers which are based on some value, where every attempt to create an identifier for the same value, should produce the same identifier Not all implementations must support both kind of identifiers. The RDF.Resource.Generator module provides two generate functions for the kindes of identifiers, generate/1 for random-based and generate/2 for value-based identifiers. The config keyword list they take must contain a :generator key, which provides the module implementing the RDF.Resource.Generator behaviour. All other keywords are specific to the generator implementation. When the generator is configured differently for the different identifier types, the identifier-type specific configuration can be put under the keys :random_based and :value_based respectively. The RDF.Resource.Generator.generate implementations will be called with the general configuration options from the top-level merged with the identifier-type specific configuration. The generate functions however are usually not called directly. See the guide on how they are meant to be used. The following RDF.Resource.Generator implementations are provided with RDF.ex: RDF.BlankNode RDF.BlankNode.Generator RDF.IRI.UUID.Generator","ref":"RDF.Resource.Generator.html","title":"RDF.Resource.Generator","type":"behaviour"},{"doc":"Generates a random resource identifier based on the given config . See the guide on how it is meant to be used.","ref":"RDF.Resource.Generator.html#generate/1","title":"RDF.Resource.Generator.generate/1","type":"function"},{"doc":"Generates a random resource identifier based on the given config .","ref":"RDF.Resource.Generator.html#c:generate/1","title":"RDF.Resource.Generator.generate/1","type":"callback"},{"doc":"Generates a resource identifier based on the given config and value . See the guide on how it is meant to be used.","ref":"RDF.Resource.Generator.html#generate/2","title":"RDF.Resource.Generator.generate/2","type":"function"},{"doc":"Generates a resource identifier based on the given config and value .","ref":"RDF.Resource.Generator.html#c:generate/2","title":"RDF.Resource.Generator.generate/2","type":"callback"},{"doc":"Allows to normalize the configuration. This callback is optional. A default implementation is generated which returns the configuration as-is.","ref":"RDF.Resource.Generator.html#c:generator_config/2","title":"RDF.Resource.Generator.generator_config/2","type":"callback"},{"doc":"","ref":"RDF.Resource.Generator.html#t:id_type/0","title":"RDF.Resource.Generator.id_type/0","type":"type"},{"doc":"Functions for working with RDF serializations generically. Besides some reflection functions regarding available serialization formats, this module includes the full serialization reader and writer API from the serialization format modules. As opposed to calling the reader and writer functions statically on the serialization format module, they can be used more dynamically on this module either by providing the format by name or media type with the :format option or in the case of the read and write function on files by relying on detection of the format by file extension.","ref":"RDF.Serialization.html","title":"RDF.Serialization","type":"module"},{"doc":"The list of all available RDF.Serialization.Format s in an application. A known format might not be available in an application, when the format is implemented in an external library and this not specified as a Mix dependency of this application. Examples iex&gt; RDF.Serialization . available_formats [ RDF.Turtle , RDF.NTriples , RDF.NQuads ]","ref":"RDF.Serialization.html#available_formats/0","title":"RDF.Serialization.available_formats/0","type":"function"},{"doc":"Returns the RDF.Serialization.Format with the given name, if available. Examples iex&gt; RDF.Serialization . format ( :turtle ) RDF.Turtle iex&gt; RDF.Serialization . format ( &quot;turtle&quot; ) RDF.Turtle iex&gt; RDF.Serialization . format ( :jsonld ) nil # unless json_ld is defined as a dependency of the application","ref":"RDF.Serialization.html#format/1","title":"RDF.Serialization.format/1","type":"function"},{"doc":"Returns the proper RDF.Serialization.Format for the given file extension, if available. Examples iex&gt; RDF.Serialization . format_by_extension ( &quot;ttl&quot; ) RDF.Turtle iex&gt; RDF.Serialization . format_by_extension ( &quot;.ttl&quot; ) RDF.Turtle iex&gt; RDF.Serialization . format_by_extension ( &quot;jsonld&quot; ) nil # unless json_ld is defined as a dependency of the application","ref":"RDF.Serialization.html#format_by_extension/1","title":"RDF.Serialization.format_by_extension/1","type":"function"},{"doc":"Returns the RDF.Serialization.Format with the given media type, if available. Examples iex&gt; RDF.Serialization . format_by_media_type ( &quot;text/turtle&quot; ) RDF.Turtle iex&gt; RDF.Serialization . format_by_media_type ( &quot;application/ld+json&quot; ) nil # unless json_ld is defined as a dependency of the application","ref":"RDF.Serialization.html#format_by_media_type/1","title":"RDF.Serialization.format_by_media_type/1","type":"function"},{"doc":"The list of all known RDF.Serialization.Format s in the RDF.ex eco-system. Note: Not all known formats might be available to an application, see available_formats/0 . Examples iex&gt; RDF.Serialization . formats [ RDF.Turtle , JSON.LD , RDF.NTriples , RDF.NQuads , RDF.XML ]","ref":"RDF.Serialization.html#formats/0","title":"RDF.Serialization.formats/0","type":"function"},{"doc":"Deserializes a graph or dataset from a file. As opposed to read_file/2 , it raises an exception if an error occurs and defaults to stream: true . The format can be specified with the format option and a format name or the media_type option and the media type of the format. If none of these are given, the format gets inferred from the extension of the given file name. See read_file/3 for the available format-independent options. Please refer to the documentation of the decoder of a RDF serialization format for format-specific options.","ref":"RDF.Serialization.html#read_file!/2","title":"RDF.Serialization.read_file!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a file. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. Options The format can be specified with the format option and a format name or the media_type option and the media type of the format. If none of these are given, the format gets inferred from the extension of the given file name. Other available serialization-independent options: :stream : Allows to enable reading the data from a file directly via a stream (default: false on this function, true on the bang version) :gzip : Allows to read directly from a gzipped file (default: false ) :file_mode : A list with the Elixir File.open modes to be used for reading (default: [:read, :utf8] ) Please refer to the documentation of the decoder of a RDF serialization format for format-specific options.","ref":"RDF.Serialization.html#read_file/2","title":"RDF.Serialization.read_file/2","type":"function"},{"doc":"Deserializes a graph or dataset from a stream. As opposed to read_stream/2 , it raises an exception if an error occurs. The format must be specified with the format option and a format name or the media_type option and the media type of the format. Please refer to the documentation of the decoder of a RDF serialization format for format-specific options.","ref":"RDF.Serialization.html#read_stream!/2","title":"RDF.Serialization.read_stream!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a stream. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. The format must be specified with the format option and a format name or the media_type option and the media type of the format. Please refer to the documentation of the decoder of a RDF serialization format for format-specific options.","ref":"RDF.Serialization.html#read_stream/2","title":"RDF.Serialization.read_stream/2","type":"function"},{"doc":"Deserializes a graph or dataset from a string. As opposed to read_string/2 , it raises an exception if an error occurs. The format must be specified with the format option and a format name or the media_type option and the media type of the format. Please refer to the documentation of the decoder of a RDF serialization format for format-specific options.","ref":"RDF.Serialization.html#read_string!/2","title":"RDF.Serialization.read_string!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a string. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. The format must be specified with the format option and a format name or the media_type option and the media type of the format. Please refer to the documentation of the decoder of a RDF serialization format for format-specific options.","ref":"RDF.Serialization.html#read_string/2","title":"RDF.Serialization.read_string/2","type":"function"},{"doc":"Serializes a RDF data structure to a file. As opposed to write_file/3 , it raises an exception if an error occurs. See write_file/3 for the available format-independent options. Please refer to the documentation of the encoder of a RDF serialization format for format-specific options.","ref":"RDF.Serialization.html#write_file!/3","title":"RDF.Serialization.write_file!/3","type":"function"},{"doc":"Serializes a RDF data structure to a file. It returns :ok if successful or {:error, reason} if an error occurs. Options The format can be specified with the format option and a format name or the media_type option and the media type of the format. If none of these are given, the format gets inferred from the extension of the given file name. Other available serialization-independent options: :stream : Allows to enable writing the serialized data to the file directly via a stream. Possible values: :string or :iodata for writing to the file with a stream of strings respective IO lists, true if you want to use streams, but don't care for the exact method or false for not writing with a stream (default: false on this function, :iodata on the bang version) :gzip : Allows to write directly to a gzipped file (default: false ) :force : If not set to true , an error is raised when the given file already exists (default: false ) :file_mode : A list with the Elixir File.open modes to be used for writing (default: [:write, :exclusive] ) Please refer to the documentation of the encoder of a RDF serialization format for format-specific options.","ref":"RDF.Serialization.html#write_file/3","title":"RDF.Serialization.write_file/3","type":"function"},{"doc":"Serializes a RDF data structure to a stream. The format must be specified with the format option and a format name or the media_type option and the media type of the format. Please refer to the documentation of the encoder of a RDF serialization format for format-specific options and what the stream emits.","ref":"RDF.Serialization.html#write_stream/2","title":"RDF.Serialization.write_stream/2","type":"function"},{"doc":"Serializes a RDF data structure to a string. As opposed to write_string/2 , it raises an exception if an error occurs. The format must be specified with the format option and a format name or the media_type option and the media type of the format. Please refer to the documentation of the encoder of a RDF serialization format for format-specific options.","ref":"RDF.Serialization.html#write_string!/2","title":"RDF.Serialization.write_string!/2","type":"function"},{"doc":"Serializes a RDF data structure to a string. It returns an {:ok, string} tuple, with string being the serialized graph or dataset, or {:error, reason} if an error occurs. The format must be specified with the format option and a format name or the media_type option and the media type of the format. Please refer to the documentation of the encoder of a RDF serialization format for format-specific options.","ref":"RDF.Serialization.html#write_string/2","title":"RDF.Serialization.write_string/2","type":"function"},{"doc":"","ref":"RDF.Serialization.html#t:format/0","title":"RDF.Serialization.format/0","type":"type"},{"doc":"A behaviour for decoders of strings encoded in a specific RDF.Serialization format.","ref":"RDF.Serialization.Decoder.html","title":"RDF.Serialization.Decoder","type":"behaviour"},{"doc":"Decodes a serialized RDF.Graph or RDF.Dataset from a string. As opposed to decode/2 , it raises an exception if an error occurs. Note: The __using__ macro automatically provides an overridable default implementation based on the non-bang decode function.","ref":"RDF.Serialization.Decoder.html#c:decode!/1","title":"RDF.Serialization.Decoder.decode!/1","type":"callback"},{"doc":"Decodes a serialized RDF.Graph or RDF.Dataset from a string. As opposed to decode/2 , it raises an exception if an error occurs. Note: The __using__ macro automatically provides an overridable default implementation based on the non-bang decode function.","ref":"RDF.Serialization.Decoder.html#c:decode!/2","title":"RDF.Serialization.Decoder.decode!/2","type":"callback"},{"doc":"Decodes a serialized RDF.Graph or RDF.Dataset from a string. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs.","ref":"RDF.Serialization.Decoder.html#c:decode/1","title":"RDF.Serialization.Decoder.decode/1","type":"callback"},{"doc":"Decodes a serialized RDF.Graph or RDF.Dataset from a string. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs.","ref":"RDF.Serialization.Decoder.html#c:decode/2","title":"RDF.Serialization.Decoder.decode/2","type":"callback"},{"doc":"Decodes a serialized RDF.Graph or RDF.Dataset from a stream. As opposed to decode_from_stream/2 , it raises an exception if an error occurs. Note: The __using__ macro automatically provides an overridable default implementation based on the non-bang decode function.","ref":"RDF.Serialization.Decoder.html#c:decode_from_stream!/2","title":"RDF.Serialization.Decoder.decode_from_stream!/2","type":"callback"},{"doc":"Decodes a serialized RDF.Graph or RDF.Dataset from a stream. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs.","ref":"RDF.Serialization.Decoder.html#c:decode_from_stream/2","title":"RDF.Serialization.Decoder.decode_from_stream/2","type":"callback"},{"doc":"A behaviour for encoders of RDF data structures in a specific RDF.Serialization format.","ref":"RDF.Serialization.Encoder.html","title":"RDF.Serialization.Encoder","type":"behaviour"},{"doc":"Serializes a RDF data structure into a string. As opposed to encode , it raises an exception if an error occurs. Note: The __using__ macro automatically provides an overridable default implementation based on the non-bang encode function.","ref":"RDF.Serialization.Encoder.html#c:encode!/1","title":"RDF.Serialization.Encoder.encode!/1","type":"callback"},{"doc":"Serializes a RDF data structure into a string. As opposed to encode , it raises an exception if an error occurs. Note: The __using__ macro automatically provides an overridable default implementation based on the non-bang encode function.","ref":"RDF.Serialization.Encoder.html#c:encode!/2","title":"RDF.Serialization.Encoder.encode!/2","type":"callback"},{"doc":"Serializes a RDF data structure into a string. It should return an {:ok, string} tuple, with string being the serialized RDF data structure, or {:error, reason} if an error occurs.","ref":"RDF.Serialization.Encoder.html#c:encode/1","title":"RDF.Serialization.Encoder.encode/1","type":"callback"},{"doc":"Serializes a RDF data structure into a string. It should return an {:ok, string} tuple, with string being the serialized RDF data structure, or {:error, reason} if an error occurs.","ref":"RDF.Serialization.Encoder.html#c:encode/2","title":"RDF.Serialization.Encoder.encode/2","type":"callback"},{"doc":"Serializes a RDF data structure into a stream. It should return a stream emitting either strings or iodata of the serialized RDF data structure. If both forms are supported the form should be configurable via the :mode option and its values :string respective :iodata .","ref":"RDF.Serialization.Encoder.html#c:stream/2","title":"RDF.Serialization.Encoder.stream/2","type":"callback"},{"doc":"A behaviour for RDF serialization formats. A serialization format can be implemented like this defmodule SomeFormat do use RDF.Serialization.Format import RDF.Sigils @id ~I&lt;http://example.com/some_format&gt; @name :some_format @extension &quot;ext&quot; @media_type &quot;application/some-format&quot; end When @id , @name , @extension and @media_type module attributes are defined the resp. behaviour functions are generated automatically and return these values. Then you'll have to do the main work by implementing a RDF.Serialization.Encoder and a RDF.Serialization.Decoder for the format. By default it is assumed that these are defined in Encoder and Decoder modules under the RDF.Serialization.Format module of the format, i.e. in the example above in SomeFormat.Encoder and SomeFormat.Decoder . If you want them in another module, you'll have to override the encoder/0 and/or decoder/0 functions in your RDF.Serialization.Format module.","ref":"RDF.Serialization.Format.html","title":"RDF.Serialization.Format","type":"behaviour"},{"doc":"The RDF.Serialization.Decoder module for the serialization format.","ref":"RDF.Serialization.Format.html#c:decoder/0","title":"RDF.Serialization.Format.decoder/0","type":"callback"},{"doc":"The RDF.Serialization.Encoder module for the serialization format.","ref":"RDF.Serialization.Format.html#c:encoder/0","title":"RDF.Serialization.Format.encoder/0","type":"callback"},{"doc":"The usual file extension for the serialization format.","ref":"RDF.Serialization.Format.html#c:extension/0","title":"RDF.Serialization.Format.extension/0","type":"callback"},{"doc":"An IRI of the serialization format.","ref":"RDF.Serialization.Format.html#c:id/0","title":"RDF.Serialization.Format.id/0","type":"callback"},{"doc":"The MIME type of the serialization format.","ref":"RDF.Serialization.Format.html#c:media_type/0","title":"RDF.Serialization.Format.media_type/0","type":"callback"},{"doc":"An name atom of the serialization format.","ref":"RDF.Serialization.Format.html#c:name/0","title":"RDF.Serialization.Format.name/0","type":"callback"},{"doc":"Sigils for the most common types of RDF nodes.","ref":"RDF.Sigils.html","title":"RDF.Sigils","type":"module"},{"doc":"Handles the sigil ~B for blank nodes. It returns an RDF.BlankNode from the given string without interpolations and without escape characters, except for the escaping of the closing sigil character itself. Examples iex&gt; import RDF.Sigils iex&gt; ~B&lt;foo&gt; RDF . bnode ( &quot;foo&quot; )","ref":"RDF.Sigils.html#sigil_B/2","title":"RDF.Sigils.sigil_B/2","type":"macro"},{"doc":"Handles the sigil ~b for blank nodes. It returns an RDF.BlankNode from the given string as if it was a double quoted string, unescaping characters and replacing interpolations. Examples iex&gt; import RDF.Sigils iex&gt; ~b&lt;foo \#{ String . downcase ( &quot;Bar&quot; ) } &gt; RDF . bnode ( &quot;foobar&quot; )","ref":"RDF.Sigils.html#sigil_b/2","title":"RDF.Sigils.sigil_b/2","type":"macro"},{"doc":"Handles the sigil ~I for IRIs. It returns an RDF.IRI from the given string without interpolations and without escape characters, except for the escaping of the closing sigil character itself. Examples iex&gt; import RDF.Sigils iex&gt; ~I&lt;http://example.com&gt; RDF . iri ( &quot;http://example.com&quot; )","ref":"RDF.Sigils.html#sigil_I/2","title":"RDF.Sigils.sigil_I/2","type":"macro"},{"doc":"Handles the sigil ~i for IRIs. It returns an RDF.IRI from the given string as if it was a double quoted string, unescaping characters and replacing interpolations. Examples iex&gt; import RDF.Sigils iex&gt; ~i&lt;http://example.com/ \#{ String . downcase ( &quot;Foo&quot; ) } &gt; RDF . iri ( &quot;http://example.com/foo&quot; )","ref":"RDF.Sigils.html#sigil_i/2","title":"RDF.Sigils.sigil_i/2","type":"macro"},{"doc":"Handles the sigil ~L for plain Literals. It returns an RDF.Literal from the given string without interpolations and without escape characters, except for the escaping of the closing sigil character itself. The sigil modifier can be used to specify a language tag. Note: Languages with subtags are not supported. Examples iex&gt; import RDF.Sigils iex&gt; ~L&quot;foo&quot; RDF . literal ( &quot;foo&quot; ) iex&gt; ~L&quot;foo&quot;en RDF . literal ( &quot;foo&quot; , language : &quot;en&quot; )","ref":"RDF.Sigils.html#sigil_L/2","title":"RDF.Sigils.sigil_L/2","type":"macro"},{"doc":"Handles the sigil ~l for blank nodes. It returns an RDF.Literal from the given string as if it was a double quoted string, unescaping characters and replacing interpolations. Examples iex&gt; import RDF.Sigils iex&gt; ~l&quot;foo \#{ String . downcase ( &quot;Bar&quot; ) } &quot; RDF . literal ( &quot;foo bar&quot; ) iex&gt; ~l&quot;foo \#{ String . downcase ( &quot;Bar&quot; ) } &quot;en RDF . literal ( &quot;foo bar&quot; , language : &quot;en&quot; )","ref":"RDF.Sigils.html#sigil_l/2","title":"RDF.Sigils.sigil_l/2","type":"macro"},{"doc":"Helper functions for RDF-star quads. An RDF-star quad is represented as a plain Elixir tuple consisting of four valid RDF values for subject, predicate, object and a graph name. As opposed to an RDF.Quad the subject or object can be a triple.","ref":"RDF.Star.Quad.html","title":"RDF.Star.Quad","type":"module"},{"doc":"Creates a RDF.Star.Quad with proper RDF-star values. An error is raised when the given elements are not coercible to RDF-star values. Note: The RDF.quad function is a shortcut to this function. Examples iex&gt; RDF.Star.Quad . new { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 , &quot;http://example.com/Graph&quot; } { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; } iex&gt; RDF.Star.Quad . new { EX.S , EX . p , 42 , EX.Graph } { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) } iex&gt; RDF.Star.Quad . new { EX.S , EX . p , 42 } { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , nil } iex&gt; RDF.Star.Quad . new { EX.S , :p , 42 , EX.Graph } , RDF.PropertyMap . new ( p : EX . p ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) } iex&gt; RDF.Star.Quad . new ( { { EX.S , :p , 42 } , :p2 , 43 , EX.Graph } , RDF.PropertyMap . new ( p : EX . p , p2 : EX . p2 ) ) { { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } , ~I&lt;http://example.com/p2&gt; , RDF . literal ( 43 ) , ~I&lt;http://example.com/Graph&gt; }","ref":"RDF.Star.Quad.html#new/2","title":"RDF.Star.Quad.new/2","type":"function"},{"doc":"Creates a RDF.Star.Quad with proper RDF-star values. An error is raised when the given elements are not coercible to RDF-star values. Note: The RDF.quad function is a shortcut to this function. Examples iex&gt; RDF.Star.Quad . new ( &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 , &quot;http://example.com/Graph&quot; ) { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; } iex&gt; RDF.Star.Quad . new ( EX.S , EX . p , 42 , EX.Graph ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) } iex&gt; RDF.Star.Quad . new ( EX.S , :p , 42 , EX.Graph , RDF.PropertyMap . new ( p : EX . p ) ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) } iex&gt; RDF.Star.Quad . new ( EX.S , :p , 42 , EX.Graph , RDF.PropertyMap . new ( p : EX . p ) ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) } iex&gt; RDF.Star.Quad . new ( { EX.S , :p , 42 } , :p2 , 43 , EX.Graph , RDF.PropertyMap . new ( p : EX . p , p2 : EX . p2 ) ) { { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } , ~I&lt;http://example.com/p2&gt; , RDF . literal ( 43 ) , ~I&lt;http://example.com/Graph&gt; }","ref":"RDF.Star.Quad.html#new/5","title":"RDF.Star.Quad.new/5","type":"function"},{"doc":"Checks if the given tuple is a valid RDF quad. The elements of a valid RDF-star quad must be RDF terms. On the subject position only IRIs, blank nodes and triples are allowed, while on the predicate and graph name position only IRIs allowed. The object position can be any RDF term or triple.","ref":"RDF.Star.Quad.html#valid?/1","title":"RDF.Star.Quad.valid?/1","type":"function"},{"doc":"","ref":"RDF.Star.Quad.html#t:coercible/0","title":"RDF.Star.Quad.coercible/0","type":"type"},{"doc":"","ref":"RDF.Star.Quad.html#t:t/0","title":"RDF.Star.Quad.t/0","type":"type"},{"doc":"Helper functions for RDF-star statements. An RDF-star statement is either a RDF.Star.Triple or a RDF.Star.Quad .","ref":"RDF.Star.Statement.html","title":"RDF.Star.Statement","type":"module"},{"doc":"Creates a RDF.Star.Statement tuple with proper RDF values. An error is raised when the given elements are not coercible to RDF-star values. Examples iex&gt; RDF.Star.Statement . coerce { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 } { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } iex&gt; RDF.Star.Statement . coerce { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 , &quot;http://example.com/Graph&quot; } { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; }","ref":"RDF.Star.Statement.html#coerce/2","title":"RDF.Star.Statement.coerce/2","type":"function"},{"doc":"See RDF.Statement.coerce_graph_name/1 .","ref":"RDF.Star.Statement.html#coerce_graph_name/1","title":"RDF.Star.Statement.coerce_graph_name/1","type":"function"},{"doc":"See RDF.Statement.coerce_predicate/1 .","ref":"RDF.Star.Statement.html#coerce_predicate/1","title":"RDF.Star.Statement.coerce_predicate/1","type":"function"},{"doc":"See RDF.Statement.coerce_predicate/2 .","ref":"RDF.Star.Statement.html#coerce_predicate/2","title":"RDF.Star.Statement.coerce_predicate/2","type":"function"},{"doc":"Creates a RDF.Star.Triple or RDF.Star.Quad with proper RDF values. An error is raised when the given elements are not coercible to RDF-star values. Note: The RDF.statement function is a shortcut to this function. Examples iex&gt; RDF.Star.Statement . new ( { EX.S , EX . p , 42 } ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) } iex&gt; RDF.Star.Statement . new ( { EX.S , EX . p , 42 , EX.Graph } ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) } iex&gt; RDF.Star.Statement . new ( { EX.S , :p , 42 , EX.Graph } , RDF.PropertyMap . new ( p : EX . p ) ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) }","ref":"RDF.Star.Statement.html#new/2","title":"RDF.Star.Statement.new/2","type":"function"},{"doc":"See RDF.Star.Triple.new/3 .","ref":"RDF.Star.Statement.html#new/3","title":"RDF.Star.Statement.new/3","type":"function"},{"doc":"See RDF.Star.Quad.new/4 .","ref":"RDF.Star.Statement.html#new/4","title":"RDF.Star.Statement.new/4","type":"function"},{"doc":"Checks if the given tuple is a RDF-star statement with a quoted triple on subject or object position. Note: This function won't check if the given tuple or the quoted triple is valid. Use valid?/1 for this purpose. Examples iex&gt; RDF.Star.Statement . star_statement? ( { EX.S , EX.P , EX.O } ) false iex&gt; RDF.Star.Statement . star_statement? ( { EX.AS , EX.AP , { EX.S , EX.P , EX.O } } ) true iex&gt; RDF.Star.Statement . star_statement? ( { { EX.S , EX.P , EX.O } , EX.AP , EX.AO } ) true","ref":"RDF.Star.Statement.html#star_statement?/1","title":"RDF.Star.Statement.star_statement?/1","type":"function"},{"doc":"","ref":"RDF.Star.Statement.html#valid_graph_name?/1","title":"RDF.Star.Statement.valid_graph_name?/1","type":"function"},{"doc":"","ref":"RDF.Star.Statement.html#valid_object?/1","title":"RDF.Star.Statement.valid_object?/1","type":"function"},{"doc":"","ref":"RDF.Star.Statement.html#valid_predicate?/1","title":"RDF.Star.Statement.valid_predicate?/1","type":"function"},{"doc":"","ref":"RDF.Star.Statement.html#valid_subject?/1","title":"RDF.Star.Statement.valid_subject?/1","type":"function"},{"doc":"Checks if the given tuple is a valid RDF-star statement, i.e. RDF-star triple or quad. The elements of a valid RDF-star statement must be RDF terms. On the subject position only IRIs, blank nodes and triples allowed, while on the predicate and graph context position only IRIs allowed. The object position can be any RDF term or a triple.","ref":"RDF.Star.Statement.html#valid?/1","title":"RDF.Star.Statement.valid?/1","type":"function"},{"doc":"","ref":"RDF.Star.Statement.html#t:coercible/0","title":"RDF.Star.Statement.coercible/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:coercible_graph_name/0","title":"RDF.Star.Statement.coercible_graph_name/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:coercible_object/0","title":"RDF.Star.Statement.coercible_object/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:coercible_predicate/0","title":"RDF.Star.Statement.coercible_predicate/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:coercible_subject/0","title":"RDF.Star.Statement.coercible_subject/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:coercible_t/0","title":"RDF.Star.Statement.coercible_t/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:graph_name/0","title":"RDF.Star.Statement.graph_name/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:object/0","title":"RDF.Star.Statement.object/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:predicate/0","title":"RDF.Star.Statement.predicate/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:subject/0","title":"RDF.Star.Statement.subject/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:t/0","title":"RDF.Star.Statement.t/0","type":"type"},{"doc":"","ref":"RDF.Star.Statement.html#t:term_mapping/0","title":"RDF.Star.Statement.term_mapping/0","type":"type"},{"doc":"Helper functions for RDF-star triples. An RDF-star triple is represented as a plain Elixir tuple consisting of three valid RDF values for subject, predicate and object. As opposed to an RDF.Triple the subject or object can be a triple itself.","ref":"RDF.Star.Triple.html","title":"RDF.Star.Triple","type":"module"},{"doc":"Creates a RDF.Star.Triple with proper RDF-star values. An error is raised when the given elements are not coercible to RDF-star values. Note: The RDF.triple function is a shortcut to this function. Examples iex&gt; RDF.Star.Triple . new { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 } { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } iex&gt; RDF.Star.Triple . new { EX.S , EX . p , 42 } { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) } iex&gt; RDF.Star.Triple . new { EX.S , EX . p , 42 , EX.Graph } { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) } iex&gt; RDF.Star.Triple . new { EX.S , :p , 42 } , RDF.PropertyMap . new ( p : EX . p ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) } iex&gt; RDF.Star.Triple . new ( { { EX.S , :p , 42 } , :p2 , 43 } , RDF.PropertyMap . new ( p : EX . p , p2 : EX . p2 ) ) { { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } , ~I&lt;http://example.com/p2&gt; , RDF . literal ( 43 ) }","ref":"RDF.Star.Triple.html#new/2","title":"RDF.Star.Triple.new/2","type":"function"},{"doc":"Creates a RDF.Star.Triple with proper RDF-star values. An error is raised when the given elements are not coercible to RDF-star values. Note: The RDF.triple function is a shortcut to this function. Examples iex&gt; RDF.Star.Triple . new ( { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 } , &quot;http://example.com/p2&quot; , 43 ) { { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } , ~I&lt;http://example.com/p2&gt; , RDF . literal ( 43 ) } iex&gt; RDF.Star.Triple . new ( { EX.S , EX . p , 42 } , EX . p2 , 43 ) { { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } , ~I&lt;http://example.com/p2&gt; , RDF . literal ( 43 ) } iex&gt; RDF.Star.Triple . new ( EX.S , EX . p , 42 ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) } iex&gt; RDF.Star.Triple . new ( { EX.S , :p , 42 } , :p2 , 43 , RDF.PropertyMap . new ( p : EX . p , p2 : EX . p2 ) ) { { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } , ~I&lt;http://example.com/p2&gt; , RDF . literal ( 43 ) }","ref":"RDF.Star.Triple.html#new/4","title":"RDF.Star.Triple.new/4","type":"function"},{"doc":"Checks if the given tuple is a valid RDF-star triple. The elements of a valid RDF-star triple must be RDF terms. On the subject position only IRIs, blank nodes and triples are allowed, while on the predicate position only IRIs allowed. The object position can be any RDF term or triple.","ref":"RDF.Star.Triple.html#valid?/1","title":"RDF.Star.Triple.valid?/1","type":"function"},{"doc":"","ref":"RDF.Star.Triple.html#t:coercible/0","title":"RDF.Star.Triple.coercible/0","type":"type"},{"doc":"","ref":"RDF.Star.Triple.html#t:t/0","title":"RDF.Star.Triple.t/0","type":"type"},{"doc":"Helper functions for RDF statements. An RDF statement is either a RDF.Triple or a RDF.Quad .","ref":"RDF.Statement.html","title":"RDF.Statement","type":"module"},{"doc":"Creates a RDF.Statement tuple with proper RDF values. An error is raised when the given elements are not coercible to RDF values. Examples iex&gt; RDF.Statement . coerce { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 } { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } iex&gt; RDF.Statement . coerce { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 , &quot;http://example.com/Graph&quot; } { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; }","ref":"RDF.Statement.html#coerce/2","title":"RDF.Statement.coerce/2","type":"function"},{"doc":"","ref":"RDF.Statement.html#default_property_mapping/1","title":"RDF.Statement.default_property_mapping/1","type":"function"},{"doc":"Returns a tuple of native Elixir values from a RDF.Statement of RDF terms. Returns nil if one of the components of the given tuple is not convertible via RDF.Term.value/1 . The optional second argument allows to specify a custom mapping with a function which will receive a tuple {statement_position, rdf_term} where statement_position is one of the atoms :subject , :predicate , :object or :graph_name , while rdf_term is the RDF term to be mapped. When the given function returns nil this will be interpreted as an error and will become the overhaul result of the values/2 call. Examples iex&gt; { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; } ...&gt; |&gt; RDF.Statement . map ( fn ...&gt; { :subject , subject } -&gt; ...&gt; subject |&gt; to_string ( ) |&gt; String . last ( ) ...&gt; { :predicate , predicate } -&gt; ...&gt; predicate |&gt; to_string ( ) |&gt; String . last ( ) |&gt; String . to_atom ( ) ...&gt; { :object , object } -&gt; ...&gt; RDF.Term . value ( object ) ...&gt; { :graph_name , graph_name } -&gt; ...&gt; graph_name ...&gt; end ) { &quot;S&quot; , :p , 42 , ~I&lt;http://example.com/Graph&gt; }","ref":"RDF.Statement.html#map/2","title":"RDF.Statement.map/2","type":"function"},{"doc":"Creates a RDF.Triple or RDF.Quad with proper RDF values. An error is raised when the given elements are not coercible to RDF values. Note: The RDF.statement function is a shortcut to this function. Examples iex&gt; RDF.Statement . new ( { EX.S , EX . p , 42 } ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) } iex&gt; RDF.Statement . new ( { EX.S , EX . p , 42 , EX.Graph } ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) } iex&gt; RDF.Statement . new ( { EX.S , :p , 42 , EX.Graph } , RDF.PropertyMap . new ( p : EX . p ) ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) , RDF . iri ( &quot;http://example.com/Graph&quot; ) }","ref":"RDF.Statement.html#new/2","title":"RDF.Statement.new/2","type":"function"},{"doc":"See RDF.Triple.new/3 .","ref":"RDF.Statement.html#new/3","title":"RDF.Statement.new/3","type":"function"},{"doc":"See RDF.Quad.new/4 .","ref":"RDF.Statement.html#new/4","title":"RDF.Statement.new/4","type":"function"},{"doc":"","ref":"RDF.Statement.html#valid_graph_name?/1","title":"RDF.Statement.valid_graph_name?/1","type":"function"},{"doc":"","ref":"RDF.Statement.html#valid_object?/1","title":"RDF.Statement.valid_object?/1","type":"function"},{"doc":"","ref":"RDF.Statement.html#valid_predicate?/1","title":"RDF.Statement.valid_predicate?/1","type":"function"},{"doc":"","ref":"RDF.Statement.html#valid_subject?/1","title":"RDF.Statement.valid_subject?/1","type":"function"},{"doc":"Checks if the given tuple is a valid RDF statement, i.e. RDF triple or quad. The elements of a valid RDF statement must be RDF terms. On the subject position only IRIs and blank nodes allowed, while on the predicate and graph context position only IRIs allowed. The object position can be any RDF term.","ref":"RDF.Statement.html#valid?/1","title":"RDF.Statement.valid?/1","type":"function"},{"doc":"Returns a tuple of native Elixir values from a RDF.Statement of RDF terms. When a :context option is given with a RDF.PropertyMap , predicates will be mapped to the terms defined in the RDF.PropertyMap , if present. Returns nil if one of the components of the given tuple is not convertible via RDF.Term.value/1 . Examples iex&gt; RDF.Statement . values { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 } iex&gt; RDF.Statement . values { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) , ~I&lt;http://example.com/Graph&gt; } { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 , &quot;http://example.com/Graph&quot; } iex&gt; { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } ...&gt; |&gt; RDF.Statement . values ( context : %{ p : ~I&lt;http://example.com/p&gt; } ) { &quot;http://example.com/S&quot; , :p , 42 }","ref":"RDF.Statement.html#values/2","title":"RDF.Statement.values/2","type":"function"},{"doc":"","ref":"RDF.Statement.html#t:coercible/0","title":"RDF.Statement.coercible/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:coercible_graph_name/0","title":"RDF.Statement.coercible_graph_name/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:coercible_object/0","title":"RDF.Statement.coercible_object/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:coercible_predicate/0","title":"RDF.Statement.coercible_predicate/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:coercible_subject/0","title":"RDF.Statement.coercible_subject/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:coercible_t/0","title":"RDF.Statement.coercible_t/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:graph_name/0","title":"RDF.Statement.graph_name/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:object/0","title":"RDF.Statement.object/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:position/0","title":"RDF.Statement.position/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:predicate/0","title":"RDF.Statement.predicate/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:qualified_term/0","title":"RDF.Statement.qualified_term/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:subject/0","title":"RDF.Statement.subject/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:t/0","title":"RDF.Statement.t/0","type":"type"},{"doc":"","ref":"RDF.Statement.html#t:term_mapping/0","title":"RDF.Statement.term_mapping/0","type":"type"},{"doc":"Shared behaviour for all RDF terms. A RDF.Term is anything which can be an element of RDF statements of a RDF graph: RDF.IRI s RDF.BlankNode s RDF.Literal s see https://www.w3.org/TR/sparql11-query/#defn_RDFTerm","ref":"RDF.Term.html","title":"RDF.Term","type":"protocol"},{"doc":"Converts a given value into a RDF term. Returns nil if the given value is not convertible into any valid RDF.Term. Examples iex&gt; RDF.Term . coerce ( &quot;foo&quot; ) ~L&quot;foo&quot; iex&gt; RDF.Term . coerce ( 42 ) RDF.XSD . integer ( 42 )","ref":"RDF.Term.html#coerce/1","title":"RDF.Term.coerce/1","type":"function"},{"doc":"Tests for equality of values. Non-RDF terms are tried to be coerced via RDF.Term.coerce/1 before comparison. Returns nil if the given terms are not comparable. see http://www.w3.org/TR/rdf-sparql-query/#func-RDFterm-equal and the value equality semantics of the different literal datatypes here: https://www.w3.org/TR/sparql11-query/#OperatorMapping","ref":"RDF.Term.html#equal_value?/2","title":"RDF.Term.equal_value?/2","type":"function"},{"doc":"Tests for term equality. see http://www.w3.org/TR/rdf-sparql-query/#func-sameTerm","ref":"RDF.Term.html#equal?/2","title":"RDF.Term.equal?/2","type":"function"},{"doc":"Checks if the given value is a RDF term. Note: As opposed to RDF.term? this function returns false on atoms and does not try to resolve them to IRIs. Examples iex&gt; RDF.Term . term? ( RDF . iri ( &quot;http://example.com/resource&quot; ) ) true iex&gt; RDF.Term . term? ( EX.Resource ) false iex&gt; RDF.Term . term? ( RDF . bnode ) true iex&gt; RDF.Term . term? ( RDF.XSD . integer ( 42 ) ) true iex&gt; RDF.Term . term? ( 42 ) false","ref":"RDF.Term.html#term?/1","title":"RDF.Term.term?/1","type":"function"},{"doc":"Returns the native Elixir value of a RDF term. Returns nil if the given value is not a a valid RDF term or a value convertible to a RDF term. Examples iex&gt; RDF.Term . value ( ~I&lt;http://example.com/&gt; ) &quot;http://example.com/&quot; iex&gt; RDF.Term . value ( ~L&quot;foo&quot; ) &quot;foo&quot; iex&gt; RDF.XSD . integer ( 42 ) |&gt; RDF.Term . value ( ) 42","ref":"RDF.Term.html#value/1","title":"RDF.Term.value/1","type":"function"},{"doc":"","ref":"RDF.Term.html#t:t/0","title":"RDF.Term.t/0","type":"type"},{"doc":"Helper functions for RDF triples. An RDF Triple is represented as a plain Elixir tuple consisting of three valid RDF values for subject, predicate and object.","ref":"RDF.Triple.html","title":"RDF.Triple","type":"module"},{"doc":"Returns a triple where each element from a RDF.Triple is mapped with the given function. Returns nil if one of the components of the given tuple is not convertible via RDF.Term.value/1 . The function fun will receive a tuple {statement_position, rdf_term} where statement_position is one of the atoms :subject , :predicate or :object , while rdf_term is the RDF term to be mapped. When the given function returns nil this will be interpreted as an error and will become the overhaul result of the map/2 call. Examples iex&gt; { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } ...&gt; |&gt; RDF.Triple . map ( fn ...&gt; { :object , object } -&gt; RDF.Term . value ( object ) ...&gt; { _ , term } -&gt; term |&gt; to_string ( ) |&gt; String . last ( ) ...&gt; end ) { &quot;S&quot; , &quot;p&quot; , 42 }","ref":"RDF.Triple.html#map/2","title":"RDF.Triple.map/2","type":"function"},{"doc":"Creates a RDF.Triple with proper RDF values. An error is raised when the given elements are not coercible to RDF values. Note: The RDF.triple function is a shortcut to this function. Examples iex&gt; RDF.Triple . new { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 } { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } iex&gt; RDF.Triple . new { EX.S , EX . p , 42 } { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) } iex&gt; RDF.Triple . new { EX.S , EX . p , 42 , EX.Graph } { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) } iex&gt; RDF.Triple . new { EX.S , :p , 42 } , RDF.PropertyMap . new ( p : EX . p ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) }","ref":"RDF.Triple.html#new/2","title":"RDF.Triple.new/2","type":"function"},{"doc":"Creates a RDF.Triple with proper RDF values. An error is raised when the given elements are not coercible to RDF values. Note: The RDF.triple function is a shortcut to this function. Examples iex&gt; RDF.Triple . new ( &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 ) { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } iex&gt; RDF.Triple . new ( EX.S , EX . p , 42 ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) } iex&gt; RDF.Triple . new ( EX.S , :p , 42 , RDF.PropertyMap . new ( p : EX . p ) ) { RDF . iri ( &quot;http://example.com/S&quot; ) , RDF . iri ( &quot;http://example.com/p&quot; ) , RDF . literal ( 42 ) }","ref":"RDF.Triple.html#new/4","title":"RDF.Triple.new/4","type":"function"},{"doc":"Checks if the given tuple is a valid RDF triple. The elements of a valid RDF triple must be RDF terms. On the subject position only IRIs and blank nodes allowed, while on the predicate position only IRIs allowed. The object position can be any RDF term.","ref":"RDF.Triple.html#valid?/1","title":"RDF.Triple.valid?/1","type":"function"},{"doc":"Returns a tuple of native Elixir values from a RDF.Triple of RDF terms. When a :context option is given with a RDF.PropertyMap , predicates will be mapped to the terms defined in the RDF.PropertyMap , if present. Returns nil if one of the components of the given tuple is not convertible via RDF.Term.value/1 . Examples iex&gt; RDF.Triple . values { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } { &quot;http://example.com/S&quot; , &quot;http://example.com/p&quot; , 42 } iex&gt; { ~I&lt;http://example.com/S&gt; , ~I&lt;http://example.com/p&gt; , RDF . literal ( 42 ) } ...&gt; |&gt; RDF.Triple . values ( context : %{ p : ~I&lt;http://example.com/p&gt; } ) { &quot;http://example.com/S&quot; , :p , 42 }","ref":"RDF.Triple.html#values/2","title":"RDF.Triple.values/2","type":"function"},{"doc":"","ref":"RDF.Triple.html#t:coercible/0","title":"RDF.Triple.coercible/0","type":"type"},{"doc":"","ref":"RDF.Triple.html#t:mapping_value/0","title":"RDF.Triple.mapping_value/0","type":"type"},{"doc":"","ref":"RDF.Triple.html#t:t/0","title":"RDF.Triple.t/0","type":"type"},{"doc":"","ref":"RDF.Triple.html#t:t_values/0","title":"RDF.Triple.t_values/0","type":"type"},{"doc":"RDF.Turtle provides support for the Turtle serialization format. See RDF.Turtle.Decoder and RDF.Turtle.Encoder for the available options on the read and write functions. For more on Turtle see https://www.w3.org/TR/turtle/ .","ref":"RDF.Turtle.html","title":"RDF.Turtle","type":"module"},{"doc":"Deserializes a graph or dataset from a file. As opposed to read_file/2 , it raises an exception if an error occurs and defaults to stream: true . See read_file/3 for the available format-independent options. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.Turtle.html#read_file!/2","title":"RDF.Turtle.read_file!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a file. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. Options General serialization-independent options: :stream : Allows to enable reading the data from a file directly via a stream (default: false on this function, true on the bang version) :gzip : Allows to read directly from a gzipped file (default: false ) :file_mode : A list with the Elixir File.open modes to be used for reading (default: [:read, :utf8] ) See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.Turtle.html#read_file/2","title":"RDF.Turtle.read_file/2","type":"function"},{"doc":"Deserializes a graph or dataset from a stream. As opposed to read_stream/2 , it raises an exception if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.Turtle.html#read_stream!/2","title":"RDF.Turtle.read_stream!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a stream. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.Turtle.html#read_stream/2","title":"RDF.Turtle.read_stream/2","type":"function"},{"doc":"Deserializes a graph or dataset from a string. As opposed to read_string/2 , it raises an exception if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.Turtle.html#read_string!/2","title":"RDF.Turtle.read_string!/2","type":"function"},{"doc":"Deserializes a graph or dataset from a string. It returns an {:ok, data} tuple, with data being the deserialized graph or dataset, or {:error, reason} if an error occurs. See the module documentation of the decoder for the available format-specific options, all of which can be used in this function and will be passed them through to the decoder.","ref":"RDF.Turtle.html#read_string/2","title":"RDF.Turtle.read_string/2","type":"function"},{"doc":"Serializes a RDF data structure to a file. As opposed to write_file/3 , it raises an exception if an error occurs. See write_file/3 for the available format-independent options. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.Turtle.html#write_file!/3","title":"RDF.Turtle.write_file!/3","type":"function"},{"doc":"Serializes a RDF data structure to a file. It returns :ok if successful or {:error, reason} if an error occurs. Options General serialization-independent options: :stream : Allows to enable writing the serialized data to the file directly via a stream. Possible values: :string or :iodata for writing to the file with a stream of strings respective IO lists, true if you want to use streams, but don't care for the exact method or false for not writing with a stream (default: false on this function, :iodata on the bang version) :gzip : Allows to write directly to a gzipped file (default: false ) :force : If not set to true , an error is raised when the given file already exists (default: false ) :file_mode : A list with the Elixir File.open modes to be used for writing (default: [:write, :exclusive] ) See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.Turtle.html#write_file/3","title":"RDF.Turtle.write_file/3","type":"function"},{"doc":"Serializes a RDF data structure to a string. As opposed to write_string/2 , it raises an exception if an error occurs. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.Turtle.html#write_string!/2","title":"RDF.Turtle.write_string!/2","type":"function"},{"doc":"Serializes a RDF data structure to a string. It returns an {:ok, string} tuple, with string being the serialized graph or dataset, or {:error, reason} if an error occurs. See the module documentation of the encoder for the available format-specific options, all of which can be used in this function and will be passed them through to the encoder.","ref":"RDF.Turtle.html#write_string/2","title":"RDF.Turtle.write_string/2","type":"function"},{"doc":"A decoder for N-Triples serializations to RDF.Graph s. As for all decoders of RDF.Serialization.Format s, you normally won't use these functions directly, but via one of the read_ functions on the RDF.Turtle format module or the generic RDF.Serialization module. Options :base : allows to specify the base URI to be used against relative URIs when no base URI is defined with a @base directive within the document","ref":"RDF.Turtle.Decoder.html","title":"RDF.Turtle.Decoder","type":"module"},{"doc":"","ref":"RDF.Turtle.Decoder.html#parse/1","title":"RDF.Turtle.Decoder.parse/1","type":"function"},{"doc":"","ref":"RDF.Turtle.Decoder.html#tokenize/1","title":"RDF.Turtle.Decoder.tokenize/1","type":"function"},{"doc":"","ref":"RDF.Turtle.Decoder.State.html","title":"RDF.Turtle.Decoder.State","type":"module"},{"doc":"","ref":"RDF.Turtle.Decoder.State.html#add_namespace/3","title":"RDF.Turtle.Decoder.State.add_namespace/3","type":"function"},{"doc":"","ref":"RDF.Turtle.Decoder.State.html#next_bnode/1","title":"RDF.Turtle.Decoder.State.next_bnode/1","type":"function"},{"doc":"","ref":"RDF.Turtle.Decoder.State.html#ns/2","title":"RDF.Turtle.Decoder.State.ns/2","type":"function"},{"doc":"An encoder for Turtle serializations of RDF.ex data structures. As for all encoders of RDF.Serialization.Format s, you normally won't use these functions directly, but via one of the write_ functions on the RDF.Turtle format module or the generic RDF.Serialization module. Options :prefixes : Allows to specify the prefixes to be used as a RDF.PrefixMap or anything from which a RDF.PrefixMap can be created with RDF.PrefixMap.new/1 . If not specified the ones from the given graph are used or if these are also not present the RDF.default_prefixes/0 . :base : : Allows to specify the base URI to be used for a @base directive. If not specified the one from the given graph is used or if there is also none specified for the graph the RDF.default_base_iri/0 . :implicit_base : This boolean flag allows to use a base URI to get relative IRIs without embedding it explicitly in the content with a @base directive, so that the URIs will be resolved according to the remaining strategy specified in section 5.1 of RFC3986 (default: false ). :base_description : Allows to provide a description of the resource denoted by the base URI. This option is especially useful when the base URI is actually not specified, eg. in the common use case of wanting to describe the Turtle document itself, which should be denoted by the URL where it is hosted as the implicit base URI. :only : Allows to specify which parts of a Turtle document should be generated. Possible values: :base , :prefixes , :directives (means the same as [:base, :prefixes] ), :triples or a list with any combination of these values. :indent : Allows to specify the number of spaces the output should be indented.","ref":"RDF.Turtle.Encoder.html","title":"RDF.Turtle.Encoder","type":"module"},{"doc":"","ref":"RDF.Turtle.Encoder.html#prefixed_name/2","title":"RDF.Turtle.Encoder.prefixed_name/2","type":"function"},{"doc":"An RDF vocabulary as a RDF.Namespace . RDF.Vocabulary.Namespace modules represent a RDF vocabulary as a RDF.Namespace . They can be defined with the defvocab/2 macro of this module. RDF.ex comes with predefined modules for some fundamental vocabularies in the RDF.NS module.","ref":"RDF.Vocabulary.Namespace.html","title":"RDF.Vocabulary.Namespace","type":"module"},{"doc":"Defines a RDF.Namespace module for a RDF vocabulary.","ref":"RDF.Vocabulary.Namespace.html#defvocab/2","title":"RDF.Vocabulary.Namespace.defvocab/2","type":"macro"},{"doc":"","ref":"RDF.Vocabulary.Namespace.html#invalid_terms/0","title":"RDF.Vocabulary.Namespace.invalid_terms/0","type":"function"},{"doc":"","ref":"RDF.Vocabulary.Namespace.html#t:t/0","title":"RDF.Vocabulary.Namespace.t/0","type":"type"},{"doc":"An implementation of the XML Schema (XSD) datatype system for use within RDF.Literal.Datatype system. It consists of RDF.XSD.Datatype : a more specialized RDF.Literal.Datatype behaviour for XSD datatypes RDF.XSD.Datatype.Primitive : macros for the definition of RDF.Literal.Datatype and RDF.XSD.Datatype implementations for primitive XSD datatypes RDF.XSD.Datatype.Restriction : macros for the definition of RDF.Literal.Datatype and RDF.XSD.Datatype implementations for derived XSD datatypes RDF.XSD.Facet : a behaviour for XSD facets which can be used to constrain values on datatype derivations see https://www.w3.org/TR/xmlschema11-2/","ref":"RDF.XSD.html","title":"RDF.XSD","type":"module"},{"doc":"See RDF.XSD.AnyURI.new/1 .","ref":"RDF.XSD.html#any_uri/1","title":"RDF.XSD.any_uri/1","type":"function"},{"doc":"See RDF.XSD.AnyURI.new/2 .","ref":"RDF.XSD.html#any_uri/2","title":"RDF.XSD.any_uri/2","type":"function"},{"doc":"See RDF.XSD.AnyURI.new/1 .","ref":"RDF.XSD.html#anyURI/1","title":"RDF.XSD.anyURI/1","type":"function"},{"doc":"See RDF.XSD.AnyURI.new/2 .","ref":"RDF.XSD.html#anyURI/2","title":"RDF.XSD.anyURI/2","type":"function"},{"doc":"See RDF.XSD.Base64Binary.new/1 .","ref":"RDF.XSD.html#base64_binary/1","title":"RDF.XSD.base64_binary/1","type":"function"},{"doc":"See RDF.XSD.Base64Binary.new/2 .","ref":"RDF.XSD.html#base64_binary/2","title":"RDF.XSD.base64_binary/2","type":"function"},{"doc":"See RDF.XSD.Base64Binary.new/1 .","ref":"RDF.XSD.html#base64Binary/1","title":"RDF.XSD.base64Binary/1","type":"function"},{"doc":"See RDF.XSD.Base64Binary.new/2 .","ref":"RDF.XSD.html#base64Binary/2","title":"RDF.XSD.base64Binary/2","type":"function"},{"doc":"See RDF.XSD.Boolean.new/1 .","ref":"RDF.XSD.html#boolean/1","title":"RDF.XSD.boolean/1","type":"function"},{"doc":"See RDF.XSD.Boolean.new/2 .","ref":"RDF.XSD.html#boolean/2","title":"RDF.XSD.boolean/2","type":"function"},{"doc":"See RDF.XSD.Byte.new/1 .","ref":"RDF.XSD.html#byte/1","title":"RDF.XSD.byte/1","type":"function"},{"doc":"See RDF.XSD.Byte.new/2 .","ref":"RDF.XSD.html#byte/2","title":"RDF.XSD.byte/2","type":"function"},{"doc":"Returns if the given value is a RDF.XSD.Datatype struct or RDF.Literal with a RDF.XSD.Datatype .","ref":"RDF.XSD.html#datatype?/1","title":"RDF.XSD.datatype?/1","type":"function"},{"doc":"See RDF.XSD.Date.new/1 .","ref":"RDF.XSD.html#date/1","title":"RDF.XSD.date/1","type":"function"},{"doc":"See RDF.XSD.Date.new/2 .","ref":"RDF.XSD.html#date/2","title":"RDF.XSD.date/2","type":"function"},{"doc":"See RDF.XSD.DateTime.new/1 .","ref":"RDF.XSD.html#date_time/1","title":"RDF.XSD.date_time/1","type":"function"},{"doc":"See RDF.XSD.DateTime.new/2 .","ref":"RDF.XSD.html#date_time/2","title":"RDF.XSD.date_time/2","type":"function"},{"doc":"See RDF.XSD.DateTime.new/1 .","ref":"RDF.XSD.html#dateTime/1","title":"RDF.XSD.dateTime/1","type":"function"},{"doc":"See RDF.XSD.DateTime.new/2 .","ref":"RDF.XSD.html#dateTime/2","title":"RDF.XSD.dateTime/2","type":"function"},{"doc":"See RDF.XSD.DateTime.new/1 .","ref":"RDF.XSD.html#datetime/1","title":"RDF.XSD.datetime/1","type":"function"},{"doc":"See RDF.XSD.DateTime.new/2 .","ref":"RDF.XSD.html#datetime/2","title":"RDF.XSD.datetime/2","type":"function"},{"doc":"See RDF.XSD.Decimal.new/1 .","ref":"RDF.XSD.html#decimal/1","title":"RDF.XSD.decimal/1","type":"function"},{"doc":"See RDF.XSD.Decimal.new/2 .","ref":"RDF.XSD.html#decimal/2","title":"RDF.XSD.decimal/2","type":"function"},{"doc":"See RDF.XSD.Double.new/1 .","ref":"RDF.XSD.html#double/1","title":"RDF.XSD.double/1","type":"function"},{"doc":"See RDF.XSD.Double.new/2 .","ref":"RDF.XSD.html#double/2","title":"RDF.XSD.double/2","type":"function"},{"doc":"Get a RDF.XSD.Facet by its name.","ref":"RDF.XSD.html#facet/1","title":"RDF.XSD.facet/1","type":"function"},{"doc":"The list of all XSD facets.","ref":"RDF.XSD.html#facets/0","title":"RDF.XSD.facets/0","type":"function"},{"doc":"See RDF.XSD.Boolean.Value.false/0 .","ref":"RDF.XSD.html#false/0","title":"RDF.XSD.false/0","type":"function"},{"doc":"See RDF.XSD.Float.new/1 .","ref":"RDF.XSD.html#float/1","title":"RDF.XSD.float/1","type":"function"},{"doc":"See RDF.XSD.Float.new/2 .","ref":"RDF.XSD.html#float/2","title":"RDF.XSD.float/2","type":"function"},{"doc":"See RDF.XSD.Int.new/1 .","ref":"RDF.XSD.html#int/1","title":"RDF.XSD.int/1","type":"function"},{"doc":"See RDF.XSD.Int.new/2 .","ref":"RDF.XSD.html#int/2","title":"RDF.XSD.int/2","type":"function"},{"doc":"See RDF.XSD.Integer.new/1 .","ref":"RDF.XSD.html#integer/1","title":"RDF.XSD.integer/1","type":"function"},{"doc":"See RDF.XSD.Integer.new/2 .","ref":"RDF.XSD.html#integer/2","title":"RDF.XSD.integer/2","type":"function"},{"doc":"See RDF.XSD.Long.new/1 .","ref":"RDF.XSD.html#long/1","title":"RDF.XSD.long/1","type":"function"},{"doc":"See RDF.XSD.Long.new/2 .","ref":"RDF.XSD.html#long/2","title":"RDF.XSD.long/2","type":"function"},{"doc":"See RDF.XSD.NegativeInteger.new/1 .","ref":"RDF.XSD.html#negative_integer/1","title":"RDF.XSD.negative_integer/1","type":"function"},{"doc":"See RDF.XSD.NegativeInteger.new/2 .","ref":"RDF.XSD.html#negative_integer/2","title":"RDF.XSD.negative_integer/2","type":"function"},{"doc":"See RDF.XSD.NegativeInteger.new/1 .","ref":"RDF.XSD.html#negativeInteger/1","title":"RDF.XSD.negativeInteger/1","type":"function"},{"doc":"See RDF.XSD.NegativeInteger.new/2 .","ref":"RDF.XSD.html#negativeInteger/2","title":"RDF.XSD.negativeInteger/2","type":"function"},{"doc":"See RDF.XSD.NonNegativeInteger.new/1 .","ref":"RDF.XSD.html#non_negative_integer/1","title":"RDF.XSD.non_negative_integer/1","type":"function"},{"doc":"See RDF.XSD.NonNegativeInteger.new/2 .","ref":"RDF.XSD.html#non_negative_integer/2","title":"RDF.XSD.non_negative_integer/2","type":"function"},{"doc":"See RDF.XSD.NonPositiveInteger.new/1 .","ref":"RDF.XSD.html#non_positive_integer/1","title":"RDF.XSD.non_positive_integer/1","type":"function"},{"doc":"See RDF.XSD.NonPositiveInteger.new/2 .","ref":"RDF.XSD.html#non_positive_integer/2","title":"RDF.XSD.non_positive_integer/2","type":"function"},{"doc":"See RDF.XSD.NonNegativeInteger.new/1 .","ref":"RDF.XSD.html#nonNegativeInteger/1","title":"RDF.XSD.nonNegativeInteger/1","type":"function"},{"doc":"See RDF.XSD.NonNegativeInteger.new/2 .","ref":"RDF.XSD.html#nonNegativeInteger/2","title":"RDF.XSD.nonNegativeInteger/2","type":"function"},{"doc":"See RDF.XSD.NonPositiveInteger.new/1 .","ref":"RDF.XSD.html#nonPositiveInteger/1","title":"RDF.XSD.nonPositiveInteger/1","type":"function"},{"doc":"See RDF.XSD.NonPositiveInteger.new/2 .","ref":"RDF.XSD.html#nonPositiveInteger/2","title":"RDF.XSD.nonPositiveInteger/2","type":"function"},{"doc":"See RDF.XSD.PositiveInteger.new/1 .","ref":"RDF.XSD.html#positive_integer/1","title":"RDF.XSD.positive_integer/1","type":"function"},{"doc":"See RDF.XSD.PositiveInteger.new/2 .","ref":"RDF.XSD.html#positive_integer/2","title":"RDF.XSD.positive_integer/2","type":"function"},{"doc":"See RDF.XSD.PositiveInteger.new/1 .","ref":"RDF.XSD.html#positiveInteger/1","title":"RDF.XSD.positiveInteger/1","type":"function"},{"doc":"See RDF.XSD.PositiveInteger.new/2 .","ref":"RDF.XSD.html#positiveInteger/2","title":"RDF.XSD.positiveInteger/2","type":"function"},{"doc":"See RDF.XSD.Short.new/1 .","ref":"RDF.XSD.html#short/1","title":"RDF.XSD.short/1","type":"function"},{"doc":"See RDF.XSD.Short.new/2 .","ref":"RDF.XSD.html#short/2","title":"RDF.XSD.short/2","type":"function"},{"doc":"See RDF.XSD.String.new/1 .","ref":"RDF.XSD.html#string/1","title":"RDF.XSD.string/1","type":"function"},{"doc":"See RDF.XSD.String.new/2 .","ref":"RDF.XSD.html#string/2","title":"RDF.XSD.string/2","type":"function"},{"doc":"See RDF.XSD.Time.new/1 .","ref":"RDF.XSD.html#time/1","title":"RDF.XSD.time/1","type":"function"},{"doc":"See RDF.XSD.Time.new/2 .","ref":"RDF.XSD.html#time/2","title":"RDF.XSD.time/2","type":"function"},{"doc":"See RDF.XSD.Boolean.Value.true/0 .","ref":"RDF.XSD.html#true/0","title":"RDF.XSD.true/0","type":"function"},{"doc":"See RDF.XSD.UnsignedByte.new/1 .","ref":"RDF.XSD.html#unsigned_byte/1","title":"RDF.XSD.unsigned_byte/1","type":"function"},{"doc":"See RDF.XSD.UnsignedByte.new/2 .","ref":"RDF.XSD.html#unsigned_byte/2","title":"RDF.XSD.unsigned_byte/2","type":"function"},{"doc":"See RDF.XSD.UnsignedInt.new/1 .","ref":"RDF.XSD.html#unsigned_int/1","title":"RDF.XSD.unsigned_int/1","type":"function"},{"doc":"See RDF.XSD.UnsignedInt.new/2 .","ref":"RDF.XSD.html#unsigned_int/2","title":"RDF.XSD.unsigned_int/2","type":"function"},{"doc":"See RDF.XSD.UnsignedLong.new/1 .","ref":"RDF.XSD.html#unsigned_long/1","title":"RDF.XSD.unsigned_long/1","type":"function"},{"doc":"See RDF.XSD.UnsignedLong.new/2 .","ref":"RDF.XSD.html#unsigned_long/2","title":"RDF.XSD.unsigned_long/2","type":"function"},{"doc":"See RDF.XSD.UnsignedShort.new/1 .","ref":"RDF.XSD.html#unsigned_short/1","title":"RDF.XSD.unsigned_short/1","type":"function"},{"doc":"See RDF.XSD.UnsignedShort.new/2 .","ref":"RDF.XSD.html#unsigned_short/2","title":"RDF.XSD.unsigned_short/2","type":"function"},{"doc":"See RDF.XSD.UnsignedByte.new/1 .","ref":"RDF.XSD.html#unsignedByte/1","title":"RDF.XSD.unsignedByte/1","type":"function"},{"doc":"See RDF.XSD.UnsignedByte.new/2 .","ref":"RDF.XSD.html#unsignedByte/2","title":"RDF.XSD.unsignedByte/2","type":"function"},{"doc":"See RDF.XSD.UnsignedInt.new/1 .","ref":"RDF.XSD.html#unsignedInt/1","title":"RDF.XSD.unsignedInt/1","type":"function"},{"doc":"See RDF.XSD.UnsignedInt.new/2 .","ref":"RDF.XSD.html#unsignedInt/2","title":"RDF.XSD.unsignedInt/2","type":"function"},{"doc":"See RDF.XSD.UnsignedLong.new/1 .","ref":"RDF.XSD.html#unsignedLong/1","title":"RDF.XSD.unsignedLong/1","type":"function"},{"doc":"See RDF.XSD.UnsignedLong.new/2 .","ref":"RDF.XSD.html#unsignedLong/2","title":"RDF.XSD.unsignedLong/2","type":"function"},{"doc":"See RDF.XSD.UnsignedShort.new/1 .","ref":"RDF.XSD.html#unsignedShort/1","title":"RDF.XSD.unsignedShort/1","type":"function"},{"doc":"See RDF.XSD.UnsignedShort.new/2 .","ref":"RDF.XSD.html#unsignedShort/2","title":"RDF.XSD.unsignedShort/2","type":"function"},{"doc":"RDF.XSD.Datatype for XSD anyURIs. See: http://www.w3.org/TR/xmlschema11-2/#anyURI","ref":"RDF.XSD.AnyURI.html","title":"RDF.XSD.AnyURI","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.AnyURI.html#canonical/1","title":"RDF.XSD.AnyURI.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.AnyURI.html#canonical_lexical/1","title":"RDF.XSD.AnyURI.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.AnyURI.html#canonical?/1","title":"RDF.XSD.AnyURI.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.AnyURI.html#cast/1","title":"RDF.XSD.AnyURI.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.AnyURI.html#compare/2","title":"RDF.XSD.AnyURI.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.AnyURI.html#datatype?/1","title":"RDF.XSD.AnyURI.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.AnyURI.html#equal_value?/2","title":"RDF.XSD.AnyURI.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.AnyURI.html#lexical/1","title":"RDF.XSD.AnyURI.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.AnyURI.html#new!/2","title":"RDF.XSD.AnyURI.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.AnyURI.html#new/2","title":"RDF.XSD.AnyURI.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.AnyURI.html#update/3","title":"RDF.XSD.AnyURI.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.AnyURI.html#valid?/1","title":"RDF.XSD.AnyURI.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.AnyURI.html#value/1","title":"RDF.XSD.AnyURI.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.AnyURI.html#t:invalid_value/0","title":"RDF.XSD.AnyURI.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.AnyURI.html#t:t/0","title":"RDF.XSD.AnyURI.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.AnyURI.html#t:valid_value/0","title":"RDF.XSD.AnyURI.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.AnyURI.html#t:value/0","title":"RDF.XSD.AnyURI.value/0","type":"type"},{"doc":"RDF.XSD.Datatype for XSD base64Binary.","ref":"RDF.XSD.Base64Binary.html","title":"RDF.XSD.Base64Binary","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Base64Binary.html#canonical/1","title":"RDF.XSD.Base64Binary.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Base64Binary.html#canonical_lexical/1","title":"RDF.XSD.Base64Binary.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Base64Binary.html#canonical?/1","title":"RDF.XSD.Base64Binary.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Base64Binary.html#cast/1","title":"RDF.XSD.Base64Binary.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Base64Binary.html#compare/2","title":"RDF.XSD.Base64Binary.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Base64Binary.html#datatype?/1","title":"RDF.XSD.Base64Binary.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Base64Binary.html#equal_value?/2","title":"RDF.XSD.Base64Binary.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Base64Binary.html#lexical/1","title":"RDF.XSD.Base64Binary.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Base64Binary.html#new!/2","title":"RDF.XSD.Base64Binary.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Base64Binary.html#new/2","title":"RDF.XSD.Base64Binary.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Base64Binary.html#update/3","title":"RDF.XSD.Base64Binary.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Base64Binary.html#valid?/1","title":"RDF.XSD.Base64Binary.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Base64Binary.html#value/1","title":"RDF.XSD.Base64Binary.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Base64Binary.html#t:invalid_value/0","title":"RDF.XSD.Base64Binary.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Base64Binary.html#t:t/0","title":"RDF.XSD.Base64Binary.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Base64Binary.html#t:valid_value/0","title":"RDF.XSD.Base64Binary.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Base64Binary.html#t:value/0","title":"RDF.XSD.Base64Binary.value/0","type":"type"},{"doc":"RDF.XSD.Datatype for XSD booleans.","ref":"RDF.XSD.Boolean.html","title":"RDF.XSD.Boolean","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Boolean.html#canonical/1","title":"RDF.XSD.Boolean.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Boolean.html#canonical_lexical/1","title":"RDF.XSD.Boolean.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Boolean.html#canonical?/1","title":"RDF.XSD.Boolean.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Boolean.html#cast/1","title":"RDF.XSD.Boolean.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Boolean.html#compare/2","title":"RDF.XSD.Boolean.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Boolean.html#datatype?/1","title":"RDF.XSD.Boolean.datatype?/1","type":"function"},{"doc":"Returns an Effective Boolean Value (EBV). The Effective Boolean Value is an algorithm to coerce values to a RDF.XSD.Boolean . It is specified and used in the SPARQL query language and is based upon XPath's fn:boolean . Other than specified in these specs any value which can not be converted into a boolean results in nil . see https://www.w3.org/TR/xpath-31/#id-ebv https://www.w3.org/TR/sparql11-query/#ebv","ref":"RDF.XSD.Boolean.html#ebv/1","title":"RDF.XSD.Boolean.ebv/1","type":"function"},{"doc":"Alias for ebv/1 .","ref":"RDF.XSD.Boolean.html#effective/1","title":"RDF.XSD.Boolean.effective/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Boolean.html#equal_value?/2","title":"RDF.XSD.Boolean.equal_value?/2","type":"function"},{"doc":"Returns RDF.XSD.true if the effective boolean value of the given argument is RDF.XSD.false , or RDF.XSD.false if it is RDF.XSD.true . Otherwise it returns nil . Examples iex&gt; RDF.XSD.Boolean . fn_not ( RDF.XSD . true ) RDF.XSD . false iex&gt; RDF.XSD.Boolean . fn_not ( RDF.XSD . false ) RDF.XSD . true iex&gt; RDF.XSD.Boolean . fn_not ( true ) RDF.XSD . false iex&gt; RDF.XSD.Boolean . fn_not ( false ) RDF.XSD . true iex&gt; RDF.XSD.Boolean . fn_not ( 42 ) RDF.XSD . false iex&gt; RDF.XSD.Boolean . fn_not ( &quot;&quot; ) RDF.XSD . true iex&gt; RDF.XSD.Boolean . fn_not ( nil ) nil see https://www.w3.org/TR/xpath-functions/#func-not","ref":"RDF.XSD.Boolean.html#fn_not/1","title":"RDF.XSD.Boolean.fn_not/1","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Boolean.html#lexical/1","title":"RDF.XSD.Boolean.lexical/1","type":"function"},{"doc":"Returns the logical AND of the effective boolean value of the given arguments. It returns nil if only one argument is nil and the other argument is RDF.XSD.true and RDF.XSD.false if the other argument is RDF.XSD.false . Examples iex&gt; RDF.XSD.Boolean . logical_and ( RDF.XSD . true , RDF.XSD . true ) RDF.XSD . true iex&gt; RDF.XSD.Boolean . logical_and ( RDF.XSD . true , RDF.XSD . false ) RDF.XSD . false iex&gt; RDF.XSD.Boolean . logical_and ( RDF.XSD . true , nil ) nil iex&gt; RDF.XSD.Boolean . logical_and ( nil , RDF.XSD . false ) RDF.XSD . false iex&gt; RDF.XSD.Boolean . logical_and ( nil , nil ) nil see https://www.w3.org/TR/sparql11-query/#func-logical-and","ref":"RDF.XSD.Boolean.html#logical_and/2","title":"RDF.XSD.Boolean.logical_and/2","type":"function"},{"doc":"Returns the logical OR of the effective boolean value of the given arguments. It returns nil if only one argument is nil and the other argument is RDF.XSD.false and RDF.XSD.true if the other argument is RDF.XSD.true . Examples iex&gt; RDF.XSD.Boolean . logical_or ( RDF.XSD . true , RDF.XSD . false ) RDF.XSD . true iex&gt; RDF.XSD.Boolean . logical_or ( RDF.XSD . false , RDF.XSD . false ) RDF.XSD . false iex&gt; RDF.XSD.Boolean . logical_or ( RDF.XSD . true , nil ) RDF.XSD . true iex&gt; RDF.XSD.Boolean . logical_or ( nil , RDF.XSD . false ) nil iex&gt; RDF.XSD.Boolean . logical_or ( nil , nil ) nil see https://www.w3.org/TR/sparql11-query/#func-logical-or","ref":"RDF.XSD.Boolean.html#logical_or/2","title":"RDF.XSD.Boolean.logical_or/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Boolean.html#new!/2","title":"RDF.XSD.Boolean.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Boolean.html#new/2","title":"RDF.XSD.Boolean.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Boolean.html#update/3","title":"RDF.XSD.Boolean.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Boolean.html#valid?/1","title":"RDF.XSD.Boolean.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Boolean.html#value/1","title":"RDF.XSD.Boolean.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Boolean.html#t:input_value/0","title":"RDF.XSD.Boolean.input_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Boolean.html#t:invalid_value/0","title":"RDF.XSD.Boolean.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Boolean.html#t:t/0","title":"RDF.XSD.Boolean.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Boolean.html#t:valid_value/0","title":"RDF.XSD.Boolean.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Boolean.html#t:value/0","title":"RDF.XSD.Boolean.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Byte.html","title":"RDF.XSD.Byte","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Byte.html#canonical/1","title":"RDF.XSD.Byte.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Byte.html#canonical_lexical/1","title":"RDF.XSD.Byte.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Byte.html#canonical?/1","title":"RDF.XSD.Byte.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Byte.html#cast/1","title":"RDF.XSD.Byte.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Byte.html#compare/2","title":"RDF.XSD.Byte.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Byte.html#datatype?/1","title":"RDF.XSD.Byte.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Byte.html#equal_value?/2","title":"RDF.XSD.Byte.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Byte.html#lexical/1","title":"RDF.XSD.Byte.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Byte.html#new!/2","title":"RDF.XSD.Byte.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Byte.html#new/2","title":"RDF.XSD.Byte.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Byte.html#update/3","title":"RDF.XSD.Byte.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Byte.html#valid?/1","title":"RDF.XSD.Byte.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Byte.html#value/1","title":"RDF.XSD.Byte.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Byte.html#t:invalid_value/0","title":"RDF.XSD.Byte.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Byte.html#t:t/0","title":"RDF.XSD.Byte.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Byte.html#t:valid_value/0","title":"RDF.XSD.Byte.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Byte.html#t:value/0","title":"RDF.XSD.Byte.value/0","type":"type"},{"doc":"A behaviour for XSD datatypes. A XSD datatype has three properties: A value space , which is a set of values. A lexical space , which is a set of literals used to denote the values. A collection of functions associated with the datatype. Builtin XSD datatypes RDF.ex comes with the following builtin implementations of XSD datatypes: xsd:boolean RDF.XSD.Boolean xsd:float RDF.XSD.Float xsd:double RDF.XSD.Double xsd:decimal RDF.XSD.Decimal xsd:integer RDF.XSD.Integer xsd:long RDF.XSD.Long xsd:int RDF.XSD.Int xsd:short RDF.XSD.Short xsd:byte RDF.XSD.Byte xsd:nonPositiveInteger RDF.XSD.NonPositiveInteger xsd:negativeInteger RDF.XSD.NegativeInteger xsd:nonNegativeInteger RDF.XSD.NonNegativeInteger xsd:positiveInteger RDF.XSD.PositiveInteger xsd:unsignedLong RDF.XSD.UnsignedLong xsd:unsignedInt RDF.XSD.UnsignedInt xsd:unsignedShort RDF.XSD.UnsignedShort xsd:unsignedByte RDF.XSD.UnsignedByte xsd:string RDF.XSD.String xsd:normalizedString ❌ xsd:token ❌ xsd:language ❌ xsd:Name ❌ xsd:NCName ❌ xsd:ID ❌ xsd:IDREF ❌ xsd:ENTITY ❌ xsd:NMTOKEN ❌ xsd:dateTime RDF.XSD.DateTime xsd:dateTimeStamp ❌ xsd:date RDF.XSD.Date xsd:time RDF.XSD.Time xsd:duration ❌ xsd:dayTimeDuration ❌ xsd:yearMonthDuration ❌ xsd:gYearMonth ❌ xsd:gYear ❌ xsd:gMonthDay ❌ xsd:gDay ❌ xsd:gMonth ❌ xsd:base64Binary RDF.XSD.Base64Binary xsd:hexBinary ❌ xsd:anyURI RDF.XSD.AnyURI xsd:QName ❌ xsd:NOTATION ❌ There are some notable difference in the implementations of some datatypes compared to the original spec: RDF.XSD.Integer is not derived from RDF.XSD.Decimal , but implemented as a primitive datatype RDF.XSD.Float is not implemented as a primitive datatype, but derived from RDF.XSD.Double without further restrictions instead, since Erlang doesn't have a corresponding datatype see https://www.w3.org/TR/xmlschema11-2/#built-in-datatypes","ref":"RDF.XSD.Datatype.html","title":"RDF.XSD.Datatype","type":"behaviour"},{"doc":"The set of applicable facets of a RDF.XSD.Datatype .","ref":"RDF.XSD.Datatype.html#c:applicable_facets/0","title":"RDF.XSD.Datatype.applicable_facets/0","type":"callback"},{"doc":"The base datatype from which a RDF.XSD.Datatype is derived. Note: Since this library focuses on atomic types and the special xsd:anyAtomicType specified as the base type of all primitive types in the W3C spec wouldn't serve any purpose here, all primitive datatypes just return nil instead.","ref":"RDF.XSD.Datatype.html#c:base/0","title":"RDF.XSD.Datatype.base/0","type":"callback"},{"doc":"The primitive RDF.XSD.Datatype from which a RDF.XSD.Datatype is derived. In case of a primitive RDF.XSD.Datatype this function returns this RDF.XSD.Datatype itself.","ref":"RDF.XSD.Datatype.html#c:base_primitive/0","title":"RDF.XSD.Datatype.base_primitive/0","type":"callback"},{"doc":"Returns the standard lexical representation for a value of the value space of a RDF.XSD.Datatype .","ref":"RDF.XSD.Datatype.html#c:canonical_mapping/1","title":"RDF.XSD.Datatype.canonical_mapping/1","type":"callback"},{"doc":"Checks if the RDF.XSD.Datatype is directly or indirectly derived from the given RDF.XSD.Datatype . Note that this is just a basic datatype reflection function on the module level and does not work with RDF.Literal s. See RDF.Literal.Datatype.datatype?/1 instead.","ref":"RDF.XSD.Datatype.html#c:derived_from?/1","title":"RDF.XSD.Datatype.derived_from?/1","type":"callback"},{"doc":"A mapping from Elixir values into the value space of a RDF.XSD.Datatype . If the Elixir mapping for the given value can not be mapped into value space of the XSD datatype an implementation should return @invalid_value (which is just nil at the moment, so nil is never a valid value of a value space). Otherwise a tuple {value, lexical} with value being the internal representation of the mapped value from the value space and lexical being the lexical representation to be used for the Elixir value or nil if init_valid_lexical/3 should be used to determine the lexical form in general (i.e. also when initialized with a string via the lexical_mapping/2 ). Since the later case is most often what you want, you can also return value directly, as long as it is not a two element tuple.","ref":"RDF.XSD.Datatype.html#c:elixir_mapping/2","title":"RDF.XSD.Datatype.elixir_mapping/2","type":"callback"},{"doc":"Returns the RDF.XSD.Datatype for a datatype IRI.","ref":"RDF.XSD.Datatype.html#get/1","title":"RDF.XSD.Datatype.get/1","type":"function"},{"doc":"Produces the lexical representation of an invalid value. The default implementation of the _using__ macro just returns the to_string/1 representation of the value.","ref":"RDF.XSD.Datatype.html#c:init_invalid_lexical/2","title":"RDF.XSD.Datatype.init_invalid_lexical/2","type":"callback"},{"doc":"Produces the lexical representation to be used for a RDF.XSD.Datatype literal. By default the lexical representation of a RDF.XSD.Datatype is either the canonical form in case it is created from a non-string Elixir value or, if it is created from a string, just with that string as the lexical form. But there can be various reasons for why this should be different for certain datatypes. For example, for RDF.XSD.Double s given as Elixir floats, we want the default lexical representation to be the decimal and not the canonical exponential form. Another reason might be that additional options are given which should be taken into account in the lexical form. If the lexical representation for a given value and lexical should be the canonical one, an implementation should return nil .","ref":"RDF.XSD.Datatype.html#c:init_valid_lexical/3","title":"RDF.XSD.Datatype.init_valid_lexical/3","type":"callback"},{"doc":"A mapping from the lexical space of a RDF.XSD.Datatype into its value space.","ref":"RDF.XSD.Datatype.html#c:lexical_mapping/2","title":"RDF.XSD.Datatype.lexical_mapping/2","type":"callback"},{"doc":"Returns if the RDF.XSD.Datatype is a primitive datatype.","ref":"RDF.XSD.Datatype.html#c:primitive?/0","title":"RDF.XSD.Datatype.primitive?/0","type":"callback"},{"doc":"","ref":"RDF.XSD.Datatype.html#t:literal/0","title":"RDF.XSD.Datatype.literal/0","type":"type"},{"doc":"","ref":"RDF.XSD.Datatype.html#t:t/0","title":"RDF.XSD.Datatype.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Datatype.html#t:uncanonical_lexical/0","title":"RDF.XSD.Datatype.uncanonical_lexical/0","type":"type"},{"doc":"Macros for the definition of primitive XSD datatypes.","ref":"RDF.XSD.Datatype.Primitive.html","title":"RDF.XSD.Datatype.Primitive","type":"module"},{"doc":"Specifies the applicability of the given XSD facet on a primitive datatype. For a facet with the name example_facet this requires a function def example_facet_conform? ( example_facet_value , literal_value , lexical ) do end to be defined on the primitive datatype.","ref":"RDF.XSD.Datatype.Primitive.html#def_applicable_facet/1","title":"RDF.XSD.Datatype.Primitive.def_applicable_facet/1","type":"macro"},{"doc":"A __using__ macro for the derivation of restricted XSD datatypes. Example A new custom datatype can be derived by defining a new datatype module and use this module, specifying a name , id and base datatype and restricting it by specifying some of the applicable facets of the base datatype: defmodule MyApp.PersonAge do use RDF.XSD.Datatype.Restriction , name : &quot;person_age&quot; , id : &quot;http://example.com/person_age&quot; , base : RDF.XSD.NonNegativeInteger def_facet_constraint RDF.XSD.Facets.MaxInclusive , 150 end See RDF.XSD.Facet on which facets are available on the existing datatypes.","ref":"RDF.XSD.Datatype.Restriction.html","title":"RDF.XSD.Datatype.Restriction","type":"module"},{"doc":"RDF.XSD.Datatype for XSD date. Options: tz : this allows to specify a timezone which is not supported by Elixir's Date struct; note, that it will also overwrite an eventually already present timezone in an input lexical","ref":"RDF.XSD.Date.html","title":"RDF.XSD.Date","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Date.html#canonical/1","title":"RDF.XSD.Date.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Date.html#canonical_lexical/1","title":"RDF.XSD.Date.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Date.html#canonical?/1","title":"RDF.XSD.Date.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Date.html#cast/1","title":"RDF.XSD.Date.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Date.html#compare/2","title":"RDF.XSD.Date.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Date.html#datatype?/1","title":"RDF.XSD.Date.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Date.html#equal_value?/2","title":"RDF.XSD.Date.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Date.html#lexical/1","title":"RDF.XSD.Date.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Date.html#new!/2","title":"RDF.XSD.Date.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Date.html#new/2","title":"RDF.XSD.Date.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Date.html#update/3","title":"RDF.XSD.Date.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Date.html#valid?/1","title":"RDF.XSD.Date.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Date.html#value/1","title":"RDF.XSD.Date.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Date.html#t:invalid_value/0","title":"RDF.XSD.Date.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Date.html#t:t/0","title":"RDF.XSD.Date.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Date.html#t:valid_value/0","title":"RDF.XSD.Date.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Date.html#t:value/0","title":"RDF.XSD.Date.value/0","type":"type"},{"doc":"RDF.XSD.Datatype for XSD dateTimes.","ref":"RDF.XSD.DateTime.html","title":"RDF.XSD.DateTime","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.DateTime.html#canonical/1","title":"RDF.XSD.DateTime.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.DateTime.html#canonical_lexical/1","title":"RDF.XSD.DateTime.canonical_lexical/1","type":"function"},{"doc":"Converts a datetime literal to a canonical string, preserving the zone information.","ref":"RDF.XSD.DateTime.html#canonical_lexical_with_zone/1","title":"RDF.XSD.DateTime.canonical_lexical_with_zone/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.DateTime.html#canonical?/1","title":"RDF.XSD.DateTime.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.DateTime.html#cast/1","title":"RDF.XSD.DateTime.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.DateTime.html#compare/2","title":"RDF.XSD.DateTime.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.DateTime.html#datatype?/1","title":"RDF.XSD.DateTime.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.DateTime.html#equal_value?/2","title":"RDF.XSD.DateTime.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.DateTime.html#lexical/1","title":"RDF.XSD.DateTime.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.DateTime.html#new!/2","title":"RDF.XSD.DateTime.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.DateTime.html#new/2","title":"RDF.XSD.DateTime.new/2","type":"function"},{"doc":"Builds a RDF.XSD.DateTime literal for current moment in time.","ref":"RDF.XSD.DateTime.html#now/0","title":"RDF.XSD.DateTime.now/0","type":"function"},{"doc":"Extracts the timezone string from a RDF.XSD.DateTime value.","ref":"RDF.XSD.DateTime.html#tz/1","title":"RDF.XSD.DateTime.tz/1","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.DateTime.html#update/3","title":"RDF.XSD.DateTime.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.DateTime.html#valid?/1","title":"RDF.XSD.DateTime.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.DateTime.html#value/1","title":"RDF.XSD.DateTime.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.DateTime.html#t:invalid_value/0","title":"RDF.XSD.DateTime.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.DateTime.html#t:t/0","title":"RDF.XSD.DateTime.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.DateTime.html#t:valid_value/0","title":"RDF.XSD.DateTime.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.DateTime.html#t:value/0","title":"RDF.XSD.DateTime.value/0","type":"type"},{"doc":"RDF.XSD.Datatype for XSD decimals.","ref":"RDF.XSD.Decimal.html","title":"RDF.XSD.Decimal","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Decimal.html#canonical/1","title":"RDF.XSD.Decimal.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Decimal.html#canonical_lexical/1","title":"RDF.XSD.Decimal.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Decimal.html#canonical?/1","title":"RDF.XSD.Decimal.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Decimal.html#cast/1","title":"RDF.XSD.Decimal.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Decimal.html#compare/2","title":"RDF.XSD.Decimal.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Decimal.html#datatype?/1","title":"RDF.XSD.Decimal.datatype?/1","type":"function"},{"doc":"The number of digits in the XML Schema canonical form of the literal value.","ref":"RDF.XSD.Decimal.html#digit_count/1","title":"RDF.XSD.Decimal.digit_count/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Decimal.html#equal_value?/2","title":"RDF.XSD.Decimal.equal_value?/2","type":"function"},{"doc":"The number of digits to the right of the decimal point in the XML Schema canonical form of the literal value.","ref":"RDF.XSD.Decimal.html#fraction_digit_count/1","title":"RDF.XSD.Decimal.fraction_digit_count/1","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Decimal.html#lexical/1","title":"RDF.XSD.Decimal.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Decimal.html#new!/2","title":"RDF.XSD.Decimal.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Decimal.html#new/2","title":"RDF.XSD.Decimal.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Decimal.html#update/3","title":"RDF.XSD.Decimal.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Decimal.html#valid?/1","title":"RDF.XSD.Decimal.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Decimal.html#value/1","title":"RDF.XSD.Decimal.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Decimal.html#t:invalid_value/0","title":"RDF.XSD.Decimal.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Decimal.html#t:t/0","title":"RDF.XSD.Decimal.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Decimal.html#t:valid_value/0","title":"RDF.XSD.Decimal.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Decimal.html#t:value/0","title":"RDF.XSD.Decimal.value/0","type":"type"},{"doc":"RDF.XSD.Datatype for XSD doubles.","ref":"RDF.XSD.Double.html","title":"RDF.XSD.Double","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Double.html#canonical/1","title":"RDF.XSD.Double.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Double.html#canonical_lexical/1","title":"RDF.XSD.Double.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Double.html#canonical?/1","title":"RDF.XSD.Double.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Double.html#cast/1","title":"RDF.XSD.Double.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Double.html#compare/2","title":"RDF.XSD.Double.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Double.html#datatype?/1","title":"RDF.XSD.Double.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Double.html#equal_value?/2","title":"RDF.XSD.Double.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Double.html#lexical/1","title":"RDF.XSD.Double.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Double.html#new!/2","title":"RDF.XSD.Double.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Double.html#new/2","title":"RDF.XSD.Double.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Double.html#update/3","title":"RDF.XSD.Double.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Double.html#valid?/1","title":"RDF.XSD.Double.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Double.html#value/1","title":"RDF.XSD.Double.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Double.html#t:invalid_value/0","title":"RDF.XSD.Double.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Double.html#t:special_values/0","title":"RDF.XSD.Double.special_values/0","type":"type"},{"doc":"","ref":"RDF.XSD.Double.html#t:t/0","title":"RDF.XSD.Double.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Double.html#t:valid_value/0","title":"RDF.XSD.Double.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Double.html#t:value/0","title":"RDF.XSD.Double.value/0","type":"type"},{"doc":"A behaviour for XSD restriction facets. Here's a list of all the RDF.XSD.Facet s RDF.ex implements out-of-the-box: XSD facet RDF.XSD.Facet length RDF.XSD.Facets.Length minLength RDF.XSD.Facets.MinLength maxLength RDF.XSD.Facets.MaxLength maxInclusive RDF.XSD.Facets.MaxInclusive maxExclusive RDF.XSD.Facets.MaxExclusive minInclusive RDF.XSD.Facets.MinInclusive minExclusive RDF.XSD.Facets.MinExclusive totalDigits RDF.XSD.Facets.TotalDigits fractionDigits RDF.XSD.Facets.FractionDigits explicitTimezone RDF.XSD.Facets.ExplicitTimezone pattern RDF.XSD.Facets.Pattern whiteSpace ❌ enumeration ❌ assertions ❌ Every RDF.XSD.Datatype.Primitive defines a set of applicable constraining facets which are can be used on derivations of this primitive or any of its existing derivations: Primitive datatype Applicable facets string RDF.XSD.Facets.Length , RDF.XSD.Facets.MaxLength , RDF.XSD.Facets.MinLength , RDF.XSD.Facets.Pattern boolean RDF.XSD.Facets.Pattern float RDF.XSD.Facets.MaxExclusive , RDF.XSD.Facets.MaxInclusive , RDF.XSD.Facets.MinExclusive , RDF.XSD.Facets.MinInclusive , RDF.XSD.Facets.Pattern double RDF.XSD.Facets.MaxExclusive , RDF.XSD.Facets.MaxInclusive , RDF.XSD.Facets.MinExclusive , RDF.XSD.Facets.MinInclusive , RDF.XSD.Facets.Pattern decimal RDF.XSD.Facets.MaxExclusive , RDF.XSD.Facets.MaxInclusive , RDF.XSD.Facets.MinExclusive , RDF.XSD.Facets.MinInclusive , RDF.XSD.Facets.Pattern , RDF.XSD.Facets.TotalDigits , RDF.XSD.Facets.FractionDigits decimal RDF.XSD.Facets.MaxExclusive , RDF.XSD.Facets.MaxInclusive , RDF.XSD.Facets.MinExclusive , RDF.XSD.Facets.MinInclusive , RDF.XSD.Facets.Pattern , RDF.XSD.Facets.TotalDigits duration RDF.XSD.Facets.MaxExclusive , RDF.XSD.Facets.MaxInclusive , RDF.XSD.Facets.MinExclusive , RDF.XSD.Facets.MinInclusive , RDF.XSD.Facets.Pattern dateTime RDF.XSD.Facets.ExplicitTimezone , RDF.XSD.Facets.MaxExclusive , RDF.XSD.Facets.MaxInclusive , RDF.XSD.Facets.MinExclusive , RDF.XSD.Facets.MinInclusive , RDF.XSD.Facets.Pattern time RDF.XSD.Facets.ExplicitTimezone , RDF.XSD.Facets.MaxExclusive , RDF.XSD.Facets.MaxInclusive , RDF.XSD.Facets.MinExclusive , RDF.XSD.Facets.MinInclusive , RDF.XSD.Facets.Pattern date RDF.XSD.Facets.ExplicitTimezone , RDF.XSD.Facets.MaxExclusive , RDF.XSD.Facets.MaxInclusive , RDF.XSD.Facets.MinExclusive , RDF.XSD.Facets.MinInclusive , RDF.XSD.Facets.Pattern anyURI RDF.XSD.Facets.Length , RDF.XSD.Facets.MaxLength , RDF.XSD.Facets.MinLength , RDF.XSD.Facets.Pattern https://www.w3.org/TR/xmlschema11-2/datatypes.html#rf-facets","ref":"RDF.XSD.Facet.html","title":"RDF.XSD.Facet","type":"behaviour"},{"doc":"Macro for the definition of concrete constraining value for a RDF.XSD.Facet on a RDF.XSD.Datatype .","ref":"RDF.XSD.Facet.html#def_facet_constraint/2","title":"RDF.XSD.Facet.def_facet_constraint/2","type":"macro"},{"doc":"The name of a RDF.XSD.Facet .","ref":"RDF.XSD.Facet.html#c:name/0","title":"RDF.XSD.Facet.name/0","type":"callback"},{"doc":"","ref":"RDF.XSD.Facet.html#t:t/0","title":"RDF.XSD.Facet.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Facets.ExplicitTimezone.html","title":"RDF.XSD.Facets.ExplicitTimezone","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the explicit_timezone_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.ExplicitTimezone.html#conform?/3","title":"RDF.XSD.Facets.ExplicitTimezone.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.ExplicitTimezone.html#c:explicit_timezone/0","title":"RDF.XSD.Facets.ExplicitTimezone.explicit_timezone/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.ExplicitTimezone.html#c:explicit_timezone_conform?/3","title":"RDF.XSD.Facets.ExplicitTimezone.explicit_timezone_conform?/3","type":"callback"},{"doc":"","ref":"RDF.XSD.Facets.ExplicitTimezone.html#t:t/0","title":"RDF.XSD.Facets.ExplicitTimezone.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Facets.FractionDigits.html","title":"RDF.XSD.Facets.FractionDigits","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the fraction_digits_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.FractionDigits.html#conform?/3","title":"RDF.XSD.Facets.FractionDigits.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.FractionDigits.html#c:fraction_digits/0","title":"RDF.XSD.Facets.FractionDigits.fraction_digits/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.FractionDigits.html#c:fraction_digits_conform?/3","title":"RDF.XSD.Facets.FractionDigits.fraction_digits_conform?/3","type":"callback"},{"doc":"","ref":"RDF.XSD.Facets.Length.html","title":"RDF.XSD.Facets.Length","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the length_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.Length.html#conform?/3","title":"RDF.XSD.Facets.Length.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.Length.html#c:length/0","title":"RDF.XSD.Facets.Length.length/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.Length.html#c:length_conform?/3","title":"RDF.XSD.Facets.Length.length_conform?/3","type":"callback"},{"doc":"","ref":"RDF.XSD.Facets.MaxExclusive.html","title":"RDF.XSD.Facets.MaxExclusive","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the max_exclusive_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MaxExclusive.html#conform?/3","title":"RDF.XSD.Facets.MaxExclusive.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MaxExclusive.html#c:max_exclusive/0","title":"RDF.XSD.Facets.MaxExclusive.max_exclusive/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.MaxExclusive.html#c:max_exclusive_conform?/3","title":"RDF.XSD.Facets.MaxExclusive.max_exclusive_conform?/3","type":"callback"},{"doc":"","ref":"RDF.XSD.Facets.MaxInclusive.html","title":"RDF.XSD.Facets.MaxInclusive","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the max_inclusive_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MaxInclusive.html#conform?/3","title":"RDF.XSD.Facets.MaxInclusive.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MaxInclusive.html#c:max_inclusive/0","title":"RDF.XSD.Facets.MaxInclusive.max_inclusive/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.MaxInclusive.html#c:max_inclusive_conform?/3","title":"RDF.XSD.Facets.MaxInclusive.max_inclusive_conform?/3","type":"callback"},{"doc":"","ref":"RDF.XSD.Facets.MaxLength.html","title":"RDF.XSD.Facets.MaxLength","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the max_length_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MaxLength.html#conform?/3","title":"RDF.XSD.Facets.MaxLength.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MaxLength.html#c:max_length/0","title":"RDF.XSD.Facets.MaxLength.max_length/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.MaxLength.html#c:max_length_conform?/3","title":"RDF.XSD.Facets.MaxLength.max_length_conform?/3","type":"callback"},{"doc":"","ref":"RDF.XSD.Facets.MinExclusive.html","title":"RDF.XSD.Facets.MinExclusive","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the min_exclusive_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MinExclusive.html#conform?/3","title":"RDF.XSD.Facets.MinExclusive.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MinExclusive.html#c:min_exclusive/0","title":"RDF.XSD.Facets.MinExclusive.min_exclusive/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.MinExclusive.html#c:min_exclusive_conform?/3","title":"RDF.XSD.Facets.MinExclusive.min_exclusive_conform?/3","type":"callback"},{"doc":"","ref":"RDF.XSD.Facets.MinInclusive.html","title":"RDF.XSD.Facets.MinInclusive","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the min_inclusive_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MinInclusive.html#conform?/3","title":"RDF.XSD.Facets.MinInclusive.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MinInclusive.html#c:min_inclusive/0","title":"RDF.XSD.Facets.MinInclusive.min_inclusive/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.MinInclusive.html#c:min_inclusive_conform?/3","title":"RDF.XSD.Facets.MinInclusive.min_inclusive_conform?/3","type":"callback"},{"doc":"","ref":"RDF.XSD.Facets.MinLength.html","title":"RDF.XSD.Facets.MinLength","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the min_length_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MinLength.html#conform?/3","title":"RDF.XSD.Facets.MinLength.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.MinLength.html#c:min_length/0","title":"RDF.XSD.Facets.MinLength.min_length/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.MinLength.html#c:min_length_conform?/3","title":"RDF.XSD.Facets.MinLength.min_length_conform?/3","type":"callback"},{"doc":"","ref":"RDF.XSD.Facets.Pattern.html","title":"RDF.XSD.Facets.Pattern","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the pattern_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.Pattern.html#conform?/3","title":"RDF.XSD.Facets.Pattern.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.Pattern.html#c:pattern/0","title":"RDF.XSD.Facets.Pattern.pattern/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.Pattern.html#c:pattern_conform?/3","title":"RDF.XSD.Facets.Pattern.pattern_conform?/3","type":"callback"},{"doc":"","ref":"RDF.XSD.Facets.TotalDigits.html","title":"RDF.XSD.Facets.TotalDigits","type":"behaviour"},{"doc":"Checks if a value and lexical conforms with the total_digits_conform?/3 implementation on the datatype RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.TotalDigits.html#conform?/3","title":"RDF.XSD.Facets.TotalDigits.conform?/3","type":"function"},{"doc":"Returns the value of this RDF.XSD.Facet on specific RDF.XSD.Datatype .","ref":"RDF.XSD.Facets.TotalDigits.html#c:total_digits/0","title":"RDF.XSD.Facets.TotalDigits.total_digits/0","type":"callback"},{"doc":"Validates if a value and lexical conforms with a concrete facet_constaint_value for this RDF.XSD.Facet . This function must be implemented on a RDF.XSD.Datatype using this RDF.XSD.Facet .","ref":"RDF.XSD.Facets.TotalDigits.html#c:total_digits_conform?/3","title":"RDF.XSD.Facets.TotalDigits.total_digits_conform?/3","type":"callback"},{"doc":"RDF.XSD.Datatype for XSD floats. Although the XSD spec defines floats as a primitive we derive it here from XSD.Double with any further constraints, since Erlang doesn't support 32-bit floats.","ref":"RDF.XSD.Float.html","title":"RDF.XSD.Float","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Float.html#canonical/1","title":"RDF.XSD.Float.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Float.html#canonical_lexical/1","title":"RDF.XSD.Float.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Float.html#canonical?/1","title":"RDF.XSD.Float.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Float.html#cast/1","title":"RDF.XSD.Float.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Float.html#compare/2","title":"RDF.XSD.Float.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Float.html#datatype?/1","title":"RDF.XSD.Float.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Float.html#equal_value?/2","title":"RDF.XSD.Float.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Float.html#lexical/1","title":"RDF.XSD.Float.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Float.html#new!/2","title":"RDF.XSD.Float.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Float.html#new/2","title":"RDF.XSD.Float.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Float.html#update/3","title":"RDF.XSD.Float.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Float.html#valid?/1","title":"RDF.XSD.Float.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Float.html#value/1","title":"RDF.XSD.Float.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Float.html#t:invalid_value/0","title":"RDF.XSD.Float.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Float.html#t:t/0","title":"RDF.XSD.Float.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Float.html#t:valid_value/0","title":"RDF.XSD.Float.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Float.html#t:value/0","title":"RDF.XSD.Float.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Int.html","title":"RDF.XSD.Int","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Int.html#canonical/1","title":"RDF.XSD.Int.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Int.html#canonical_lexical/1","title":"RDF.XSD.Int.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Int.html#canonical?/1","title":"RDF.XSD.Int.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Int.html#cast/1","title":"RDF.XSD.Int.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Int.html#compare/2","title":"RDF.XSD.Int.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Int.html#datatype?/1","title":"RDF.XSD.Int.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Int.html#equal_value?/2","title":"RDF.XSD.Int.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Int.html#lexical/1","title":"RDF.XSD.Int.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Int.html#new!/2","title":"RDF.XSD.Int.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Int.html#new/2","title":"RDF.XSD.Int.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Int.html#update/3","title":"RDF.XSD.Int.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Int.html#valid?/1","title":"RDF.XSD.Int.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Int.html#value/1","title":"RDF.XSD.Int.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Int.html#t:invalid_value/0","title":"RDF.XSD.Int.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Int.html#t:t/0","title":"RDF.XSD.Int.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Int.html#t:valid_value/0","title":"RDF.XSD.Int.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Int.html#t:value/0","title":"RDF.XSD.Int.value/0","type":"type"},{"doc":"RDF.XSD.Datatype for XSD integers. Although the XSD spec defines integers as derived from xsd:decimal we implement it here as a primitive datatype for simplicity and performance reasons.","ref":"RDF.XSD.Integer.html","title":"RDF.XSD.Integer","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Integer.html#canonical/1","title":"RDF.XSD.Integer.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Integer.html#canonical_lexical/1","title":"RDF.XSD.Integer.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Integer.html#canonical?/1","title":"RDF.XSD.Integer.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Integer.html#cast/1","title":"RDF.XSD.Integer.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Integer.html#compare/2","title":"RDF.XSD.Integer.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Integer.html#datatype?/1","title":"RDF.XSD.Integer.datatype?/1","type":"function"},{"doc":"The number of digits in the XML Schema canonical form of the literal value.","ref":"RDF.XSD.Integer.html#digit_count/1","title":"RDF.XSD.Integer.digit_count/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Integer.html#equal_value?/2","title":"RDF.XSD.Integer.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Integer.html#lexical/1","title":"RDF.XSD.Integer.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Integer.html#new!/2","title":"RDF.XSD.Integer.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Integer.html#new/2","title":"RDF.XSD.Integer.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Integer.html#update/3","title":"RDF.XSD.Integer.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Integer.html#valid?/1","title":"RDF.XSD.Integer.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Integer.html#value/1","title":"RDF.XSD.Integer.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Integer.html#t:invalid_value/0","title":"RDF.XSD.Integer.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Integer.html#t:t/0","title":"RDF.XSD.Integer.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Integer.html#t:valid_value/0","title":"RDF.XSD.Integer.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Integer.html#t:value/0","title":"RDF.XSD.Integer.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Long.html","title":"RDF.XSD.Long","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Long.html#canonical/1","title":"RDF.XSD.Long.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Long.html#canonical_lexical/1","title":"RDF.XSD.Long.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Long.html#canonical?/1","title":"RDF.XSD.Long.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Long.html#cast/1","title":"RDF.XSD.Long.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Long.html#compare/2","title":"RDF.XSD.Long.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Long.html#datatype?/1","title":"RDF.XSD.Long.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Long.html#equal_value?/2","title":"RDF.XSD.Long.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Long.html#lexical/1","title":"RDF.XSD.Long.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Long.html#new!/2","title":"RDF.XSD.Long.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Long.html#new/2","title":"RDF.XSD.Long.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Long.html#update/3","title":"RDF.XSD.Long.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Long.html#valid?/1","title":"RDF.XSD.Long.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Long.html#value/1","title":"RDF.XSD.Long.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Long.html#t:invalid_value/0","title":"RDF.XSD.Long.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Long.html#t:t/0","title":"RDF.XSD.Long.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Long.html#t:valid_value/0","title":"RDF.XSD.Long.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Long.html#t:value/0","title":"RDF.XSD.Long.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.NegativeInteger.html","title":"RDF.XSD.NegativeInteger","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.NegativeInteger.html#canonical/1","title":"RDF.XSD.NegativeInteger.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.NegativeInteger.html#canonical_lexical/1","title":"RDF.XSD.NegativeInteger.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.NegativeInteger.html#canonical?/1","title":"RDF.XSD.NegativeInteger.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.NegativeInteger.html#cast/1","title":"RDF.XSD.NegativeInteger.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.NegativeInteger.html#compare/2","title":"RDF.XSD.NegativeInteger.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.NegativeInteger.html#datatype?/1","title":"RDF.XSD.NegativeInteger.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.NegativeInteger.html#equal_value?/2","title":"RDF.XSD.NegativeInteger.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.NegativeInteger.html#lexical/1","title":"RDF.XSD.NegativeInteger.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.NegativeInteger.html#new!/2","title":"RDF.XSD.NegativeInteger.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.NegativeInteger.html#new/2","title":"RDF.XSD.NegativeInteger.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.NegativeInteger.html#update/3","title":"RDF.XSD.NegativeInteger.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.NegativeInteger.html#valid?/1","title":"RDF.XSD.NegativeInteger.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.NegativeInteger.html#value/1","title":"RDF.XSD.NegativeInteger.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.NegativeInteger.html#t:invalid_value/0","title":"RDF.XSD.NegativeInteger.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.NegativeInteger.html#t:t/0","title":"RDF.XSD.NegativeInteger.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.NegativeInteger.html#t:valid_value/0","title":"RDF.XSD.NegativeInteger.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.NegativeInteger.html#t:value/0","title":"RDF.XSD.NegativeInteger.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.NonNegativeInteger.html","title":"RDF.XSD.NonNegativeInteger","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.NonNegativeInteger.html#canonical/1","title":"RDF.XSD.NonNegativeInteger.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.NonNegativeInteger.html#canonical_lexical/1","title":"RDF.XSD.NonNegativeInteger.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.NonNegativeInteger.html#canonical?/1","title":"RDF.XSD.NonNegativeInteger.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.NonNegativeInteger.html#cast/1","title":"RDF.XSD.NonNegativeInteger.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.NonNegativeInteger.html#compare/2","title":"RDF.XSD.NonNegativeInteger.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.NonNegativeInteger.html#datatype?/1","title":"RDF.XSD.NonNegativeInteger.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.NonNegativeInteger.html#equal_value?/2","title":"RDF.XSD.NonNegativeInteger.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.NonNegativeInteger.html#lexical/1","title":"RDF.XSD.NonNegativeInteger.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.NonNegativeInteger.html#new!/2","title":"RDF.XSD.NonNegativeInteger.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.NonNegativeInteger.html#new/2","title":"RDF.XSD.NonNegativeInteger.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.NonNegativeInteger.html#update/3","title":"RDF.XSD.NonNegativeInteger.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.NonNegativeInteger.html#valid?/1","title":"RDF.XSD.NonNegativeInteger.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.NonNegativeInteger.html#value/1","title":"RDF.XSD.NonNegativeInteger.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.NonNegativeInteger.html#t:invalid_value/0","title":"RDF.XSD.NonNegativeInteger.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.NonNegativeInteger.html#t:t/0","title":"RDF.XSD.NonNegativeInteger.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.NonNegativeInteger.html#t:valid_value/0","title":"RDF.XSD.NonNegativeInteger.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.NonNegativeInteger.html#t:value/0","title":"RDF.XSD.NonNegativeInteger.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.NonPositiveInteger.html","title":"RDF.XSD.NonPositiveInteger","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.NonPositiveInteger.html#canonical/1","title":"RDF.XSD.NonPositiveInteger.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.NonPositiveInteger.html#canonical_lexical/1","title":"RDF.XSD.NonPositiveInteger.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.NonPositiveInteger.html#canonical?/1","title":"RDF.XSD.NonPositiveInteger.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.NonPositiveInteger.html#cast/1","title":"RDF.XSD.NonPositiveInteger.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.NonPositiveInteger.html#compare/2","title":"RDF.XSD.NonPositiveInteger.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.NonPositiveInteger.html#datatype?/1","title":"RDF.XSD.NonPositiveInteger.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.NonPositiveInteger.html#equal_value?/2","title":"RDF.XSD.NonPositiveInteger.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.NonPositiveInteger.html#lexical/1","title":"RDF.XSD.NonPositiveInteger.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.NonPositiveInteger.html#new!/2","title":"RDF.XSD.NonPositiveInteger.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.NonPositiveInteger.html#new/2","title":"RDF.XSD.NonPositiveInteger.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.NonPositiveInteger.html#update/3","title":"RDF.XSD.NonPositiveInteger.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.NonPositiveInteger.html#valid?/1","title":"RDF.XSD.NonPositiveInteger.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.NonPositiveInteger.html#value/1","title":"RDF.XSD.NonPositiveInteger.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.NonPositiveInteger.html#t:invalid_value/0","title":"RDF.XSD.NonPositiveInteger.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.NonPositiveInteger.html#t:t/0","title":"RDF.XSD.NonPositiveInteger.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.NonPositiveInteger.html#t:valid_value/0","title":"RDF.XSD.NonPositiveInteger.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.NonPositiveInteger.html#t:value/0","title":"RDF.XSD.NonPositiveInteger.value/0","type":"type"},{"doc":"Collection of functions for numeric literals.","ref":"RDF.XSD.Numeric.html","title":"RDF.XSD.Numeric","type":"module"},{"doc":"Returns the absolute value of a numeric literal. If the given argument is not a numeric literal or a value which can be coerced into a numeric literal, nil is returned. see http://www.w3.org/TR/xpath-functions/#func-abs","ref":"RDF.XSD.Numeric.html#abs/1","title":"RDF.XSD.Numeric.abs/1","type":"function"},{"doc":"Adds two numeric literals. For xsd:float or xsd:double values, if one of the operands is a zero or a finite number and the other is INF or -INF, INF or -INF is returned. If both operands are INF, INF is returned. If both operands are -INF, -INF is returned. If one of the operands is INF and the other is -INF, NaN is returned. If one of the given arguments is not a numeric literal or a value which can be coerced into a numeric literal, nil is returned. see http://www.w3.org/TR/xpath-functions/#func-numeric-add","ref":"RDF.XSD.Numeric.html#add/2","title":"RDF.XSD.Numeric.add/2","type":"function"},{"doc":"Rounds a numeric literal upwards to a whole number literal. If the given argument is not a numeric literal or a value which can be coerced into a numeric literal, nil is returned. see http://www.w3.org/TR/xpath-functions/#func-ceil","ref":"RDF.XSD.Numeric.html#ceil/1","title":"RDF.XSD.Numeric.ceil/1","type":"function"},{"doc":"See RDF.Literal.Datatype.Registry.numeric_datatype?/1 .","ref":"RDF.XSD.Numeric.html#datatype?/1","title":"RDF.XSD.Numeric.datatype?/1","type":"function"},{"doc":"Divides two numeric literals. For xsd:float and xsd:double operands, floating point division is performed as specified in [IEEE 754-2008]. A positive number divided by positive zero returns INF. A negative number divided by positive zero returns -INF. Division by negative zero returns -INF and INF, respectively. Positive or negative zero divided by positive or negative zero returns NaN. Also, INF or -INF divided by INF or -INF returns NaN. If one of the given arguments is not a numeric literal or a value which can be coerced into a numeric literal, nil is returned. nil is also returned for xsd:decimal and xsd:integer operands, if the divisor is (positive or negative) zero. see http://www.w3.org/TR/xpath-functions/#func-numeric-divide","ref":"RDF.XSD.Numeric.html#divide/2","title":"RDF.XSD.Numeric.divide/2","type":"function"},{"doc":"Rounds a numeric literal downwards to a whole number literal. If the given argument is not a numeric literal or a value which can be coerced into a numeric literal, nil is returned. see http://www.w3.org/TR/xpath-functions/#func-floor","ref":"RDF.XSD.Numeric.html#floor/1","title":"RDF.XSD.Numeric.floor/1","type":"function"},{"doc":"Multiplies two numeric literals. For xsd:float or xsd:double values, if one of the operands is a zero and the other is an infinity, NaN is returned. If one of the operands is a non-zero number and the other is an infinity, an infinity with the appropriate sign is returned. If one of the given arguments is not a numeric literal or a value which can be coerced into a numeric literal, nil is returned. see http://www.w3.org/TR/xpath-functions/#func-numeric-multiply","ref":"RDF.XSD.Numeric.html#multiply/2","title":"RDF.XSD.Numeric.multiply/2","type":"function"},{"doc":"","ref":"RDF.XSD.Numeric.html#negative_zero?/1","title":"RDF.XSD.Numeric.negative_zero?/1","type":"function"},{"doc":"Rounds a value to a specified number of decimal places, rounding upwards if two such values are equally near. The function returns the nearest (that is, numerically closest) value to the given literal value that is a multiple of ten to the power of minus precision . If two such values are equally near (for example, if the fractional part in the literal value is exactly .5), the function returns the one that is closest to positive infinity. If the given argument is not a numeric literal or a value which can be coerced into a numeric literal, nil is returned. see http://www.w3.org/TR/xpath-functions/#func-round","ref":"RDF.XSD.Numeric.html#round/2","title":"RDF.XSD.Numeric.round/2","type":"function"},{"doc":"Subtracts two numeric literals. For xsd:float or xsd:double values, if one of the operands is a zero or a finite number and the other is INF or -INF, an infinity of the appropriate sign is returned. If both operands are INF or -INF, NaN is returned. If one of the operands is INF and the other is -INF, an infinity of the appropriate sign is returned. If one of the given arguments is not a numeric literal or a value which can be coerced into a numeric literal, nil is returned. see http://www.w3.org/TR/xpath-functions/#func-numeric-subtract","ref":"RDF.XSD.Numeric.html#subtract/2","title":"RDF.XSD.Numeric.subtract/2","type":"function"},{"doc":"","ref":"RDF.XSD.Numeric.html#zero?/1","title":"RDF.XSD.Numeric.zero?/1","type":"function"},{"doc":"","ref":"RDF.XSD.Numeric.html#t:t/0","title":"RDF.XSD.Numeric.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.PositiveInteger.html","title":"RDF.XSD.PositiveInteger","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.PositiveInteger.html#canonical/1","title":"RDF.XSD.PositiveInteger.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.PositiveInteger.html#canonical_lexical/1","title":"RDF.XSD.PositiveInteger.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.PositiveInteger.html#canonical?/1","title":"RDF.XSD.PositiveInteger.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.PositiveInteger.html#cast/1","title":"RDF.XSD.PositiveInteger.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.PositiveInteger.html#compare/2","title":"RDF.XSD.PositiveInteger.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.PositiveInteger.html#datatype?/1","title":"RDF.XSD.PositiveInteger.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.PositiveInteger.html#equal_value?/2","title":"RDF.XSD.PositiveInteger.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.PositiveInteger.html#lexical/1","title":"RDF.XSD.PositiveInteger.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.PositiveInteger.html#new!/2","title":"RDF.XSD.PositiveInteger.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.PositiveInteger.html#new/2","title":"RDF.XSD.PositiveInteger.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.PositiveInteger.html#update/3","title":"RDF.XSD.PositiveInteger.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.PositiveInteger.html#valid?/1","title":"RDF.XSD.PositiveInteger.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.PositiveInteger.html#value/1","title":"RDF.XSD.PositiveInteger.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.PositiveInteger.html#t:invalid_value/0","title":"RDF.XSD.PositiveInteger.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.PositiveInteger.html#t:t/0","title":"RDF.XSD.PositiveInteger.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.PositiveInteger.html#t:valid_value/0","title":"RDF.XSD.PositiveInteger.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.PositiveInteger.html#t:value/0","title":"RDF.XSD.PositiveInteger.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Short.html","title":"RDF.XSD.Short","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Short.html#canonical/1","title":"RDF.XSD.Short.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Short.html#canonical_lexical/1","title":"RDF.XSD.Short.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Short.html#canonical?/1","title":"RDF.XSD.Short.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Short.html#cast/1","title":"RDF.XSD.Short.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Short.html#compare/2","title":"RDF.XSD.Short.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Short.html#datatype?/1","title":"RDF.XSD.Short.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Short.html#equal_value?/2","title":"RDF.XSD.Short.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Short.html#lexical/1","title":"RDF.XSD.Short.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Short.html#new!/2","title":"RDF.XSD.Short.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Short.html#new/2","title":"RDF.XSD.Short.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Short.html#update/3","title":"RDF.XSD.Short.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Short.html#valid?/1","title":"RDF.XSD.Short.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Short.html#value/1","title":"RDF.XSD.Short.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Short.html#t:invalid_value/0","title":"RDF.XSD.Short.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Short.html#t:t/0","title":"RDF.XSD.Short.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Short.html#t:valid_value/0","title":"RDF.XSD.Short.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Short.html#t:value/0","title":"RDF.XSD.Short.value/0","type":"type"},{"doc":"RDF.XSD.Datatype for XSD strings.","ref":"RDF.XSD.String.html","title":"RDF.XSD.String","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.String.html#canonical/1","title":"RDF.XSD.String.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.String.html#canonical_lexical/1","title":"RDF.XSD.String.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.String.html#canonical?/1","title":"RDF.XSD.String.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.String.html#cast/1","title":"RDF.XSD.String.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.String.html#compare/2","title":"RDF.XSD.String.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.String.html#datatype?/1","title":"RDF.XSD.String.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.String.html#equal_value?/2","title":"RDF.XSD.String.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.String.html#lexical/1","title":"RDF.XSD.String.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.String.html#new!/2","title":"RDF.XSD.String.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.String.html#new/2","title":"RDF.XSD.String.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.String.html#update/3","title":"RDF.XSD.String.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.String.html#valid?/1","title":"RDF.XSD.String.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.String.html#value/1","title":"RDF.XSD.String.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.String.html#t:invalid_value/0","title":"RDF.XSD.String.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.String.html#t:t/0","title":"RDF.XSD.String.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.String.html#t:valid_value/0","title":"RDF.XSD.String.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.String.html#t:value/0","title":"RDF.XSD.String.value/0","type":"type"},{"doc":"RDF.XSD.Datatype for XSD times. Options: tz : this allows to specify a timezone which is not supported by Elixir's Time struct; note, that it will also overwrite an eventually already present timezone in an input lexical","ref":"RDF.XSD.Time.html","title":"RDF.XSD.Time","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.Time.html#canonical/1","title":"RDF.XSD.Time.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Time.html#canonical_lexical/1","title":"RDF.XSD.Time.canonical_lexical/1","type":"function"},{"doc":"Converts a time literal to a canonical string, preserving the zone information.","ref":"RDF.XSD.Time.html#canonical_lexical_with_zone/1","title":"RDF.XSD.Time.canonical_lexical_with_zone/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.Time.html#canonical?/1","title":"RDF.XSD.Time.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.Time.html#cast/1","title":"RDF.XSD.Time.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.Time.html#compare/2","title":"RDF.XSD.Time.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.Time.html#datatype?/1","title":"RDF.XSD.Time.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.Time.html#equal_value?/2","title":"RDF.XSD.Time.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.Time.html#lexical/1","title":"RDF.XSD.Time.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.Time.html#new!/2","title":"RDF.XSD.Time.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.Time.html#new/2","title":"RDF.XSD.Time.new/2","type":"function"},{"doc":"Extracts the timezone string from a RDF.XSD.Time value.","ref":"RDF.XSD.Time.html#tz/1","title":"RDF.XSD.Time.tz/1","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.Time.html#update/3","title":"RDF.XSD.Time.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.Time.html#valid?/1","title":"RDF.XSD.Time.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.Time.html#value/1","title":"RDF.XSD.Time.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.Time.html#t:invalid_value/0","title":"RDF.XSD.Time.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Time.html#t:t/0","title":"RDF.XSD.Time.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.Time.html#t:valid_value/0","title":"RDF.XSD.Time.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.Time.html#t:value/0","title":"RDF.XSD.Time.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedByte.html","title":"RDF.XSD.UnsignedByte","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedByte.html#canonical/1","title":"RDF.XSD.UnsignedByte.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedByte.html#canonical_lexical/1","title":"RDF.XSD.UnsignedByte.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.UnsignedByte.html#canonical?/1","title":"RDF.XSD.UnsignedByte.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.UnsignedByte.html#cast/1","title":"RDF.XSD.UnsignedByte.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.UnsignedByte.html#compare/2","title":"RDF.XSD.UnsignedByte.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.UnsignedByte.html#datatype?/1","title":"RDF.XSD.UnsignedByte.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.UnsignedByte.html#equal_value?/2","title":"RDF.XSD.UnsignedByte.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedByte.html#lexical/1","title":"RDF.XSD.UnsignedByte.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.UnsignedByte.html#new!/2","title":"RDF.XSD.UnsignedByte.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.UnsignedByte.html#new/2","title":"RDF.XSD.UnsignedByte.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.UnsignedByte.html#update/3","title":"RDF.XSD.UnsignedByte.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.UnsignedByte.html#valid?/1","title":"RDF.XSD.UnsignedByte.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.UnsignedByte.html#value/1","title":"RDF.XSD.UnsignedByte.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.UnsignedByte.html#t:invalid_value/0","title":"RDF.XSD.UnsignedByte.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedByte.html#t:t/0","title":"RDF.XSD.UnsignedByte.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedByte.html#t:valid_value/0","title":"RDF.XSD.UnsignedByte.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedByte.html#t:value/0","title":"RDF.XSD.UnsignedByte.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedInt.html","title":"RDF.XSD.UnsignedInt","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedInt.html#canonical/1","title":"RDF.XSD.UnsignedInt.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedInt.html#canonical_lexical/1","title":"RDF.XSD.UnsignedInt.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.UnsignedInt.html#canonical?/1","title":"RDF.XSD.UnsignedInt.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.UnsignedInt.html#cast/1","title":"RDF.XSD.UnsignedInt.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.UnsignedInt.html#compare/2","title":"RDF.XSD.UnsignedInt.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.UnsignedInt.html#datatype?/1","title":"RDF.XSD.UnsignedInt.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.UnsignedInt.html#equal_value?/2","title":"RDF.XSD.UnsignedInt.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedInt.html#lexical/1","title":"RDF.XSD.UnsignedInt.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.UnsignedInt.html#new!/2","title":"RDF.XSD.UnsignedInt.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.UnsignedInt.html#new/2","title":"RDF.XSD.UnsignedInt.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.UnsignedInt.html#update/3","title":"RDF.XSD.UnsignedInt.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.UnsignedInt.html#valid?/1","title":"RDF.XSD.UnsignedInt.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.UnsignedInt.html#value/1","title":"RDF.XSD.UnsignedInt.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.UnsignedInt.html#t:invalid_value/0","title":"RDF.XSD.UnsignedInt.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedInt.html#t:t/0","title":"RDF.XSD.UnsignedInt.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedInt.html#t:valid_value/0","title":"RDF.XSD.UnsignedInt.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedInt.html#t:value/0","title":"RDF.XSD.UnsignedInt.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedLong.html","title":"RDF.XSD.UnsignedLong","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedLong.html#canonical/1","title":"RDF.XSD.UnsignedLong.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedLong.html#canonical_lexical/1","title":"RDF.XSD.UnsignedLong.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.UnsignedLong.html#canonical?/1","title":"RDF.XSD.UnsignedLong.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.UnsignedLong.html#cast/1","title":"RDF.XSD.UnsignedLong.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.UnsignedLong.html#compare/2","title":"RDF.XSD.UnsignedLong.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.UnsignedLong.html#datatype?/1","title":"RDF.XSD.UnsignedLong.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.UnsignedLong.html#equal_value?/2","title":"RDF.XSD.UnsignedLong.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedLong.html#lexical/1","title":"RDF.XSD.UnsignedLong.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.UnsignedLong.html#new!/2","title":"RDF.XSD.UnsignedLong.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.UnsignedLong.html#new/2","title":"RDF.XSD.UnsignedLong.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.UnsignedLong.html#update/3","title":"RDF.XSD.UnsignedLong.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.UnsignedLong.html#valid?/1","title":"RDF.XSD.UnsignedLong.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.UnsignedLong.html#value/1","title":"RDF.XSD.UnsignedLong.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.UnsignedLong.html#t:invalid_value/0","title":"RDF.XSD.UnsignedLong.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedLong.html#t:t/0","title":"RDF.XSD.UnsignedLong.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedLong.html#t:valid_value/0","title":"RDF.XSD.UnsignedLong.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedLong.html#t:value/0","title":"RDF.XSD.UnsignedLong.value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedShort.html","title":"RDF.XSD.UnsignedShort","type":"module"},{"doc":"Produces the canonical representation of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedShort.html#canonical/1","title":"RDF.XSD.UnsignedShort.canonical/1","type":"function"},{"doc":"Returns the canonical lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedShort.html#canonical_lexical/1","title":"RDF.XSD.UnsignedShort.canonical_lexical/1","type":"function"},{"doc":"Determines if the lexical form of a RDF.Literal of this datatype is the canonical form.","ref":"RDF.XSD.UnsignedShort.html#canonical?/1","title":"RDF.XSD.UnsignedShort.canonical?/1","type":"function"},{"doc":"Casts a datatype literal of one type into a datatype literal of another type. Returns nil when the given arguments are not castable into this datatype or when the given argument is an invalid literal. Implementations define the casting for a given value with the RDF.Literal.Datatype.do_cast/1 callback.","ref":"RDF.XSD.UnsignedShort.html#cast/1","title":"RDF.XSD.UnsignedShort.cast/1","type":"function"},{"doc":"Compares two RDF.Literal s. If the first literal is greater than the second :gt is returned, if less than :lt is returned. If both literal are equal :eq is returned. If the literals can not be compared either nil is returned, when they generally can be compared due to their datatype, or :indeterminate is returned, when the order of the given values is not defined on only partially ordered datatypes.","ref":"RDF.XSD.UnsignedShort.html#compare/2","title":"RDF.XSD.UnsignedShort.compare/2","type":"function"},{"doc":"Checks if the given literal has datatype this or a datatype that is derived of it.","ref":"RDF.XSD.UnsignedShort.html#datatype?/1","title":"RDF.XSD.UnsignedShort.datatype?/1","type":"function"},{"doc":"Checks if two datatype literals are equal in terms of the values of their value space. Non- RDF.Literal s are tried to be coerced via RDF.Literal.coerce/1 before comparison. Returns nil when the given arguments are not comparable as literals of this datatype. Invalid literals are only considered equal in this relation when both have the exact same datatype and the same attributes (lexical form, language etc.). Implementations can customize this equivalence relation via the RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 and RDF.Literal.Datatype.do_equal_value_different_datatypes?/2 callbacks.","ref":"RDF.XSD.UnsignedShort.html#equal_value?/2","title":"RDF.XSD.UnsignedShort.equal_value?/2","type":"function"},{"doc":"Returns the lexical form of a RDF.Literal of this datatype.","ref":"RDF.XSD.UnsignedShort.html#lexical/1","title":"RDF.XSD.UnsignedShort.lexical/1","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value or fails when it is not valid.","ref":"RDF.XSD.UnsignedShort.html#new!/2","title":"RDF.XSD.UnsignedShort.new!/2","type":"function"},{"doc":"Creates a new RDF.Literal with this datatype and the given value .","ref":"RDF.XSD.UnsignedShort.html#new/2","title":"RDF.XSD.UnsignedShort.new/2","type":"function"},{"doc":"Updates the value of a RDF.Literal without changing everything else.","ref":"RDF.XSD.UnsignedShort.html#update/3","title":"RDF.XSD.UnsignedShort.update/3","type":"function"},{"doc":"Determines if a RDF.Literal of this or a derived datatype has a proper value of its value space.","ref":"RDF.XSD.UnsignedShort.html#valid?/1","title":"RDF.XSD.UnsignedShort.valid?/1","type":"function"},{"doc":"Returns the value of a RDF.Literal of this or a derived datatype.","ref":"RDF.XSD.UnsignedShort.html#value/1","title":"RDF.XSD.UnsignedShort.value/1","type":"function"},{"doc":"","ref":"RDF.XSD.UnsignedShort.html#t:invalid_value/0","title":"RDF.XSD.UnsignedShort.invalid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedShort.html#t:t/0","title":"RDF.XSD.UnsignedShort.t/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedShort.html#t:valid_value/0","title":"RDF.XSD.UnsignedShort.valid_value/0","type":"type"},{"doc":"","ref":"RDF.XSD.UnsignedShort.html#t:value/0","title":"RDF.XSD.UnsignedShort.value/0","type":"type"},{"doc":"","ref":"RDF.Graph.Builder.Error.html","title":"RDF.Graph.Builder.Error","type":"exception"},{"doc":"","ref":"RDF.Graph.EmptyDescriptionError.html","title":"RDF.Graph.EmptyDescriptionError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"RDF.Graph.EmptyDescriptionError.html#message/1","title":"RDF.Graph.EmptyDescriptionError.message/1","type":"function"},{"doc":"","ref":"RDF.IRI.InvalidError.html","title":"RDF.IRI.InvalidError","type":"exception"},{"doc":"","ref":"RDF.Literal.InvalidError.html","title":"RDF.Literal.InvalidError","type":"exception"},{"doc":"","ref":"RDF.Namespace.InvalidAliasError.html","title":"RDF.Namespace.InvalidAliasError","type":"exception"},{"doc":"","ref":"RDF.Namespace.InvalidTermError.html","title":"RDF.Namespace.InvalidTermError","type":"exception"},{"doc":"","ref":"RDF.Namespace.InvalidVocabBaseIRIError.html","title":"RDF.Namespace.InvalidVocabBaseIRIError","type":"exception"},{"doc":"","ref":"RDF.Namespace.UndefinedTermError.html","title":"RDF.Namespace.UndefinedTermError","type":"exception"},{"doc":"","ref":"RDF.Quad.InvalidGraphContextError.html","title":"RDF.Quad.InvalidGraphContextError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"RDF.Quad.InvalidGraphContextError.html#message/1","title":"RDF.Quad.InvalidGraphContextError.message/1","type":"function"},{"doc":"","ref":"RDF.Query.InvalidError.html","title":"RDF.Query.InvalidError","type":"exception"},{"doc":"","ref":"RDF.Resource.Generator.ConfigError.html","title":"RDF.Resource.Generator.ConfigError","type":"exception"},{"doc":"","ref":"RDF.Triple.InvalidPredicateError.html","title":"RDF.Triple.InvalidPredicateError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"RDF.Triple.InvalidPredicateError.html#message/1","title":"RDF.Triple.InvalidPredicateError.message/1","type":"function"},{"doc":"","ref":"RDF.Triple.InvalidSubjectError.html","title":"RDF.Triple.InvalidSubjectError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"RDF.Triple.InvalidSubjectError.html#message/1","title":"RDF.Triple.InvalidSubjectError.message/1","type":"function"},{"doc":"","ref":"RDF.XSD.Datatype.Mismatch.html","title":"RDF.XSD.Datatype.Mismatch","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"RDF.XSD.Datatype.Mismatch.html#message/1","title":"RDF.XSD.Datatype.Mismatch.message/1","type":"function"},{"doc":"All notable changes to this project will be documented in this file. This project adheres to Semantic Versioning and Keep a CHANGELOG .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This version introduces a new graph builder DSL. See the new guide for an introduction. Added a RDF.Graph builder DSL available under the RDF.Graph.build/2 function new RDF.Sigils ~i , ~b and ~l as variants of the ~I , ~B and ~L sigils, which support string interpolation RDF.Graph.new/2 and RDF.Graph.add/2 support the addition of RDF.Dataset s RDF.Description.empty?/1 , RDF.Graph.empty?/1 , RDF.Dataset.empty?/1 and RDF.Data.empty?/1 which are significantly faster than Enum.empty?/1 By replacing all Enum.empty?/1 uses over the RDF data structures with these new empty?/1 functions throughout the code base, several functions benefit from this performance improvement. RDF.Description.first/2 now has a RDF.Description.first/3 variant which supports a default value new guards in RDF.Guards : is_statement/1 and is_quad/1 RDF.PropertyMap.terms/1 and RDF.PropertyMap.iris/1 Changed RDF.Graph.description/2 is no longer an alias for RDF.Graph.get/2 , but has a different behaviour now: it will return an empty description when no description for the requested subject exists in the graph The inspect string of RDF.Description now includes the subject separately, so it can be seen also when the description is empty. Fixed When triples with an empty object list where added to an RDF.Graph , it included empty descriptions, which lead to inconsistent behaviour (for example it would be counted in RDF.Graph.subject_count/1 ). When an RDF.Graph contained empty descriptions these were rendered by the RDF.Turtle.Encoder to a subject without predicates and objects, i.e. invalid Turtle. This actually shouldn't happen and is either caused by misuse or a bug. So instead, a RDF.Graph.EmptyDescriptionError with a detailed message will be raised now when this case is detected. Compare v0.11.0...v0.12.0","ref":"changelog.html#0-12-0-2022-04-11","title":"Changelog - 0.12.0 - 2022-04-11","type":"extras"},{"doc":"The main feature of this version are the RDF.Resource.Generator s. For an introduction see this guide . Added RDF.Resource.Generator s which can be used to generate configurable ids :implicit_base option on the RDF.Turtle.Encoder :base_description option on the RDF.Turtle.Encoder several new types: RDF.Resource.t for all node identifiers, i.e. RDF.IRI s and RDF.BlankNode s RDF.Triple.coercible , RDF.Quad.coercible , RDF.Star.Triple.coercible and RDF.Star.Quad.coercible for tuples which can be coerced to the respective statements Changed some types were renamed for consistency reasons; the old types were deprecated and will be removed in v0.11 RDF.Statement.coercible_t -&gt; RDF.Statement.coercible RDF.Star.Statement.coercible_t -&gt; RDF.Star.Statement.coercible RDF.Triple.t_values -&gt; RDF.Triple.mapping_value RDF.Quad.t_values -&gt; RDF.Quad.mapping_value Fixed the interface of RDF.BlankNode.Generator.start_link/1 was fixed, so that generators can be started supervised Compare v0.10.0...v0.11.0","ref":"changelog.html#0-11-0-2022-03-22","title":"Changelog - 0.11.0 - 2022-03-22","type":"extras"},{"doc":"This release adds RDF-star support on the RDF data structures, the N-Triples, N-Quads, Turtle encoders and decoders and the BGP query engine. For an introduction read the new page on the RDF.ex guide . For more details on how to migrate from an earlier version read this wiki page . Elixir versions &lt; 1.10 are no longer supported Added Support for RDF.PropertyMap on RDF.Statement.new/2 and RDF.Statement.coerce/2 . RDF.Dataset.graph_count/1 The RDF.NQuads.Encoder now supports a :default_graph_name option, which allows to specify the graph name to be used as the default for triples from a RDF.Graph or RDF.Description . Changed The RDF.Turtle.Encoder no longer supports the encoding of RDF.Dataset s. You'll have to aggregate a RDF.Dataset to a RDF.Graph on your own now. The RDF.NQuads.Encoder now uses the RDF.Graph.name/1 as the graph name for the triples of a RDF.Graph . Previously the triples of an RDF.Graph were always encoded as part of default graph. You can use the new :default_graph_name option and set it to nil to get the old behaviour. Compare v0.9.4...v0.10.0","ref":"changelog.html#0-10-0-2021-12-13","title":"Changelog - 0.10.0 - 2021-12-13","type":"extras"},{"doc":"Added RDF.statement/1 , RDF.statement/3 and RDF.statement/4 constructor functions the :default_prefixes configuration option now allows to set a {mod, fun} tuple, with a function which should be called to determine the default prefixes the :default_base_iri configuration option now allows to set a {mod, fun} tuple, with a function which should be called to determine the default base IRI support for Elixir 1.12 and OTP 24 Fixed the Turtle encoder was encoding IRIs as prefixed names even when they were resulting in non-conform prefixed names the Turtle encoder didn't properly escape special characters in language-tagged literals the N-Triples and N-Quads encoders didn't properly escape special characters in both language-tagged and plain literals the Inspect protocol implementation for RDF.Diff was causing an error when both graphs had prefixes defined Note: In the canonical form of -0.0 in XSD doubles and floats the sign is removed in OTP versions &lt; 24 although this is not standard conform. This has the consequence that the sign of -0.0 is also removed when casting these doubles and floats to decimals. These bugs won't be fixed. If you rely on the correct behavior in these cases, you'll have to upgrade to OTP 24 and a respective Elixir version. Compare v0.9.3...v0.9.4","ref":"changelog.html#0-9-4-2021-05-26","title":"Changelog - 0.9.4 - 2021-05-26","type":"extras"},{"doc":"Added :indent option on RDF.Turtle.Encoder , which allows to specify the number of spaces the output should be indented Changed the performance of the Enumerable protocol implementations of the RDF data structures was significantly improved (for graphs almost 10x), which in turn increases the performance of all functions built on top of that, eg. the N-Triples and N-Quads encoders improvement of the Inspect forms of the RDF data structures: the content is now enclosed in angle brackets and indented Fixed strings of the form &quot;.0&quot; and &quot;0.&quot; weren't recognized as valid XSD float and double literals the Turtle encoder handles base URIs without a trailing slash or hash properly (no longer raising a warning and ignoring them) Compare v0.9.2...v0.9.3","ref":"changelog.html#0-9-3-2021-03-09","title":"Changelog - 0.9.3 - 2021-03-09","type":"extras"},{"doc":"Added RDF.XSD.Base64Binary datatype ( @pukkamustard ) Changed a new option :as_value to enforce interpretation of an input string as a value instead of a lexical, which is needed on datatypes where the lexical space and the value space both consist of strings RDF.XSD.Date and RDF.XSD.Time both can now be initialized with tuples of an Elixir Date resp. Time value and a timezone string (previously XSD date and time values with time zones could only be created from strings) Compare v0.9.1...v0.9.2","ref":"changelog.html#0-9-2-2021-01-06","title":"Changelog - 0.9.2 - 2021-01-06","type":"extras"},{"doc":"Elixir versions &lt; 1.9 are no longer supported Added general serialization functions for reading from and writing to streams and implementations for N-Triples and N-Quads (Turtle still to come) a :gzip option flag on all read_file/3 and write_file/3 functions allows to read and write all supported serialization formats from and to gzipped files (works also with the new possibility to read and write files via streams) RDF.Dataset.prefixes/1 for getting an aggregated RDF.PrefixMap over all graphs RDF.PrefixMap.put/3 for adding a prefix mapping and overwrite an existing one RDF.BlankNode.value/1 for getting the internal string representation of a blank node RDF.IRI.in_namespace?/2 for determining whether an IRI lies in a namespace Changed all read_file/3 and write_file/3 functions on RDF.Serialization and the modules of RDF serialization formats can use streaming via the :stream flag option; for read_file/3 and write_file/3 it defaults to false , while for read_file!/3 and write_file!/3 it defaults to true when the respective format supports streams the Inspect form of the RDF data structures are now Turtle-based and respect the usual :limit behaviour more compact Inspect form for RDF.PrefixMap the RDF.Turtle.Encoder accepts RDF.Vocabulary.Namespace modules as base the performance of the RDF.Turtle.Encoder was improved (by using a for most use cases more efficient method for resolving IRIs to prefixed names) RDF.BlankNode.new/0 creates integer-based blank nodes, which is much more efficient in terms of performance and memory consumption than the previous ref-based blank nodes Fixed RDF.BlankNode s based on refs weren't serializable to Turtle RDF.Vocabulary.Namespace s couldn't contain terms conflicting with functions from Elixirs Kernel module; most of them are supported now, while for the remaining unsupported ones a proper error message is produced during compilation Compare v0.9.0...v0.9.1","ref":"changelog.html#0-9-1-2020-11-16","title":"Changelog - 0.9.1 - 2020-11-16","type":"extras"},{"doc":"The API of the all three RDF datastructures RDF.Dataset , RDF.Graph and RDF.Description were changed, so that the functions taking input data consist only of one field in order to open the possibility of introducing options on these functions. The supported ways with which RDF statements can be passed to the RDF data structures were extended and unified to be supported across all functions accepting input data. This includes also the way in which patterns for BGP queries are specified. Also, the performance for adding data has been improved. For an introduction on the new data structure API and the commonly supported input formats read the updated page on the RDF data structures in the guide . For more details on how to migrate from an earlier version read this wiki page . Added RDF.PropertyMap which allow definition of atoms for RDF properties. Such property maps can be provided to all RDF data structure functions accepting input data and BGP query patterns with the :context opt, allowing the use of the atoms from the property map in the input data. on RDF.Description RDF.Description.subject/1 RDF.Description.change_subject/2 on RDF.Graph RDF.Graph.name/1 RDF.Graph.change_name/2 RDF.Graph.base_iri/1 RDF.Graph.prefixes/1 RDF.Graph.put_properties/3 on RDF.Dataset RDF.Dataset.name/1 RDF.Dataset.change_name/2 RDF.Dataset.put_properties/3 RDF.IRI.append/2 Changed the format for the specification of BGP queries with RDF.Graph.query/2 , RDF.Graph.query_stream/2 and RDF.Query.bgp/1 has been changed to be consistent with the supported formats for input data in the rest of the library RDF.Description.new now requires the subject to be passed always as first argument; if you want to add some initial data this must be done with the :init option The put/3 functions on RDF.Graph and RDF.Dataset now overwrite all statements with same subject. Previously only statements with the same subject AND predicate were overwritten, which was probably not the expected behaviour, since it's not inline with the common put semantics in Elixir. A function with the previous behaviour was added on RDF.Graph and RDF.Dataset with the put_properties/3 function. CAUTION: This means the RDF.Graph.put/2 and RDF.Dataset.put/2 function have become more destructive now when not specified otherwise. Note: Although one could argue, that following this route RDF.Dataset.put/3 would consequently have to overwrite whole graphs, this was not implemented for practical reasons. It's probably not what's wanted in most cases. The Access protocol implementation of get_and_update/3 on RDF.Graph and RDF.Dataset previously relied on the put/2 functions with the old behaviour of overwriting only statements with the same subject and predicate, which was almost never the expected behaviour. This is fixed now by relying on the new put/2 behaviour. the values/2 functions of RDF.Statement , RDF.Triple , RDF.Quad , RDF.Description , RDF.Graph and RDF.Dataset now accept on their second argument an optional RDF.PropertyMap which will be used to map predicates accordingly; the variant of these values/2 functions to provide a custom mapping function was extracted into a new function map/2 on all of these modules for consistency reasons the internal :id struct field of RDF.BlankNode was renamed to :value allow the base_iri of RDF.Vocabulary.Namespace s to end with a . to support vocabularies which use dots in the IRIs for further structuring (eg. CIM-based formats like CGMES) RDF.Triple.new/1 now also accepts four-element tuples and simple ignores fourth element RDF.Quad.new/1 now also accepts three-element tuples and simple assumes the fourth element to be nil Fixed the put functions on RDF.Description , RDF.Graph and RDF.Dataset didn't add all statements properly under certain circumstances RDF.Graph.put/2 ignores empty descriptions; this should be the final piece to ensure that RDF.Graph s never contain empty descriptions, which would distort results of functions like RDF.Graph.subjects/1 , RDF.Graph.subject_count/1 , RDF.Graph.descriptions/1 Compare v0.8.2...v0.9.0","ref":"changelog.html#0-9-0-2020-10-13","title":"Changelog - 0.9.0 - 2020-10-13","type":"extras"},{"doc":"Added the Turtle encoder can now produce partial Turtle documents with the :only option and any combination of the following values: :triples , :directives , :base , :prefixes the style of the Turtle directives produced by the Turtle encoder can be switched to SPARQL style with the option :directive_style and the value :sparql the most common conflict resolution strategies on RDF.PrefixMap.merge/3 can now be chosen directly with the atoms :ignore and :overwrite RDF.PrefixMap.prefixed_name/2 to convert an IRI to a prefixed name RDF.PrefixMap.prefixed_name_to_iri/2 to convert a prefixed name to an IRI Changed when serializing a RDF.Dataset with the Turtle encoder the prefixes of all of its graphs are used now Fixed adding an empty RDF.Description with a subject to an empty RDF.Graph resulted in an invalid non-empty graph ( @pukkamustard ) Compare v0.8.1...v0.8.2","ref":"changelog.html#0-8-2-2020-09-21","title":"Changelog - 0.8.2 - 2020-09-21","type":"extras"},{"doc":"Added query functions for basic graph pattern matching (incl. streaming-support) Compare v0.8.0...v0.8.1","ref":"changelog.html#0-8-1-2020-06-16","title":"Changelog - 0.8.1 - 2020-06-16","type":"extras"},{"doc":"RDF literals and their datatypes were completely redesigned to support derived XSD datatypes and allow for defining custom datatypes. For an introduction on how literals work now read the updated page on literals in the guide . For more details on how to migrate from an earlier version read this wiki page . Elixir versions &lt; 1.8 are no longer supported Added a lot of new datatypes like xsd:float , xsd:byte or xsd:anyURI -- all numeric XSD datatypes are now available; see this page of the API documentation for an up-to-date list of all supported and missing XSD datatypes an implementation of XSD facet system now makes it easy to define own custom datatypes via restriction of the existing XSD datatypes RDF.Literal.update/2 updates the value of a RDF.Literal without changing anything else, eg. the language or datatype Changed the RDF.Literal struct now consists entirely of a datatype-specific structs in the literal field, which besides being more memory-efficient (since literals no longer consist of all possible fields a literal might have), allows pattern matching now on the datatype of literals. RDF XSD datatypes are now defined in the RDF.XSD namespace alias constructor functions for the XSD datatypes are now defined on RDF.XSD matches? , less_than? , greater_than as higher level functions were removed from the RDF.Literal.Datatype modules less_than? , greater_than? now always return a boolean and no longer nil when incomparable; you can still determine if two terms are comparable by checking if compare/2 returns nil the language option is not supported on the RDF.XSD.String.new/2 constructor the language option on RDF.Literal.new/2 is no longer ignored if it's empty ( nil or &quot;&quot; ), so this either produces an invalid RDF.LangString now or, if another datatype is provided will fail with an ArgumentError canonical now performs implicit coercions when passed plain Elixir values the inspect format for literals was changed and is now much more informative and uniform, since you now always see the value, the lexical form and if the literal is valid RDF.Namespace.resolve_term/1 now returns ok or error tuples, but a new function RDF.Namespace.resolve_term!/1 with the old behaviour was added Fixed numeric operations on invalid numeric literals no longer fail, but return nil instead Datetimes preserve the original lexical form of the timezone when casting from a date BEAM error warnings when trying to use top-level modules as vocabulary terms Compare v0.7.1...v0.8.0","ref":"changelog.html#0-8-0-2020-06-01","title":"Changelog - 0.8.0 - 2020-06-01","type":"extras"},{"doc":"Added proper typespecs so that Dialyzer passes without warnings ( @rustra ) Fixed RDF.XSD.Time didn't handle 24h overflows with an offset correctly Compare v0.7.0...v0.7.1","ref":"changelog.html#0-7-1-2020-03-11","title":"Changelog - 0.7.1 - 2020-03-11","type":"extras"},{"doc":"Added RDF.Diff data structure for diffs between RDF graphs and descriptions RDF.Description.update/4 updates the objects of a predicate in a description with a custom update function RDF.Graph.update/4 updates the descriptions of a subject in a graph with a custom update function RDF.Description.take/2 creates a description from another one by limiting its statements to a set of predicates RDF.Graph.take/3 creates a graph from another one by limiting its statements to a set of subjects and optionally also a set of predicates RDF.Graph.clear/1 removes the triples from a graph Mix formatter configuration for using defvocab without parens Changed RDF.Serialization.Writer.write_file/4 which is the basis used by all the write_file/3 and write_file!/3 functions of all serialization format modules like RDF.NTriples , RDF.Turtle , JSON.LD etc. now opens file in a different mode: it no longer opens them with the :utf8 option . First, this by default slowed down the writing, but more importantly could lead to unexpected encoding issues. This is a breaking change : If your code relied on this file mode, you can get the old behaviour, by specifying the file_mode on these functions accordingly as [:utf8, :write, :exclusive] . For example, to write a Turtle file with the old behaviour, you can do it like this: RDF.Turtle . write_file! ( some_data , some_path , file_mode : ~w[utf8 write exclusive]a ) Compare v0.6.2...v0.7.0","ref":"changelog.html#0-7-0-2019-11-22","title":"Changelog - 0.7.0 - 2019-11-22","type":"extras"},{"doc":"Added field base_iri on RDF.Graph structure which can be set via new base_iri option on RDF.Graph.new or the new functions RDF.Graph.set_base_iri/2 and RDF.Graph.clear_base_iri/1 RDF.Graph.clear_metadata/1 which clears the base IRI and the prefixes RDF.IRI.coerce_base/1 which coerces base IRIs; as opposed to RDF.IRI.new/1 it also accepts bare RDF.Vocabulary.Namespace modules Changed RDF.Turtle.Decoder saves the base IRI in the RDF.Graph now RDF.Turtle.Encoder now takes the base IRI to be used during serialization in the following order of precedence: from the base option or its new alias base_iri from the base_iri field of the given graph from the RDF.default_base_iri returning the one from the application configuration RDF.PrefixMap.new and RDF.PrefixMap.add now also accepts terms from RDF.Vocabulary.Namespace s as namespaces Fixed Vocabulary namespace modules weren't always detected properly Compare v0.6.1...v0.6.2","ref":"changelog.html#0-6-2-2019-09-08","title":"Changelog - 0.6.2 - 2019-09-08","type":"extras"},{"doc":"Added RDF.IRI.to_string/1 returns the string representation of an RDF.IRI (implicitly resolving vocabulary namespace terms) RDF.Literal.matches?/3 for XQuery regex pattern matching RDF.Decimal.digit_count/1 and RDF.Decimal.fraction_digit_count/1 for determining the number of digits of decimal literals Fixed language literals were not properly unescaped during Turtle parsing RDF.Literal.new/1 can take decimals and infers the datatype xsd:decimal correctly true and false with capital letters are no longer valid RDF.Boolean s following the XSD specification; the same applies for booleans in Turtle +INF is no longer a valid RDF.Double (positive infinity doesn't expect a sign) slightly improve output of errors during parsing of Turtle, N-Triples and N-Quads Compare v0.6.0...v0.6.1","ref":"changelog.html#0-6-1-2019-07-15","title":"Changelog - 0.6.1 - 2019-07-15","type":"extras"},{"doc":"see here for upgrading notes to RDF.ex 0.6 Added RDF.PrefixMap prefix management of RDF.Graph s: the structure now has a prefixes field with an optional RDF.PrefixMap new functions add_prefixes/2 , delete_prefixes/2 and clear_prefixes/1 configurable RDF.default_prefixes RDF.Description.equal?/2 , RDF.Graph.equal?/2 , RDF.Dataset.equal?/2 and RDF.Data.equal?/2 Changed the constructor functions for RDF.Graph s and RDF.Dataset s now take the graph name resp. dataset name through a name option, instead of the first argument RDF.Graph.new supports an additional prefixes argument to initialize the prefixes field when RDF.Graph.add and RDF.Graph.put are called with another graph, its prefixes are merged RDF.Turtle.Decoder saves the prefixes now RDF.Turtle.Encoder now takes the prefixes to be serialized in the following order of precedence: from the prefixes option (as before) from the prefixes field of the given graph from the RDF.default_prefixes drop support for OTP &lt; 20, since prefixes can consist of UTF characters which are not supported in atoms on these versions Compare v0.5.4...v0.6.0","ref":"changelog.html#0-6-0-2019-04-06","title":"Changelog - 0.6.0 - 2019-04-06","type":"extras"},{"doc":"Fixed issue with Elixir 1.8 RDF.write_file and RDF.write_file! delegators had wrong signatures Compare v0.5.3...v0.5.4","ref":"changelog.html#0-5-4-2019-01-17","title":"Changelog - 0.5.4 - 2019-01-17","type":"extras"},{"doc":"Added RDF.Triple.valid?/1 , RDF.Quad.valid?/1 and RDF.Statement.valid?/1 , which validate if a tuple is a valid RDF triple or RDF quad Compare v0.5.2...v0.5.3","ref":"changelog.html#0-5-3-2018-11-11","title":"Changelog - 0.5.3 - 2018-11-11","type":"extras"},{"doc":"Added RDF.Term.value/1 returning the native Elixir value of a RDF term RDF.Statement.values/1 , RDF.Triple.values/1 and RDF.Quad.values/1 returning a tuple of RDF.Term.value/1 converted native Elixir values from a tuple of RDF terms RDF.Description.values/1 , RDF.Graph.values/1 , RDF.Dataset.values/1 and RDF.Data.values/1 returning a map of RDF.Term.value/1 converted native Elixir values from the respective structure of RDF terms for all of aforementioned values/1 functions a variant values/2 which allows to specify custom mapping function to be applied when creating the resp. structure RDF.Literal.compare/2 , RDF.Literal.less_than?/2 and RDF.Literal.greater_than?/2 for RDF.Datatype aware comparisons of RDF.Literal s Fixed RDF.DateTime.equal_value?/2 and RDF.Date.equal_value?/2 did not handle timezones correctly -00:00 is a valid timezone offset on RDF.DateTime Compare v0.5.1...v0.5.2","ref":"changelog.html#0-5-2-2018-11-04","title":"Changelog - 0.5.2 - 2018-11-04","type":"extras"},{"doc":"Fixed generated Erlang output files of Leex and Yecc are excluded from Hex package Compare v0.5.0...v0.5.1","ref":"changelog.html#0-5-1-2018-09-17","title":"Changelog - 0.5.1 - 2018-09-17","type":"extras"},{"doc":"Elixir versions &lt; 1.6 are no longer supported Added Possibility to execute simple SPARQL queries against RDF.Graph s with SPARQL 0.2 New RDF.Term protocol implemented for all structs representing RDF nodes and all native Elixir datatypes which are coercible to those modules. For now, it mainly offers, besides the coercion, just the function RDF.Term.equal?/2 and RDF.Term.equal_value?/2 for term- and value comparisons. New RDF.Decimal datatype for xsd:decimal literals and support for decimal literals in Turtle encoder RDF.Numeric module with a list of all numeric datatypes and shared functions for all numeric literals, eg. arithmetic functions Various new RDF.Datatype function RDF.Datatype.cast/1 for casting between RDF.Literal s as specified in the XSD spec on all RDF.Datatype s logical operators and the Effective Boolean Value (EBV) coercion algorithm from the XPath and SPARQL specs on RDF.Boolean various functions on the RDF.DateTime and RDF.Time datatypes RDF.LangString.match_language?/2 Many new convenience functions on the top-level RDF module constructors for all of the supported RDF.Datatype s constant functions RDF.true and RDF.false for the two boolean RDF.Literal values RDF.Literal.Guards which allow pattern matching of common literal datatypes RDF.BlankNode.Generator Possibility to configure an application-specific default base IRI; for now it is used only on reading of RDF serializations (when no base specified) Changed RDF.String.new/2 and RDF.String.new!/2 produce a rdf:langString when given a language tag Some of the defined structs now enforce keys on compile-time (via Elixirs @enforce_keys feature) when not setting the corresponding fields would lead to invalid structs, namely the following fields: RDF.IRI.value RDF.BlankNode.id RDF.Description.subject RDF.List.head Fixed RDF.resource?/1 does not fail anymore when called with unresolvable atoms but returns false instead RDF.IRI.absolute/2 does not fail with a FunctionClauseError when the given base is not absolute, but returns nil instead RDF.DateTime and RDF.Time store microseconds RDF.DateTime : '24:00:00' is a valid time in a xsd:dateTime; the dateTime value so represented is the first instant of the following day RDF.LangString : non-strings or the empty string as language produce invalid literals Compare v0.4.1...v0.5.0","ref":"changelog.html#0-5-0-2018-09-17","title":"Changelog - 0.5.0 - 2018-09-17","type":"extras"},{"doc":"Added RDF.Literal.new!/2 which fails when creating an invalid literal Changed RDF.Literal.new/2 can create rdf:langString literals without failing, they are simply invalid; if you want to fail without a language tag use the new RDF.Literal.new!/2 function Compare v0.4.0...v0.4.1","ref":"changelog.html#0-4-1-2018-03-19","title":"Changelog - 0.4.1 - 2018-03-19","type":"extras"},{"doc":"Changed renamed RDF.Serialization behaviour to RDF.Serialization.Format ; the new RDF.Serialization module contains just simple RDF serialization related functions renamed RDF.Serialization.Format function content_type/0 to media_type/0 moved RDF.Reader and RDF.Writer into RDF.Serialization module removed the limitation to serialization formats defined in the core RDF.ex package for use as a source of RDF.Vocabulary.Namespace s; so you can now also define vocabulary namespaces from JSON-LD files for example, provided that the corresponding Hex package is defined as a dependency Added RDF.Serialization.Format s define a name atom all RDF.Serialization.Reader and RDF.Serialization.Writer functions are now available on the RDF.Serialization module (or aliased on the top-level RDF module) and the format can be specified instead of a RDF.Serialization.Format argument, via the format or media_type option or in case of *_file functions, without explicit specification of the format, but inferred from file name extension instead; see the updated README section about RDF serializations the following functions to access available RDF.Serialization.Format s: RDF.Serialization.formats/0 RDF.Serialization.available_formats/0 RDF.Serialization.format/1 RDF.Serialization.format_by_media_type/1 RDF.Serialization.format_by_extension/1 Compare v0.3.1...v0.4.0","ref":"changelog.html#0-4-0-2018-03-10","title":"Changelog - 0.4.0 - 2018-03-10","type":"extras"},{"doc":"Added Collectable implementations for all RDF.Data structures so they can be used as destinations of Enum.into and for comprehensions Fixed Fix unescape_map in parse_helper for Elixir 1.6 ( @ajkeys ) Compare v0.3.0...v0.3.1","ref":"changelog.html#0-3-1-2018-01-19","title":"Changelog - 0.3.1 - 2018-01-19","type":"extras"},{"doc":"Added RDF.IRI as a more suitable URI/IRI representation for RDF, bringing enormous performance and memory consumption benefits (see here for the details about the improvements) Changed use RDF.IRI instead of Elixirs URI everywhere use the term iri instead of uri consistently, leading to the following function renamings: base_iri instead of base_uri for the definition of RDF.Vocabulary.Namespace s __base_iri__ instead of __base_uri__ in all RDF.Vocabulary.Namespace s __iris__ instead of __uris__ in all RDF.Vocabulary.Namespace s RDF.IRI.InvalidError instead of RDF.InvalidURIError RDF.Literal.InvalidError instead of RDF.InvalidLiteralError RDF.Namespace.InvalidVocabBaseIRIError instead of RDF.Namespace.InvalidVocabBaseURIError show compilation message of vocabulary namespaces always to be able to relate resp. errors and warnings Fixed when trying to resolve a term from an undefined module a RDF.Namespace.UndefinedTermError exception Compare v0.2.0...v0.3.0","ref":"changelog.html#0-3-0-2017-08-24","title":"Changelog - 0.3.0 - 2017-08-24","type":"extras"},{"doc":"Elixir versions &lt; 1.4 are no longer supported Added full Turtle support RDF.List structure for the representation of RDF lists describes?/1 on RDF.Data protocol and all RDF data structures which checks if statements about a given resource exist RDF.Data.descriptions/1 which returns all descriptions within a RDF data structure RDF.Description.first/2 which returns a single object to a predicate of a RDF.Description RDF.Description.objects/2 now supports a custom filter function RDF.bnode?/1 which checks if the given value is a blank node Changed Rename RDF.Statement.convert* functions to RDF.Statement.coerce* Fixed RDF.uri/1 and URI parsing of N-Triples and N-Quads decoders preserve empty fragments booleans weren't recognized as coercible literals on object positions N-Triples and N-Quads decoder didn't handle escaping properly Compare v0.1.1...v0.2.0","ref":"changelog.html#0-2-0-2017-08-12","title":"Changelog - 0.2.0 - 2017-08-12","type":"extras"},{"doc":"Fixed Add src directory to package files. Compare v0.1.0...v0.1.1","ref":"changelog.html#0-1-1-2017-06-25","title":"Changelog - 0.1.1 - 2017-06-25","type":"extras"},{"doc":"Initial release Note: This version is not usable, since the src directory is not part of the package, which has been immediately fixed on version 0.1.1.","ref":"changelog.html#0-1-0-2017-06-25","title":"Changelog - 0.1.0 - 2017-06-25","type":"extras"}]